/****************************************************************************
 *
 * arch/arm/mach-cactus/bd_cnxt.c
 *
 * Copyright (C) 2004 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 ****************************************************************************/
/* $Header $
 ****************************************************************************/

/******************/
/* Include Files  */
/******************/
#include <linux/config.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/tty.h>
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/cpufreq.h>
#include <linux/list.h>
#include <linux/timer.h>

#include <asm/hardware.h>
#include <asm/setup.h>
#include <asm/page.h>
#include <asm/pgtable.h>
#include <asm/irq.h>
#include <asm/mach-types.h>

#include <asm/mach/arch.h>

#include "board.h"

/********************************************/
/*  Local defines                           */
/********************************************/
#define ISA_NO_WAIT_STATES              0
#define ISA_WAIT_UNTIL_READY_0          2
#define ISA_WAIT_UNTIL_READY_1          3

/*************************/
/* ISA Descriptor Values */
/*************************/
/* The ISA_XXX_CARD_INDEX definitions in board.h refer to the   */
/* indicies of the elements in the ISADevices[] array and must  */
/* be maintained together.                                      */

#define ISA_CHIP_SELECT_4  4

ISA_DEVICE ISADevices[] =
{   
    /****************************************************************************/
    /* Bronco / Electra Sidecar / CS8900A ethernet / IO mode                    */
    /****************************************************************************/  
    {
        0,      /* Is it clocked.               */
       	0,      /* XOEMask for each board       */
        ISA_CHIP_SELECT_4,   /* ChipSelect                   */
        4,      /* Descriptor number - determines base address. */
        ISA_WAIT_UNTIL_READY_1,  /* Ext wait    */
        IO,     /* Use IO control signals.      */
        OFF,    /* IOReg signal is not used.    */
        500,    /* Write access time (ns).      */
        500,    /* Read access time (ns).       */
        0,      /* IOReg setup time (ns).       */
        0,      /* IOReg access time (ns).      */
        100,    /* Chip select setup time (ns). */
        100,    /* Chip select hold time (ns).  */
        200,    /* Control setup time (ns).     */
        100,    /* Control hold time (ns).      */
    },


    /**************************/
    /* Internal ATA Subsystem */   
    /**************************/

    /*    Uses ISA descriptor 6     */

    /*
     * The internal ATA subsystem uses one primary and one secondary ISA
     * descriptor.  The setup is done in ConfigATA().  This uses ISA
     * descriptor 6.  DO NOT USE ISA DESCRIPTOR 6 FOR ANYTHING ELSE!!!
     *
     */

};

int iNumISADevices = sizeof(ISADevices)/sizeof(ISA_DEVICE);

/****************************************************************************
 * Modifications:
 * $Log$
 *
 ****************************************************************************/

