/****************************************************************************/ 
 /*                   CONEXANT PROPRIETARY AND CONFIDENTIAL                  */
 /*                       SOFTWARE FILE/MODULE HEADER                        */
 /*                    Conexant Systems Inc. (c) 2004-2007                   */
 /*                         All Rights Reserved                              */
 /****************************************************************************/
 /*
  * Filename: board.h
  *
  * Description: Board hardware definition.
  *
  * Author: Tim Ross
  *
  ****************************************************************************/
 /* $Id$
  ****************************************************************************/ 

#ifndef _BOARD_H
#define _BOARD_H

/*****************/
/* Include Files */
/*****************/

/***********************/
/* Function Prototypes */
/***********************/

/**********************/
/* Local Definitions  */
/**********************/
typedef volatile unsigned char *LPREGB;
typedef volatile unsigned short *LPREGH;

/******************/
/* Register Bases */
/******************/
#define ROM_BASE     0xF0000000
#define PCI_IO_BASE  0xE1000000
#define PCI_MEM_BASE 0x80000000

/***********************************/
/* Board Type Specific Definitions */
/***********************************/

typedef struct _BOARD_TYPES
{
  unsigned char        BoardID;            /* Board Identifier                      */
  unsigned char        DeviceConfigIndex;  /* Index into ISA_DEVICE internal arrays */
} BOARD_TYPES, *LPBOARD_TYPES;

#define MAX_DEVICE_CONFIGS  4

/* Definitions of actual board and vendor IDs are to be */
/* found in HWCONFIG.H                                  */

/***************/
/* ISA Devices */
/***************/
typedef struct _ISA_DEVICE  {
    int        bClocked;
    int        XOEMask;
    unsigned char      ChipSelect;
    unsigned char      DescNum;
    unsigned char      ExtWait;
    unsigned char      IOMemory;
    unsigned char      IORegMode;
    unsigned short     WriteAccessTime;
    unsigned short     ReadAccessTime;
    unsigned short     IORegSetupTime;
    unsigned short     IORegAccessTime;
    unsigned short     CSSetupTime;
    unsigned short     CSHoldTime;
    unsigned short     CtrlSetupTime;
    unsigned short     CtrlHoldTime;
    unsigned char      ISAIncr;
    unsigned char      Width;

} ISA_DEVICE, *LPISA_DEVICE;

/***************/
/* PCI Devices */
/***************/
#define PCCARD_PCI_DEVICE_NUM   1
#define PCI_ID_TI_1210          0xac1a104c
#define PCI_ID_TI_1211          0xac1e104c
#define PCI_ID_ACCES_COM2S      0x10d0494f

/* PCI - PCCard Bridge configuration.  */
#define PCCARD_BRIDGE_REG_BASE  0x40000000
#define PCCARD_BRIDGE_IO_BASE   0xfeec
#define PCCARD_LATENCY          0x20
#define CARDBUS_BUS_NUM         1
#define CARDBUS_SUB_BUS_NUM     0
#define CARDBUS_LATENCY         0x40

/*****************/
/* PCCard Bridge */
/*****************/
#define PCCARD_EXCA_BASE        (PCCARD_BRIDGE_REG_BASE + 0x800)
#define PCCARD_EXCA_IO_BASE     (PIO_BASE + PCCARD_BRIDGE_IO_BASE)

#endif

/****************************************************************************
 * Modifications:
 * $Log$
 *
 ****************************************************************************/ 

