/*
 *  linux/arch/arm/mm/proc-syms.c
 *
 *  Copyright (C) 2000-2002 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <linux/module.h>
#include <linux/mm.h>

#include <asm/cacheflush.h>
#include <asm/proc-fns.h>
#include <asm/tlbflush.h>
#include <asm/page.h>
#include <asm/cache.h>

#ifndef MULTI_CPU
EXPORT_SYMBOL(cpu_dcache_clean_area);
EXPORT_SYMBOL(cpu_set_pte);
 /* Added by Conexant */

#if (defined(CONFIG_ARCH_PECOS) || defined(CONFIG_ARCH_NEVIS) || defined(CONFIG_ARCH_PECOS_256M))
extern void v6_dma_inv_range (void *start_addr, void *end_addr);
extern void v6_dma_clean_range (void *start_addr, void *end_addr, int flags);
extern void v6_dma_flush_range (void *start_addr, void *end_addr, int flags);

EXPORT_SYMBOL(v6_dma_inv_range);
EXPORT_SYMBOL(v6_dma_clean_range);
EXPORT_SYMBOL(v6_dma_flush_range);
#endif
#ifdef CONFIG_OUTER_CACHE
EXPORT_SYMBOL(l220_inv_all);
EXPORT_SYMBOL(l220_clean_all);
EXPORT_SYMBOL(l220_flush_all);
EXPORT_SYMBOL(l220_flush_range);
EXPORT_SYMBOL(l220_clean_range);
EXPORT_SYMBOL(l220_inv_range);
#endif

#ifdef CONFIG_ARCH_CACTUS
extern void arm920_dma_inv_range (void *start_addr, void *end_addr);
extern void arm920_flush_user_cache_range (void *start_addr, void *end_addr, int flags);

EXPORT_SYMBOL(arm920_dma_inv_range);
EXPORT_SYMBOL(arm920_flush_user_cache_range);
#endif

#else
EXPORT_SYMBOL(processor);
#endif

#ifndef MULTI_CACHE
EXPORT_SYMBOL(__cpuc_flush_kern_all);
EXPORT_SYMBOL(__cpuc_flush_user_all);
EXPORT_SYMBOL(__cpuc_flush_user_range);
EXPORT_SYMBOL(__cpuc_coherent_kern_range);
#else
EXPORT_SYMBOL(cpu_cache);
#endif

#ifndef MULTI_USER
EXPORT_SYMBOL(__cpu_clear_user_page);
EXPORT_SYMBOL(__cpu_copy_user_page);
#else
EXPORT_SYMBOL(cpu_user);
#endif

/*
 * No module should need to touch the TLB (and currently
 * no modules do.  We export this for "loadkernel" support
 * (booting a new kernel from within a running kernel.)
 */
#ifdef MULTI_TLB
EXPORT_SYMBOL(cpu_tlb);
#endif
