/*
 * cnxt_udc0.c -- for Pecos/Nevis Rev B later usb device controller 0  udc0; 
 * Copyright (C) 2008 Conexant systems.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 */


#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/delay.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/device.h>
#include <linux/usb_ch9.h>
#include <linux/usb_gadget.h>
#include <asm/cacheflush.h>
#include <linux/platform_device.h>
#include "./tdi/devapi.h"
#include <linux/kthread.h>
#include "./tdi/usbprv_dev.h"
#include <linux/fs.h>
#include <linux/file.h>
#include <linux/syscalls.h>
#include <asm/uaccess.h>
#include <asm/unistd.h>
#include <linux/dirent.h>
#include <linux/namei.h>
#include <linux/security.h>

#include "udc-cnxt.h"
#ifdef	CONFIG_CNXT_USB_PLUGFEST
#include <linux/proc_fs.h>
#endif


#include <asm/arch/hardware.h>
/* #include <asm/arch/hardware/usb.h> */

#define USB2_MAX_PACKET_SIZE 64
#define USB2_NUM_ENDPOINTS 6/* 8  */

#define xprintk(level,fmt,args...) \
	printk(level "%s: " fmt , driver_name , \
## args)



#ifdef DEBUG_ENUMERATION
#define DBG_ENUMERATION(fmt,args...) \
xprintk(KERN_ALERT  , fmt , ## args)
#else 
#define DBG_ENUMERATION(fmt,args...) \
do { } while (0)
#endif /* DEBUG */

 /* NOTE : On the variable direction used accross the code.
 * direction = 0, implies receive from host to device;
 * direction = 1, implies send from device to host;
*/

#define USB_DEV_PRINT(x...)   
#define printk_spl(x...)		

#ifdef USB_TASKLET
void *usb_TrCompleteTasklet;
#endif

#ifdef CONFIG_USB_CNXT_OTG	
	struct otg_transceiver	*transceiver;
#endif

#ifdef USB_PROP_FILE_OP

unsigned char in_512[64];
unsigned int flag_transfer = 0;
unsigned int read_file_open_flag = 0 , read_file_close_flag =0;
unsigned int read_file_ptr = 0 , read_curr_fcnt = 0 ,IsEOF=0;
unsigned int read_stream = 0 ;

char file_name[64] = "/test/1.ts"; 
//extern long sys_stat(char __user * filename, struct __old_kernel_stat __user * statbuf);

#endif


//senthil  Setup Polled mode

struct task_struct *SetupBuffer_ReadThread = NULL , *OUT_SCSI_CMD_READ_THREAD = NULL;



static const char driver_name [] = "cnxt_udc0";

struct vusbhs_req
{
	struct usb_request    req;
	struct list_head    queue;
};

struct vusbhs_ep
{
	struct usb_ep          ep;
	struct list_head       queue;
	char                   ep_name[14];
	u16                    maxpacket;
	u8                     bEndpointAddress;
	u8                     bmAttributes;
	struct vusbhs_udc      *udc;
};

struct vusbhs_udc
{
	struct              usb_gadget gadget;
	struct              usb_gadget_driver *gadget_driver;
	struct              vusbhs_ep ep[USB2_NUM_ENDPOINTS];
	_usb_device_handle  handle;
	spinlock_t          lock;
};

static struct vusbhs_udc *udc;

struct usbblock {
	int irq;
	u32 base_addr;
};

/* syncs-up zero-len packets and setup packets for setup transactions */
unsigned char setup_state;

/* Keeps track of enqueue count in ep0 */
int ep0_cnt;

//senthil
u32 out_flag=0 ,out_sync_flag=0 ,write_10 = 0;
u32 first_out=1,readwriteflag=0,activestatus_flag=0 ,big_flag=0 ,write_once_flag=0;
u32 disable_printks=0;


#ifdef BULK_IN

unsigned char inquiry_in[INQUIRY_CMD_LEN_MAX]= { 0x00,0x80,0x02,0x02,0x1F,0x00,0x00,0x00,0x4A,0x65,0x74,0x46,0x6C,0x61,0x73,0x68,0x54,0x53,0x34,0x47,0x4A,0x46,0x56,0x31,0x30,0x20,0x20,0x20,0x20,0x22,0x20,0x20,0x20,0x2E,0x30,0x30};
unsigned char read_format_capacity_in[READ_FORMAT_CAP_CMD_LEN_MAX]= { 0x00,0x00,0x00,0x08,0x00,0x78,0x60,0x00,0x02,0x00,0x02,0x00};
unsigned char read_capacity_in[READ_CAP_CMD_LEN_MAX]= { 0x00,0x7A,0xFF,0xFE,0x00,0x00,0x02,0x00};
unsigned char read_10_in[240 * 512] ,write_10_out[240 * 512];
unsigned char tur[1],zero_buf[1];
unsigned char request_sense[18]= { 0x70,0x00,0x05,0x00,0x00,0x00,0x00,0x0A,0x00,0x00,0x00,0x00,0x24,0x00,0x00,0x00,0x00,0x00};


volatile unsigned char  status[13] , status_prev_medium[13];
volatile unsigned char scsi_cmd[512];
unsigned int tag,signature;

#endif

#ifdef USB_PROP_FILE_OP

#define  LIST_STREAMS   0xAB
#define  CP_STREAM_FROM_STB 0xCD
#define  CP_STREAM_TO_STB  0xEF


unsigned char  prop_cmd[8];
unsigned char read_buff[64] , read_buff_cnt=0;
unsigned char read_finfo_buff[64];
unsigned int file_cnt = 0,ts_count = 50;
int fd ;


#endif

int in_scsi_cnt=0 , out_payload_cnt=0 , out_scsi_cmd_ioc_cnt=0 ,out_scsi_cmd_ioc_f_cnt =0 ,out_payload_ioc_cnt=0;


/* Interrupt handler provided by tdi */
extern void _usb_dci_vusb20_isr(void* arg);
static void nuke(struct vusbhs_ep *ep, int status);
static void done(struct vusbhs_ep *ep, struct vusbhs_req *req, int status);
static int handleClearFeature(_usb_device_handle handle, struct usb_ctrlrequest *setup_ptr);

/* Intializes VUSB HS 2.0 controller */
int usb_initTdi(void);


#if 0
void  dump_enplist()
{
	unsigned int *x;

	x = (unsigned int *)USB_ENPLISTADDR_REG;
        printk("USB_ENPLISTADDR_REG = 0x%08x\n",*x);

}
#endif

void dci_regs_dump(void)
{

	unsigned int *x;
    

    x = (unsigned int *)USB_CAP_LEN;
        printk("CAPLENGTH = 0x%02x\n", *(unsigned short *)x);

    x = (unsigned int *)USB_DCI_VER;
        printk("USB_DCI_VER = 0x%02x\n",*(unsigned short *)x);

    //x = (unsigned int *)USB_HSCPARM;
    //    printk("HCSPARAMS = 0x%02x\n", *(unsigned short *)x);

    x = (unsigned int *)USB_DCCPARM;
        printk("USB_DCCPARM = 0x%02x\n", *(unsigned short *)x);

    x = (unsigned int *)USB_CMD_REG;
        printk("USBCMD = 0x%08x\n",*x);

    x = (unsigned int *)USB_STS_REG;
        printk("USBSTS = 0x%08x\n",*x);

    x = (unsigned int *)USB_INE_REG;
        printk("USBINTR = 0x%08x\n",*x);

    x = (unsigned int *)USB_FRI_REG;
        printk("FRINDEX = 0x%08x\n",*x);

    x = (unsigned int *)USB_CTL_SEG;
        printk("CTRLDSEGMENT = 0x%08x\n",*x);

    x = (unsigned int *)USB_DEVADDR_REG;
        printk("USB_DEVADDR_REG = 0x%08x\n",*x);

    x = (unsigned int *)USB_ENPLISTADDR_REG;
        printk("USB_ENPLISTADDR_REG = 0x%08x\n",*x);

    x = (unsigned int *)USB_TTL_REG;
        printk("TTCTRL = 0x%08x\n",*x);

    x = (unsigned int *)USB_BUR_REG;
        printk("BURSTSIZE = 0x%08x\n",*x);

	
	x = (unsigned int *)USB_ENPNAK_REG;
        printk("USB_ENPNAK_REG = 0x%08x\n",*x);


	x = (unsigned int *)USB_ENPNAK_EN_REG;
        printk("USB_ENPNAK_EN_REG = 0x%08x\n",*x);



    x = (unsigned int *)USB_COF_REG;
        printk("USB_COF_REG = 0x%08x\n",*x);

    x = (unsigned int *)USB_PST_REG;
        printk("USB_PST_REG = 0x%08x\n",*x);

	
	x = (unsigned int *)USB_OTGSC_REG;
        printk("USB_OTGSC_REG = 0x%08x\n",*x);	

    x = (unsigned int *)USB_USM_REG;
        printk("USBMODE = 0x%08x\n",*x);

	x = (unsigned int *)USB_ENPTSETUPSTAT_REG;
        printk("USB_ENPTSETUPSTAT_REG = 0x%08x\n",*x);

	x = (unsigned int *)USB_ENPTPRIME_REG;
        printk("USB_ENPTPRIME_REG = 0x%08x\n",*x);

	
	x = (unsigned int *)USB_ENPTFLUSH_REG;
        printk("USB_ENPTFLUSH_REG = 0x%08x\n",*x);


	x = (unsigned int *)USB_ENPTSTAT_REG;
        printk("USB_ENPTSTAT_REG = 0x%08x\n",*x);

		
	x = (unsigned int *)USB_ENPTCOMPLETE_REG;
        printk("USB_ENPTCOMPLETE_REG = 0x%08x\n",*x);


	x = (unsigned int *)USB_ENPTCTRL0_REG;
        printk("USB_ENPTCTRL0_REG = 0x%08x\n",*x);

	x = (unsigned int *)USB_ENPTCTRL1_REG;
        printk("USB_ENPTCTRL1_REG = 0x%08x\n",*x);

	x = (unsigned int *)USB_ENPTCTRL2_REG;
        printk("USB_ENPTCTRL2_REG = 0x%08x\n",*x);

	x = (unsigned int *)USB_ENPTCTRL3_REG;
        printk("USB_ENPTCTRL3_REG = 0x%08x\n",*x);


}




/* Local irq Handler */
static irqreturn_t 
usb_udc_irq(int irq, void *dev_id, struct pt_regs *regs)
{
	
	_usb_dci_vusb20_isr((void*) NULL);
	return IRQ_HANDLED;
}

unsigned char 
get_ep_num(const char *ep_name)
{
	if (strcmp(ep_name,"ep0") == 0)
		return 0;
	else if (strcmp(ep_name,"ep2out-bulk") == 0)
		return 2;
	else if (strcmp(ep_name,"ep3in-bulk") == 0)
		return 3;
	else if (strcmp(ep_name,"ep1in-int") == 0)
		return 1;
	else
		return -EPERM;
}

#ifdef PLUGFEST

unsigned int init_out_once = 0 ,init_in_once = 0;

#define MAX_FILE_READ_CNT  6

#endif



int get_dir(char *dir );

/* Endpoint Operations */
static int 
vusbhs_ep_enable(struct usb_ep *_ep, const struct usb_endpoint_descriptor *desc)
{
	unsigned char ep_num = 0;
	ep_num = get_ep_num(_ep->name);
	
	USB_DEV_PRINT(KERN_INFO "vusbhs_ep_enable called\n");
	USB_DEV_PRINT(KERN_INFO "ep_num :: %d\n",ep_num);
	USB_DEV_PRINT(KERN_INFO "mxp :: %d\n",desc->wMaxPacketSize);
	USB_DEV_PRINT(KERN_INFO "direction %x, type :: %x\n",
		((desc->bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 0 : 1,
		desc->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK);

  //MAY28th 


	//MAY29th Senthil Added

	if (ep_num == 0)
		ep_num=3; //Just Hardcode the value

#ifdef DEBUG_2
	printk("vusbhs_ep_enable called\n");
	printk("ep_num :: %d\n",ep_num);
	printk("mxp :: %d\n",desc->wMaxPacketSize);
	printk("direction %x, type :: %x\n",
		((desc->bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 0 : 1,
		desc->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK);
#endif


	

	/* we have to keep trying to init the endpoint...if it fails 
	* and we don't retry then we may not be able to unplug and 
	* replug the USB cable properly. 
	*/
	while(_usb_device_init_endpoint ( udc->handle,
		ep_num,
		desc->wMaxPacketSize,
		((desc->bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 1 : 0,
		desc->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK,(ep_num==1)?1:0) ){
		_usb_device_cancel_transfer ( udc->handle, ep_num, 
			((desc->bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 1 : 0 );
	}
#ifdef PLUGFEST
	if( (ep_num == 2) )
	{
		
		if(!init_out_once)
		{
			  printk(" Programmed OUT revieve command from usb pc host just once *******\n");
					_usb_device_recv_data(udc->handle, 2, prop_cmd, 8); /* Set the recieve command */
					init_out_once=1;
		}
	}

	if( (ep_num == 3) )
	{

	
		if(!init_in_once)
		{
			  printk(" Programmed IN revieve just once ********\n");
			  get_dir("/test");

			  file_cnt = MAX_FILE_READ_CNT + 2;
			  printk(" file_cnt %d \n",file_cnt);

		//	read_file("/test/1.ts",read_buff,64); 
			_usb_device_send_data(udc->handle,3,(u8 *)((u32)read_buff & 0xfffff000) ,64,(u32)read_buff & 0x00000fff);
			init_in_once=1;
			 read_stream = 1;


		}
	}



#endif


	return 0;
}

static int 
vusbhs_ep_disable(struct usb_ep *_ep)
{
	struct vusbhs_ep  *ep = container_of(_ep, struct vusbhs_ep, ep);
	unsigned char ep_num = 0;
	unsigned long flags;
	
	USB_DEV_PRINT(KERN_INFO "vusbhs_ep_disable called\n");
	
	ep_num = get_ep_num(_ep->name);
	
	spin_lock_irqsave(&ep->udc->lock, flags);
	nuke (ep, -ESHUTDOWN);
	spin_unlock_irqrestore(&ep->udc->lock, flags);
	
	USB_DEV_PRINT(KERN_INFO "ep_num :: %d\n",ep_num);
	return 0;
}


static struct usb_request *
vusbhs_alloc_request(struct usb_ep *ep, gfp_t gfp_flags)
{
	struct vusbhs_req* req;
	
	USB_DEV_PRINT(KERN_INFO "%s\n",__FUNCTION__);
	req = kmalloc(sizeof *req, gfp_flags);
	
	if (req) {
		memset (req, 0, sizeof *req);
		req->req.dma = 0;
		INIT_LIST_HEAD (&req->queue);
	}
	
	return &req->req;
}

static void
vusbhs_free_request(struct usb_ep *ep, struct usb_request *_req)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_free_request called\n");
	if (_req)
		kfree (_req);
}

static void *
vusbhs_alloc_buffer(struct usb_ep  *_ep, unsigned  bytes, dma_addr_t  *dma,gfp_t gfp_flags)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_alloc_buffer called\n");
	return kmalloc(bytes, gfp_flags);
}


static void 
vusbhs_free_buffer(struct usb_ep *_ep,	void *buf, dma_addr_t dma, unsigned  bytes
				   )
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_free_buffer called\n");
	if(buf == NULL) return;
	kfree (buf);
}


/* dequeue ALL requests; caller holds udc->lock */
static void 
nuke(struct vusbhs_ep *ep, int status)
{
	struct vusbhs_req *req;
	
	while (!list_empty(&ep->queue)) {
		req = list_entry(ep->queue.next, struct vusbhs_req, queue);
		done(ep, req, status);
	}
}

static void
done(struct vusbhs_ep *ep, struct vusbhs_req *req, int status)
{
	list_del_init(&req->queue);
	
	if (req->req.status == -EINPROGRESS)
		req->req.status = status;
	else
		status = req->req.status;
	
	req->req.actual = req->req.length;
	
	if (status && status != -ESHUTDOWN)
	{
		printk_spl("complete %s req %p stat %d len %u/%u\n",
			ep->ep.name, &req->req, status,
			req->req.actual, req->req.length);
	}
	
	spin_unlock(&ep->udc->lock);
	req->req.complete(&ep->ep, &req->req);
	spin_lock(&ep->udc->lock);
}
//bookmark
static int
vusbhs_ep_queue(struct usb_ep *_ep, struct usb_request *_req, gfp_t gfp_flags)
{
	
	unsigned char ep_num = 0;
	u8 ret_val = 0;
	struct vusbhs_udc *udc;
	struct vusbhs_ep  *ep = container_of(_ep, struct vusbhs_ep, ep);
	struct vusbhs_req *req = container_of(_req, struct vusbhs_req, req);
	unsigned long flags;
	
	ep_num = get_ep_num(_ep->name);

#ifdef DEBUG_2
	printk(" vusbhs_ep_queue IN  ep_num=%d \n",ep_num);
#endif

	
	if(readwriteflag)
		printk(" vusbhs_ep_queue IN  ep_num=%d \n",ep_num);
#if 0
	//Senthil Added Do Nothing
	if(out_flag && (ep_num == 0))
		return; 

#endif
	
	/* catch various bogus parameters */
	if (!_req || !req->req.complete || !req->req.buf) {
		printk_spl("%s: ep %d, bad params\n", __FUNCTION__, ep_num);
		return -EINVAL;
	}
	
	if (!_ep ) {
		printk_spl("%s, bad ep, _ep=%p, ep->bEndpointAddress: %x\n", __FUNCTION__, _ep, ep->bEndpointAddress);
		return -EINVAL;
	}
	
	udc = ep->udc;
	
	/* Filling usb request status to be used by completion handler*/
	spin_lock_irqsave(&udc->lock, flags);
	req->req.status = -EINPROGRESS;
	req->req.actual = 0;
	
	if ( req->req.buf )
	{
		if(strcmp(ep->ep.name, "ep2out-bulk") == 0){
#ifdef DEBUG_2
			printk(" ep2out-bulk \n");
#endif

//			return ; //do Nothing June9th
			ret_val= _usb_device_recv_data( udc->handle, 
				get_ep_num(ep->ep.name), 
				(unsigned char *)req->req.buf, 
				req->req.length); 
			if (ret_val != USB_OK){
				printk_spl("%s: Rx error,%d \n", __FUNCTION__, ep_num);
			}
		}
		else if (strcmp(ep->ep.name, "ep3in-bulk") == 0)
		{
			USB_DEV_PRINT("Tx packet params complete %p!! buffer: %p, len :%d\n", 
				req->req.complete, req->req.buf, req->req.length);
			printk("Tx packet params complete %p!! buffer: %p, len :%d\n", 
				req->req.complete, req->req.buf, req->req.length);
			ret_val = _usb_device_send_data(udc->handle, 
				ep_num, 
				(u8 *)((u32)req->req.buf & 0xfffff000), 
				req->req.length, 
				(u32)req->req.buf & 0x00000fff);
			if (ret_val != USB_OK){
				printk_spl("%s: Transmission error,%d \n", __FUNCTION__, ep_num);
				printk("%s: Transmission error,%d \n", __FUNCTION__, ep_num);
			}
		}
		else 
		{
          		if(ep_num == 0){
				/* Keep track of ep0 enqueue count */
				//	if(ep0_cnt == 1){
				//		printk("twice queueing up in ep0\n");
				//	}
					ep0_cnt++;
				}
				
				ret_val = _usb_device_send_data(udc->handle, ep_num,
					(u8 *)((u32)req->req.buf & 0xfffff000), req->req.length, 
					(u32)req->req.buf & 0x00000fff);
				
				if (ret_val != USB_OK){
					printk_spl("%s: Transmission error %d, \n", __FUNCTION__, ep_num);
				}
		}
	}
	
	if (req != 0){
		/* If ep0 enqueue cnt is more than one, skip adding the req buf as this 
		   will corrupt the list since only one req buf is used for ep0 */

		if((ep_num==0)&&(ep0_cnt>1))
			goto done;		
		list_add_tail(&req->queue, &ep->queue);
	}
done:
	spin_unlock_irqrestore(&udc->lock, flags);
	return 0;
}

u32 out_scsi_cmd_cnt=0;

static int 
vusbhs_ep_dequeue(struct usb_ep *_ep, struct usb_request *_req)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_ep_dequeue called\n");
	printk(KERN_INFO "vusbhs_ep_dequeue called out_scsi_cmd_cnt=%d in_scsi_cnt=%d  out_payload_cnt=%d  out_scsi_cmd_ioc_cnt=%d out_scsi_cmd_ioc_f_cnt=%d \n",out_scsi_cmd_cnt ,in_scsi_cnt ,out_payload_cnt ,out_scsi_cmd_ioc_cnt ,out_scsi_cmd_ioc_f_cnt);
	return 0;
}


static int 
vusbhs_ep_set_halt(struct usb_ep *_ep, int value)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_ep_set_halt called\n");
	return 0;
}

/* Gadget Operations */
static int 
vusbhs_get_frame(struct usb_gadget *gadget)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_get_frame called\n");
	return 0;
}

static int 
vusbhs_wakeup(struct usb_gadget *gadget)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_wakeup called\n");
	return 0;
}

static int
vusbhs_set_selfpowered(struct usb_gadget *gadget, int is_selfpowered)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_set_selfpowered called\n");
	return 0;
}

static int 
vusbhs_vbus_session(struct usb_gadget *gadget, int is_active)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_vbus_session called\n");
	return 0;
}

static int 
vusbhs_vbus_draw(struct usb_gadget *gadget, unsigned mA)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_vbus_draw called\n");
	return 0;
}


static int 
vusbhs_pullup(struct usb_gadget *gadget, int is_on)
{
	USB_DEV_PRINT(KERN_INFO "vusbhs_pullup called\n");
	return 0;
}

static struct usb_ep_ops vusbhs_ep_ops = {
	.enable    = vusbhs_ep_enable,
	.disable  = vusbhs_ep_disable,
		
	.alloc_request  = vusbhs_alloc_request,
	.free_request  = vusbhs_free_request,
	
	.alloc_buffer  = vusbhs_alloc_buffer,
	.free_buffer  = vusbhs_free_buffer,
		
	.queue    = vusbhs_ep_queue,
	.dequeue  = vusbhs_ep_dequeue,
		
	.set_halt  = vusbhs_ep_set_halt,
	// fifo_status ... report bytes in fifo
	// fifo_flush ... flush fifo
};


static struct usb_gadget_ops vusbhs_gadget_ops = {
	.get_frame    = vusbhs_get_frame,
	.wakeup      = vusbhs_wakeup,
	.set_selfpowered  = vusbhs_set_selfpowered,
	.vbus_session    = vusbhs_vbus_session,
	.vbus_draw    = vusbhs_vbus_draw,
	.pullup      = vusbhs_pullup,
};


#define PIO_OUT_TIMEOUT (jiffies + HZ/3)


static unsigned 
ep_setup(char *name, u8 addr, u8 type, unsigned buf, unsigned maxp, int dbuf)
{
	struct vusbhs_ep  *ep;
	u8 temp;

	
	temp = addr & 0xf;

	/* OUT endpoints first, then IN */
	ep = &udc->ep[addr & 0xf];
	if (addr & USB_DIR_IN)
		ep += 4;
	
	/* next endpoint's buffer starts after this one's */
	USB_DEV_PRINT("name %s, ep->name %s\n",name,ep->name);
	buf += maxp;
	
	/* set up driver data structures */
	if(strlen(name) < 14 )
		strlcpy(ep->ep_name, name, 14);
	else
		return 0;
	INIT_LIST_HEAD(&ep->queue);
	ep->udc = udc;
	ep->bEndpointAddress = addr;
	ep->bmAttributes = type;
	
	ep->ep.name = ep->ep_name;
	ep->ep.ops = &vusbhs_ep_ops; 
	ep->ep.maxpacket =  maxp;
	
	list_add_tail (&ep->ep.ep_list, &udc->gadget.ep_list);
	
	return buf;
}


int
usb_gadget_unregister_driver (struct usb_gadget_driver *driver)
{

	return 0;

}


#if 0

int Poll_Out_sync(void *data)
{

	_usb_device_handle   handle;

	handle = (_usb_device_handle)data;


    while (1)
	{
		
		if(out_sync_flag)
		{
			printk(" Send OUT (SCSI CMD) \n");
			_usb_device_recv_data(handle, 2, scsi_cmd, 512);
			out_sync_flag = 0;
		}
	}



//	printk(" Inside  Poll_Out_sync  thread  handle =%x \n",handle);

}

#endif


#if 0

uchar buff[8];

extern VUSB20_EP_QUEUE_HEAD_STRUCT_PTR ep_queue_head_ptr_thread;
extern int Activate_Thread;
extern uchar     buffer_thread;

int Poll_SetupBuffer(void *data)
{
	
	unsigned int j=0,i;

	while(1)
	{
		
	   if(Activate_Thread)
	   {

		printk("Poll value:");
		for(i=0; i <8; i++)
        {
              *(buff + i) = ep_queue_head_ptr_thread->SETUP_BUFFER[i];
			   printk("  %d:%d  \t ",i,buff[i]);
		      
			   //if(buffer_ptr[i] == 0xF)
			//		flag=1;
			  
        }

		printk("\n");


	   }
		

	}
}
#endif


#ifdef USB_PROP_FILE_OP

unsigned char read_buf[64];

#endif

#if 1


struct getdents_callback64 {
    struct linux_dirent64 __user * current_dir;
    struct linux_dirent64 __user * previous;
    int count;
    int error;
};

#define ROUND_UP64(x) (((x)+sizeof(u64)-1) & ~(sizeof(u64)-1))
#define NAME_OFFSET(de) ((int) ((de)->d_name - (char *) (de)))


static int inm_filldir(void * __buf, const char * name,
                       int namlen, loff_t offset,
                       ino_t ino, unsigned int d_type)
{
    struct linux_dirent64 __user *dirent;
    struct getdents_callback64 * buf = (struct getdents_callback64 *)
        __buf;
    int reclen = ROUND_UP64(NAME_OFFSET(dirent) + namlen + 1);

    buf->error = -EINVAL;   /* only used if we fail.. */
    if (reclen > buf->count)
        return -EINVAL;

    dirent = buf->previous;
    dirent = buf->current_dir;
    dirent->d_ino = ino;
    dirent->d_off = 0;
    dirent->d_reclen = reclen;
    dirent->d_type = d_type;
    strcpy(dirent->d_name, name);
    dirent->d_name[namlen]='\0';
    buf->previous = dirent;
    dirent = (struct linux_dirent64 *)(((char *)dirent) + reclen);
    buf->current_dir = dirent;
    buf->count -= reclen;

    return 0;
/*
  efault:
  buf->error = -EFAULT;
  return -EFAULT;
*/
}
#endif

#define MAX_STRING 256;

unsigned char list_streams[256];
unsigned int no_count=0,prev_str_count=0;



int get_dir(char *dir )  { /* ,  int (*inm_entry_callback)(char *fname)) { */
    char *rbuf = NULL;
     struct getdents_callback64 buffer;
    struct linux_dirent64 *dirent = NULL;
    long d_size = 0;
    long _err = 0;
    int i=0;
	unsigned int str_count =0  /*,  j=0  */;



	printk(" get_dir IN  \n");

    rbuf = (char *) kmalloc(PAGE_SIZE, GFP_KERNEL);
    memset(&buffer, 0, sizeof(struct getdents_callback64));
    memset(rbuf, 0, PAGE_SIZE);
    _err = PTR_ERR(rbuf);
    if (!IS_ERR(rbuf)) {
        struct file *f = NULL;
        struct nameidata nd;

        _err = path_lookup(dir,(LOOKUP_DIRECTORY | LOOKUP_OPEN),
                           &nd);
        if (_err)
		{
			printk("get_dir: path_lookup error \n");
            goto out;

		}
	/* 	printk(" path_lookup success nd = %x \n",nd);  */

        f = dentry_open(dget(nd.dentry), nd.mnt, O_RDONLY);
        _err = PTR_ERR(f);
        if (IS_ERR(f)) {
            //err("failed to open");
			printk("get_dir: dentry_open error \n");
            goto out;
        }
		
		printk("get_dir: dentry_open  success \n");
        d_size = f->f_dentry->d_inode->i_size;
        dirent = (struct linux_dirent64 *) rbuf;
        buffer.current_dir = dirent;
        buffer.previous = NULL;
        buffer.count = PAGE_SIZE;

	/* 	printk("get_dir d_size=%d f->f_pos = %d f=%x \n", d_size , f->f_pos,f);  */

#if 1
        while (f->f_pos <= d_size) {

			printk(" get_dir  vfs_readdir IN \n");
            _err = vfs_readdir(f, (filldir_t) inm_filldir, &buffer);
            for (i=0; i<PAGE_SIZE - buffer.count;
                 i+=dirent->d_reclen,
                     dirent = (struct linux_dirent64 *)
                     ((char *) dirent + dirent->d_reclen)){

					 str_count=0;
#if 0
                if (inm_entry_callback)
                    inm_entry_callback(dirent->d_name);
#endif
				printk(" Directory: %s no_count=%d  str_count=%d \n",dirent->d_name ,no_count ,str_count);
				file_cnt++;

				
				
				

				
#if 1
				while ( dirent->d_name [str_count] != '\0')
				{
					list_streams[prev_str_count] = dirent->d_name [str_count];
					str_count++;
					prev_str_count++;

				}
				list_streams[prev_str_count] = '\0';
				prev_str_count++;
				
			
				
				
#endif


            }

            if (_err < 0)
                break;

            _err = -ENOENT;
            /* setup for next iteration */
            memset(rbuf, 0, PAGE_SIZE);
            dirent = (struct linux_dirent64 *) rbuf;
            buffer.current_dir = dirent;
            buffer.previous = NULL;
            buffer.count = PAGE_SIZE;
        }

		
#endif
        path_release(&nd);
        kfree(rbuf);

        if (f)
            fput(f);
    }

out:
	
    return 0;
} /* READING DIRECTORY CONTENTS - CODE : END */


int callback_fn(char *fname)
{

	return 0;

}


int flt_read_file (void *hdl, void *buffer, uint64_t offset, uint32_t length,
		   uint32_t *bytes_read)
{
    struct file *fp;
    ssize_t read;
    mm_segment_t fs;

    fp = (struct file *) hdl;

    if (bytes_read != NULL)
	*bytes_read = 0;

    fs = get_fs ();
    set_fs (KERNEL_DS);

    read = fp->f_op->read (fp, (char *) buffer, length, (loff_t *) & offset);

    set_fs (fs);

    if (bytes_read != NULL)
	*bytes_read = 0;

    if (read <= 0)
    {
	return 0;
    }

    if (bytes_read != NULL)
	*bytes_read = read;

    return 1;
}

int flt_write_file (void *hdl, void *buffer, unsigned long long offset, 
		    unsigned int length, unsigned int *bytes_written)
{
    struct file *fp;
    ssize_t NrWritten;
    mm_segment_t fs;

    fp = (struct file *) hdl;

    fs = get_fs ();
    set_fs (KERNEL_DS);

    fp->f_pos = offset;
    NrWritten =
	fp->f_op->write (fp, (char *) buffer, length, (loff_t *) & offset);
    fp->f_pos = offset;

    set_fs (fs);

    if (bytes_written != NULL)
	*bytes_written = 0;

    if (NrWritten <= 0)
    {
	//dbg("write failed with error 0x%x", (int32_t) NrWritten);
	  printk("write failed with error 0x%x", (int32_t) NrWritten);


	return 0;
    }

    if (bytes_written != NULL)
	*bytes_written = NrWritten;

    return 1;
}



void flt_close_file (void *hdl)
{
   // INM_BUG_ON (hdl == NULL);

    filp_close ((struct file *) hdl, NULL);
}

int flt_open_file (const char *fname, unsigned int mode, void **hdl)
{
    struct file *fp = NULL;
    mm_segment_t fs;
    int err = 1; 
  
    *hdl = NULL;

	printk(" flt_open_file IN \n");

    fs = get_fs ();
    set_fs (KERNEL_DS);

    fp = filp_open (fname, mode, 0777);
    if (IS_ERR (fp))
    {
	//dbg ("Not able to open %s", fname);
/* 	printk("flt_open_file: Not able to open %s errorcode=%x ", fname ,fp);  */
	err = 0;
	goto filp_open_failed;
    }

	
    if ((!fp->f_op->write) || !(fp->f_op->read))
    {
//	dbg ("No write found for the fild id %p", fp);

	printk("flt_open_file: No write found for the fild id %p", fp);
	err = 0;
	goto fop_not_found;
    }

	/* printk(" flt_open_file fp=%x f_op=%x \n",fp,fp->f_op); */
//	fp->f_op->flush(fp,0);
//	fp->f_op->fsync(fp,NULL,0);


    *hdl = (void *) fp;
    set_fs (fs);




/* 	printk(" flt_open_file SUCCESS fp = %x \n",fp);  */

    return 1;

fop_not_found:
    filp_close (fp, NULL);
filp_open_failed:
    set_fs (fs);

    return err;
}


unsigned char total_file_string_size[64];
unsigned char recv_stream[256];
unsigned int recv_stream_file_open = 0;


void handle_prop_cmd(_usb_device_handle  handle)
{

	/* unsigned int cnt=0; */
	//struct stat64 stat_buf;
	struct stat stat_buf;
	int fd1;
	char *filename;
	

	printk("handle_prop_cmd  prop_cmd[2] = %x \n",prop_cmd[2]);

	switch(prop_cmd[2])
	{
		
		case LIST_STREAMS:
		
			disable_printks = 1;

			get_dir("/test");
#if 0
			for(; cnt < 64; cnt++)
			{
				printk("  %x \n ",total_file_string_size[cnt]);
			}
#endif

			printk(" program the IN dTD for  total_file_string_size \n");

		//	total_file_string_size[3] = prev_str_count ;
			
			_usb_device_send_data(handle,3,(u8 *)((u32)list_streams & 0xfffff000) ,64,(u32)list_streams & 0x00000fff);
			_usb_device_recv_data(handle, 2, prop_cmd, 8);
			
#if 0
			
			sys_stat64("/1.ts", &stat_buf);
			printk(" 1.ts stat_buf.st_size = %d \n",stat_buf.st_size);

			sys_stat64("/test/1.txt", &stat_buf);
			printk(" /test/1.txt stat_buf.st_size = %d \n",stat_buf.st_size);

			sys_stat64("/test/another.txt", &stat_buf);
			printk(" /test/another.txtstat_buf.st_size = %d \n",stat_buf.st_size);

			sys_stat64("/test/input.txt", &stat_buf);
			printk(" /test/input.txt stat_buf.st_size = %d \n",stat_buf.st_size);
#endif

			fd1 = sys_open("/tmp/1.ts", O_RDONLY, 0);

			sys_newfstat(fd1 ,&stat_buf);
		/*	printk(" 1.ts stat_buf.st_size = %d \n",stat_buf.st_size);  */

				


		//	_usb_device_send_data(handle,3,(u8 *)((u32)list_streams & 0xfffff000) ,64,(u32)list_streams & 0x00000fff); 
		//	_usb_device_send_data(handle,3,(u8 *)((u32)list_streams & 0xfffff000) ,64,(u32)list_streams & 0x00000fff); 
		//	_usb_device_send_data(handle,3,(u8 *)((u32)list_streams & 0xfffff000) ,64,(u32)list_streams & 0x00000fff); 
			


		//	printk(" program the IN dTD for  list_streams \n");

		//	_usb_device_send_data(handle,3,(u8 *)((u32)list_streams & 0xfffff000) ,64,(u32)list_streams & 0x00000fff); 


			break;

		case CP_STREAM_FROM_STB:

			disable_printks = 1;

			printk(" CP_STREAM_FROM_STB \n");	

			sys_close(fd);

			filename=file_name;
			*(filename + 6) = 49;


			_usb_device_recv_data(handle, 2, prop_cmd, 8);
			
			get_dir("/test");
			read_finfo_buff [0] = (file_cnt - 2 );

			printk("  no of files in media directory %d \n", file_cnt);

			_usb_device_send_data(handle,3,(u8 *)((u32)read_finfo_buff & 0xfffff000) ,64,(u32)read_finfo_buff & 0x00000fff);  /* Recived no files and size info */
			_usb_device_send_data(handle,3,(u8 *)((u32)read_finfo_buff & 0xfffff000) ,64,(u32)read_finfo_buff & 0x00000fff);  /* Recived no files and size info */

			read_stream = 1;
			file_cnt =0;

			
#if 0
			read_file("/appfs/1.ts",read_buff,64);
			read_file_open_flag = 1 ; /* file open is required just once */
			_usb_device_send_data(handle,3,(u8 *)((u32)read_buff & 0xfffff000) ,64,(u32)read_buff & 0x00000fff); 
#endif


		//	_usb_device_recv_data(handle, 2, prop_cmd, 8);

			break;

		case CP_STREAM_TO_STB:

			 printk(" CP_STREAM_TO_STB \n");

			 disable_printks = 1;

			 _usb_device_recv_data(handle, 2, recv_stream, 256);
			 // _usb_device_recv_data(handle, 2, prop_cmd, 8);
		 
		

			break;

		default:

			printk("********** UNKNOWN COMMAND ISSUED by USB HOST *******\n");


	}


}






void read_file(char *filename , char * buf, size_t count)
{
  /* int cnt = 0 ;  */

  size_t read_ret;

 // char buf[1];
  mm_segment_t old_fs; 
	  
	  
  old_fs  = get_fs();
  set_fs(KERNEL_DS);

 // printk(" read_file IN\n");

   if( (read_file_ptr == 1048512)   &&  ( read_curr_fcnt <= (file_cnt - 2) ) ) /* Max File Size */
   {
	
	   IsEOF=1;

	   read_ret = sys_read(fd, buf, count);	

	   printk(" EOF FILE reached read_curr_fcnt=%d ,file_cnt =%d \n",read_curr_fcnt,(file_cnt-2));


	    sys_close(fd);
		read_file_open_flag = 0;
		filename=file_name;
		*(filename + 6) = ts_count++;
		read_file_ptr =0;

		if( (read_curr_fcnt ) == ( file_cnt - 2))
		{
			printk("***** LAST FILE ****** \n");
			*(filename + 6) = 49;

			printk("%s \n",filename);
			read_curr_fcnt = 0;
			ts_count = 50;
		}

		

		return;

   }

  if(!read_file_open_flag)
  {
	  

	 fd = sys_open(filename, O_RDONLY, 0);
	 read_curr_fcnt++;
	 printk(" FILE OPEN  read_curr_fcnt=%d \n",read_curr_fcnt);
	 read_file_open_flag = 1;
  }

  if (fd >= 0) {
   // printk(KERN_DEBUG);
  //	printk(" sys_open success !!! \n");


	read_ret = sys_read(fd, buf, count);

	if( read_ret < 64)
		printk("Error sys_read %d \n",read_ret);


	read_file_ptr+=64;

	printk(KERN_DEBUG);
	printk("  read_file_ptr  %d \n",read_file_ptr);
	

#if 0
    while (sys_read(fd, buf, 1) == 1)
	{
      read_buff[cnt] = buf[0];
      printk("%c", read_buff[cnt]);//buf[0]);
	  cnt++;

	}
	read_buff_cnt= cnt;
#endif

//	printk(" read_file IN\n");
   // printk("\n");
	if(read_file_close_flag)
		sys_close(fd);
  }

}

#if 0
void read_file(char *filename)
{
  int fd , cnt = 0 ;
  char buf[1];


  mm_segment_t old_fs = get_fs();
  set_fs(KERNEL_DS);

  printk(" read_file IN\n");
  fd = sys_open(filename, O_RDONLY, 0);

  if (fd >= 0) {
    printk(KERN_DEBUG);
	printk(" sys_open success !!! \n");
    while (sys_read(fd, buf, 1) == 1)
	{
      read_buff[cnt] = buf[0];
      printk("%c", read_buff[cnt]);//buf[0]);
	  cnt++;

	}

	read_buff_cnt= cnt;

    printk("\n");
    sys_close(fd);
  }

  
  printk(" read_file OUT\n");
  set_fs(old_fs);
}

#endif



void write_file(char *filename ,size_t len , char * buf)
{
  int fd =0 /* , cnt = 0 */ ;
  ssize_t ret_write;
  //char buf[1];


  mm_segment_t old_fs = get_fs();
  set_fs(KERNEL_DS);

 // printk(" write_file IN\n");

  if(!recv_stream_file_open)
  {
	fd = sys_open(filename, O_WRONLY|O_CREAT, 0);
	recv_stream_file_open = 1;
  }

  if (fd >= 0) {
  //  printk(KERN_DEBUG);
//	printk(" sys_open success !!! \n");

	ret_write = sys_write(fd,buf,len);

//	printk(" ret_write = %d \n",ret_write);
#if 0
    while (sys_read(fd, buf, 1) == 1)
	{
      read_buff[cnt] = buf[0];
      printk("%c", read_buff[cnt]);//buf[0]);
	  cnt++;

	}

	read_buff_cnt= cnt;
#endif

  //  printk("\n");
   // sys_close(fd);
  }

  
  //printk(" write_file OUT\n");
  set_fs(old_fs);
}

//#endif


extern unsigned char write_buf[64];

int usb_gadget_register_driver (struct usb_gadget_driver *driver)
{
	
	int status = 0,cnt;
	unsigned buf;
	struct vusbhs_ep  *ep;
	
#ifdef BVT_FIX

	unsigned int *x;
	unsigned int cmd;

#endif
	


	ep = &((struct vusbhs_udc *)udc)->ep[0];
#ifdef USB_PROP_FILE_OP


	/* int fstatus;
	void *hdl;  */
	/* unsigned int bytes_wr=0 ,bytes_rd=0; */


#endif
	
	USB_DEV_PRINT( KERN_INFO "cnxt_udc0::usb_gadget_register_driver\n");


#ifdef USB_PROP_ENUM
	for(cnt=0;cnt < 64 ; cnt++)
	{
		in_512[cnt] = cnt;

		read_buf[cnt] = 0;
		write_buf[cnt] = 0;
		total_file_string_size [cnt ]= cnt; 
		read_finfo_buff[cnt] = 0;
	}
	
#endif

#ifdef USB_PROP_FILE_OP

	for(cnt=0;cnt < 8 ; cnt++)
	{
		prop_cmd[cnt] = 0 ;
	}

	disable_printks = 1;

#endif


#if 0
	/* SENTHIL TEST */
	if (!driver
		|| driver->speed < USB_SPEED_FULL
		|| !driver->bind
		|| !driver->unbind
		|| !driver->setup)
		return -EINVAL;
#endif	

	/* Populating gadget structure */
	device_initialize(&udc->gadget.dev);

	udc->gadget.dev.driver = &driver->driver;
	udc->gadget.name = "cnxt_udc0"/* "vusbhs" */;
	udc->gadget.ep0 = &ep->ep;
	udc->gadget.ops = &vusbhs_gadget_ops;
	udc->gadget_driver = driver;
	udc->gadget.is_otg = 0;  
	udc->gadget.is_dualspeed = 1;


	/* Populating ep list */
	INIT_LIST_HEAD(&udc->gadget.ep_list);
	buf = ep_setup("ep0", 0, USB_ENDPOINT_XFER_CONTROL,
		8 /* after SETUP */, 64 /* maxpacket */, 0);
	
#define BULK_EP(name,addr) \
	buf = ep_setup(name "-bulk", addr, \
	USB_ENDPOINT_XFER_BULK, buf, 64, 1);
#define INT_EP(name,addr, maxp) \
	buf = ep_setup(name "-int", addr, \
	USB_ENDPOINT_XFER_INT, buf, maxp, 0);
#define ISO_EP(name,addr, maxp) \
	buf = ep_setup(name "-iso", addr, \
	USB_ENDPOINT_XFER_ISOC, buf, maxp, 1);
	

#if 1 /* Senthil  */

	BULK_EP("ep2out",  USB_DIR_OUT  | 2 );
	BULK_EP("ep3in", USB_DIR_IN |  3 /* 3 SENTHIL MAY28 */ ); 
    INT_EP("ep1in",   USB_DIR_IN  |1, 64);
#endif
	

	USB_DEV_PRINT(KERN_INFO "ep setup complete\n");
	

	

	/* calling ether bind function */
#if 1
	status = driver->bind (&udc->gadget);
	if (status) {
		printk_spl(KERN_INFO"bind to %s --> %d\n", driver->driver.name, status);

		printk("cxt_udc0::usb_gadget_register_driver bind failed\n");
		udc->gadget.dev.driver = 0;
		goto done;
	}
#endif
	usb_initTdi(); //moved here from probe to avoid crash on first boot up
	USB_DEV_PRINT(KERN_INFO"bound to driver %s\n", driver->driver.name);
	
	printk("cnxt_udc0::bound to driver %s\n", driver->driver.name);

#if 0
	dci_regs_dump();

	SetupBuffer_ReadThread = kthread_run(Poll_SetupBuffer, NULL,"cnxt_udc0_setupbuffer");
	if (IS_ERR(SetupBuffer_ReadThread)) {
		printk(" Kernel thread cnxt_udc0_setupbuffer creation failed \n");
	}


//	OUT_SCSI_CMD_READ_THREAD = kthread_run(Poll_Out_sync, udc->handle,"cnxt_udc0_out_sync");
//	if (IS_ERR(OUT_SCSI_CMD_READ_THREAD)) {
//	printk(" Kernel thread cnxt_udc0_out_sync creation failed \n");
//	}

	printk(" udc->handle = %x \n",udc->handle);
#endif

#ifdef BVT_FIX
	printk(" *************************************************BACK VOLTAGE WIRE TESTIN ****************\n");

	x = (unsigned int *)USB_OTGSC_REG;
	printk("AAA USB_OTGSC_REG1 = 0x%08x\n",*x);


	cmd = (*((volatile unsigned int *)USB_OTGSC_REG));
	(*((volatile unsigned int *)USB_OTGSC_REG)) =  cmd  &  0xFFFFFFDF;
	printk("Clear IDPU and wait for 5 secs ...\n");
	msleep(5000);
	

#endif


done:
	return status;
	return 0;
}

static void handle_packet(_usb_device_handle handle, boolean  setup, 
				   uint_8 direction,uint_32 length , 
				   struct usb_ctrlrequest local_setup_packet);

void service_ep0(_usb_device_handle handle, 
				 boolean        setup,
				 uint_8         direction,
				 uint_8_ptr     buffer,
				 uint_32        length,
				 uint_8         error)
{ 
	static struct usb_ctrlrequest local_setup_packet;
	struct vusbhs_ep  *ep0 = &udc->ep[0];
	struct vusbhs_req *req = 0;
	
	DBG_ENUMERATION( KERN_INFO "service ep0, setup = %d, direction = %d, length = %d\n",
		setup,direction,length);
	
	if(direction == 1){
		USB_DEV_PRINT("name---> %s\n", ep0->name);
		if (likely (!list_empty(&ep0->queue))){
			
			ep0_cnt--;
			if (likely (!ep0_cnt)){
				req = container_of(ep0->queue.next, struct vusbhs_req, queue);
				
				list_del_init(&req->queue); 
				spin_unlock(&ep0->udc->lock);
				if (likely (req))
				{
					if (likely (req->req.complete))
					{
						req->req.complete(&ep0->ep, &req->req);
					}
				}
				spin_lock(&ep0->udc->lock);
			}
        	}
		return;
	}
	
	if (likely (setup))
	{
		_usb_device_read_setup_data(handle, 0, (uchar_ptr)&local_setup_packet);
		le16_to_cpus (&local_setup_packet.wValue);
		le16_to_cpus (&local_setup_packet.wIndex);
		le16_to_cpus (&local_setup_packet.wLength);
	}
	/* SENTHIL */
	//printk("wValue =%d wIndex =%d wLength=%d \n",local_setup_packet.wValue,local_setup_packet.wIndex,local_setup_packet.wLength);
	handle_packet(handle,setup,direction,length,local_setup_packet);
}

/*SENTHIL */ //int sen_temp_address= 1 ,ifaddress=0,ifdesc=0;sen_temp_descriptor=0;

#if 0

void handle_standard_request(_usb_device_handle handle, 
							 boolean  setup, 
							 uint_8 direction, 
							 struct usb_ctrlrequest local_setup_packet)
{
	u8 request = local_setup_packet.bRequest;
	u16 usb_status;
	u8 endpoint;
	static u8 new_address;
	int isGet=0, status = 0;

	//senthil
      uchar zero_buff[4096];

	
	
	if(setup)
	{
		switch(request)
		{
		case USB_REQ_GET_DESCRIPTOR:
			DBG_ENUMERATION("USB_REQ_GET_DESCRIPTOR\n");
#if 0
			printk("USB_REQ_GET_DESCRIPTOR\n");
#endif

		//	ifdesc= 1; 
		//	ifaddress=0;
#if 0 /* SENTHIL */
		
			sen_temp_descriptor++;
			if(sen_temp_descriptor == 2)
			{
				printk("Duplicate Descriptor ignored!!!!!\n");
				return 0;
			}
#endif


/* Senthil TEST */
#if 1
			if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
#endif
			isGet = 1;
			break;
			
		case USB_REQ_GET_STATUS:
			DBG_ENUMERATION("USB_REQ_GET_STATUS\n");
			//printk(" USB_REQ_GET_STATUS\n ");
			if (local_setup_packet.bRequestType != 0x80) {
				DBG_ENUMERATION("Unknown status request\n");
				status = EINVAL;
			}
			else {
				_usb_device_get_status(handle, USB_STATUS_DEVICE, &usb_status);
				_usb_device_send_data(handle, 
					0, 
					(unsigned char *)&usb_status, 
					sizeof(usb_status), 
					0);
				isGet = 1;
			}
			break;
			
		case USB_REQ_GET_INTERFACE:
			DBG_ENUMERATION("USB_REQ_GET_INTERFACE\n");
//			printk(" USB_REQ_GET_INTERFACE\n ");
			if(udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
			
			isGet = 1;
			break;
			
		case USB_REQ_GET_CONFIGURATION:
			DBG_ENUMERATION("USB_REQ_GET_CONFIGURATION\n");
//			printk(" USB_REQ_GET_CONFIGURATION\n ");
			if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
			isGet = 1;
			break;
			
		case USB_REQ_SET_ADDRESS:
			DBG_ENUMERATION("USB_REQ_SET_ADDRESS\n");

#if 1
//			printk("USB_REQ_SET_ADDRESS \n");
#endif
			
		//	ifaddress=1;

			/* SENTHIL */
#if 0
			if(sen_temp_address)
			{
				printk("Duplicate Set Address ignored!!!!!\n");
				sen_temp_address=0;	
				break;
			}
			
#endif

			new_address = local_setup_packet.wValue;   
			
			//printk("USB_REQ_SET_ADDRESS new_address=%d ,local_setup_packet.wValue =%d \n",new_address,local_setup_packet.wValue);
			
			/* if hardware assitance is enabled for set_address (see
			* hardware rev for details) we need to do the set_address
			* before queuing the status phase.
			*/
			
			_usb_device_set_status(handle, USB_STATUS_ADDRESS, new_address);
			_usb_device_set_status(handle, USB_STATUS_DEVICE_STATE, USB_STATE_ADDRESS);
			
			_usb_device_send_data(handle, 0, 0, 0, 0);
			setup_state = TX_ZERO_LEN;

		//	sen_temp_address = 0; /* SENTHIL */
			break;
			
		case USB_REQ_SET_FEATURE:
			DBG_ENUMERATION("USB_REQ_SET_FEATURE\n");
			printk("USB_REQ_SET_FEATURE\n");
			switch (local_setup_packet.bRequestType){
			case 0:
				/* DEVICE */
				if (local_setup_packet.wValue == 1)
				{
					/* set remote wakeup */
					_usb_device_get_status(handle, USB_STATUS_DEVICE, &usb_status);
					usb_status |= USB_REMOTE_WAKEUP;
					_usb_device_set_status(handle, USB_STATUS_DEVICE, usb_status);
				}                                                                }
                else if (local_setup_packet.wValue == 2)
                {
                    _usb_device_set_status (handle, USB_STATUS_TEST_MODE, local_setup_packet.wIndex);
                 }
              	else
					status = EINVAL;
				break;
				
			case 2:
				/* ENDPOINT */
				if (local_setup_packet.wValue != 0){
					return;
				} /* Endif */
				endpoint = local_setup_packet.wIndex & USB_STATUS_ENDPOINT_NUMBER_MASK;
				_usb_device_get_status(handle, USB_STATUS_ENDPOINT | endpoint,
					&usb_status);
				/* set stall */
				_usb_device_set_status(handle, USB_STATUS_ENDPOINT | endpoint, 1);
				break;
			default:
				status = EINVAL;
				
			} /* Endswitch */
			_usb_device_send_data(handle, 0, 0, 0, 0); 
			setup_state = TX_ZERO_LEN;
			break;
			
			case USB_REQ_SET_DESCRIPTOR:
				DBG_ENUMERATION("USB_REQ_SET_DESCRIPTOR\n");
//				printk("USB_REQ_SET_DESCRIPTOR\n");
				status = EINVAL;
				break;
				
			case USB_REQ_SET_CONFIGURATION:
				DBG_ENUMERATION("USB_REQ_SET_CONFIGURATION\n");
//				printk("USB_REQ_SET_CONFIGURATION\n");
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				setup_state = TX_ZERO_LEN;
				break;
				
			case USB_REQ_SET_INTERFACE:
				DBG_ENUMERATION("USB_REQ_SET_INTERFACE\n");
//				printk("USB_REQ_SET_INTERFACE\n");
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				setup_state = TX_ZERO_LEN;
				break;
				
			case USB_REQ_SYNCH_FRAME:
				DBG_ENUMERATION("USB_REQ_SYNCH_FRAME\n");
//				printk("USB_REQ_SYNCH_FRAME\n");
				status = EINVAL;
				break;
				
			case USB_REQ_CLEAR_FEATURE:
				DBG_ENUMERATION("USB_REQ_CLEAR_FEATURE\n");
//				printk("USB_REQ_SYNCH_FRAME\n");
				status = handleClearFeature(handle, &local_setup_packet);
				break;      
				
			default:
				DBG_ENUMERATION("Unknown request\n");  
				status = EINVAL;
				break;
		}/* end switch */
	
		if (status)
		{
			DBG_ENUMERATION("Error processing request 0x%x\n", request);
			//_usb_device_stall_endpoint(handle, 0, 0);
			return;
		}
	
		if (isGet)
		{
			/* The host should now get the \data and send a 0 byte packet back */

//			printk(" OUT PACKET Recieve len packet \n");
			_usb_device_recv_data(handle, 0, 0 , 0);
			setup_state = RX_ZERO_LEN;
		}
	}/* end if setup */
}
#endif


#ifdef PLUGFEST

u32 usbcv=1;


void  usb_cnxt_init_endpoint(_usb_device_handle handle,unsigned int ep_num,unsigned int wMaxPacketSize,  unsigned int wEndpointAddress, unsigned int wAttributes )
{

//	printk(" usb_cnxt_init_endpoint \n");

	_usb_device_init_endpoint ( handle,
		ep_num,
		wMaxPacketSize,
		((wEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 1 : 0,
		wAttributes & USB_ENDPOINT_XFERTYPE_MASK,(ep_num==1)?1:0) ;

#if 0
		while(_usb_device_init_endpoint ( handle,
		ep_num,
		wMaxPacketSize,
		((wEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 1 : 0,
		wAttributes & USB_ENDPOINT_XFERTYPE_MASK,(ep_num==1)?1:0) ){
		_usb_device_cancel_transfer ( handle, ep_num, 
			((wEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN)? 1 : 0 );
	}
#endif
}


u8  IsBulk( u8 wIndex)
{

	if( (wIndex == 0x83) ||  ( wIndex == 0x2))
		return 0;
	else
		return -1;

}

u32 test= 1, test_interface= 1 ,setconfigval= 0 ,get_test= 1, bulk_in_status=0,bulk_out_status=0;

#endif

void handle_standard_request(_usb_device_handle handle, 
							 boolean  setup, 
							 uint_8 direction, 
							 struct usb_ctrlrequest local_setup_packet)
{
	u8 request = local_setup_packet.bRequest;
	u8 wValue = local_setup_packet.wValue;
	u8 wIndex = local_setup_packet.wIndex;
	u8 wLength = local_setup_packet.wLength;

	u16 usb_status;
	u8 endpoint;
	static u8 new_address;
	int isGet=0, status = 0;

#ifdef  PLUGFEST
	unsigned int *x;
	/* u32 cmd; */

	//senthil
      uchar /* zero_buff[4096], */buff[1] ,ep_status[2];;

#endif	
	
	if(setup)
	{
		switch(request)
		{
		case USB_REQ_GET_DESCRIPTOR:
			DBG_ENUMERATION("USB_REQ_GET_DESCRIPTOR\n");
#if 0
			printk("USB_REQ_GET_DESCRIPTOR\n");
#endif

		//	ifdesc= 1; 
		//	ifaddress=0;
#if 0 /* SENTHIL */
		
			sen_temp_descriptor++;
			if(sen_temp_descriptor == 2)
			{
				printk("Duplicate Descriptor ignored!!!!!\n");
				return 0;
			}
#endif


/* Senthil TEST */
#if 1
			if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
#endif
			isGet = 1;
			break;
			
		case USB_REQ_GET_STATUS:
			DBG_ENUMERATION("USB_REQ_GET_STATUS\n");

#ifdef PLUGFEST

			if(!IsBulk(wIndex))
			{
				if(wIndex == 0x83)
				{

					ep_status[0]= bulk_in_status ;

					x = (unsigned int *)USB_ENPTCTRL2_REG;
					printk("USB_REQ_GET_STATUS OUT  PLUGFEST USB_ENPTCTRL2_REG = 0x%08x\n",*x);


					x = (unsigned int *)USB_ENPTCTRL3_REG;
					printk(" USB_REQ_GET_STATUS IN  PLUGFEST USB_ENPTCTRL3_REG = 0x%08x\n",*x);
				}

				if(wIndex == 0x02)
				{
					ep_status[0]= bulk_out_status;

					printk("PLUGFEST program for the OUT QTD \n");

					x = (unsigned int *)USB_ENPTCTRL2_REG;
					printk("1USB_REQ_GET_STATUS OUT  PLUGFEST USB_ENPTCTRL2_REG = 0x%08x\n",*x);


					x = (unsigned int *)USB_ENPTCTRL3_REG;
					printk(" 1USB_REQ_GET_STATUS IN  PLUGFEST USB_ENPTCTRL3_REG = 0x%08x\n",*x);

				//	_usb_device_recv_data(handle, 2, scsi_cmd_pf, 31);
				}

				ep_status[1]=0;

				_usb_device_send_data(handle,0,(u8 *)((u32)ep_status & 0xfffff000) ,2,(u32)ep_status & 0x00000fff); //Send 2 bytes data
				_usb_device_recv_data(handle, 0, 0 , 0);

				
			}
#endif

			//printk(" USB_REQ_GET_STATUS\n ");
			if (local_setup_packet.bRequestType != 0x80) {
				DBG_ENUMERATION("Unknown status request\n");
				status = EINVAL;
			}
			else {
				_usb_device_get_status(handle, USB_STATUS_DEVICE, &usb_status);
				_usb_device_send_data(handle, 
					0, 
					(unsigned char *)&usb_status, 
					sizeof(usb_status), 
					0);
				isGet = 1;
			}
			break;
			
		case USB_REQ_GET_INTERFACE:
			DBG_ENUMERATION("USB_REQ_GET_INTERFACE\n");
//			printk(" USB_REQ_GET_INTERFACE\n ");
			if(udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
			
			isGet = 1;
			break;
			
		case USB_REQ_GET_CONFIGURATION:
			DBG_ENUMERATION("USB_REQ_GET_CONFIGURATION\n");
//			printk(" USB_REQ_GET_CONFIGURATION\n ");

#ifdef PLUGFEST

		if(usbcv)
		{
			if(get_test) //jULY15TH 
			{

				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				isGet = 1;
			   get_test= 0;

			}else
			{
				
				buff[0] = setconfigval;
				_usb_device_send_data(handle,0,(u8 *)((u32)buff & 0xfffff000) ,1,(u32)buff & 0x00000fff); //Send 1 bytes data
				//_usb_device_send_data(handle, 0, 0 , 0,0);
				_usb_device_recv_data(handle, 0, 0 , 0);

			}
		}
		else
		{
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
				isGet = 1;

		}

#else
			if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				status = EINVAL;
			isGet = 1;

#endif
			break;
			
		case USB_REQ_SET_ADDRESS:
			DBG_ENUMERATION("USB_REQ_SET_ADDRESS\n");

#if 1
//			printk("USB_REQ_SET_ADDRESS \n");
#endif
			
		//	ifaddress=1;

			/* SENTHIL */
#if 0
			if(sen_temp_address)
			{
				printk("Duplicate Set Address ignored!!!!!\n");
				sen_temp_address=0;	
				break;
			}
			
#endif

			new_address = local_setup_packet.wValue;   
			
			//printk("USB_REQ_SET_ADDRESS new_address=%d ,local_setup_packet.wValue =%d \n",new_address,local_setup_packet.wValue);
			
			/* if hardware assitance is enabled for set_address (see
			* hardware rev for details) we need to do the set_address
			* before queuing the status phase.
			*/
			
			_usb_device_set_status(handle, USB_STATUS_ADDRESS, new_address);
			_usb_device_set_status(handle, USB_STATUS_DEVICE_STATE, USB_STATE_ADDRESS);
			
			_usb_device_send_data(handle, 0, 0, 0, 0);
			setup_state = TX_ZERO_LEN;

		//	sen_temp_address = 0; /* SENTHIL */
			break;
			
		case USB_REQ_SET_FEATURE:
			DBG_ENUMERATION("USB_REQ_SET_FEATURE\n");
			printk("USB_REQ_SET_FEATURE\n");
			switch (local_setup_packet.bRequestType){
			case 0:
				/* DEVICE */
				if (local_setup_packet.wValue == 1)
				{
					/* set remote wakeup */
					_usb_device_get_status(handle, USB_STATUS_DEVICE, &usb_status);
					usb_status |= USB_REMOTE_WAKEUP;
					_usb_device_set_status(handle, USB_STATUS_DEVICE, usb_status);
				}
				else if (local_setup_packet.wValue == 2)
				{

					_usb_device_send_data(handle, 0, 0, 0, 0); 
					setup_state = TX_ZERO_LEN;
					_usb_device_set_status (handle, USB_STATUS_TEST_MODE, local_setup_packet.wIndex);
					return;
				}
				else
					status = EINVAL;
				break;
				
			case 2:
				/* ENDPOINT */

#ifdef PLUGFEST
			if(!IsBulk(wIndex))
			{
				if(wIndex == 0x83)
				{

					bulk_in_status = 1;
				}

				if(wIndex == 0x02)
				{
					bulk_out_status = 1;
				}

				ep_status[1]=0;

			//	_usb_device_send_data(handle,0,(u8 *)((u32)ep_status & 0xfffff000) ,2,(u32)ep_status & 0x00000fff); //Send 2 bytes data
				_usb_device_send_data(handle, 0, 0 , 0 ,0);
				return;
				
			}
#endif
				if (local_setup_packet.wValue != 0){
					return;
				} /* Endif */
				endpoint = local_setup_packet.wIndex & USB_STATUS_ENDPOINT_NUMBER_MASK;
				_usb_device_get_status(handle, USB_STATUS_ENDPOINT | endpoint,
					&usb_status);
				/* set stall */
				_usb_device_set_status(handle, USB_STATUS_ENDPOINT | endpoint, 1);
				break;
			default:
				status = EINVAL;
				
			} /* Endswitch */
			_usb_device_send_data(handle, 0, 0, 0, 0); 
			setup_state = TX_ZERO_LEN;
			break;
			
			case USB_REQ_SET_DESCRIPTOR:
				DBG_ENUMERATION("USB_REQ_SET_DESCRIPTOR\n");
//				printk("USB_REQ_SET_DESCRIPTOR\n");
				status = EINVAL;
				break;
				
			case USB_REQ_SET_CONFIGURATION:
				DBG_ENUMERATION("USB_REQ_SET_CONFIGURATION\n");

//				printk("USB_REQ_SET_CONFIGURATION\n");

#ifdef PLUGFEST
			
#if 0	
				if(!init_once)
				{
					_usb_device_recv_data(handle, 2, prop_cmd, 8); /* Set the recieve command */
					init_once=1;
				}
#endif

				if(usbcv)

				{
					if(test) //jULY15TH 
					{
						if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
							status = EINVAL;
						setup_state = TX_ZERO_LEN;
						test= 0;

					}
				else
				{

					setconfigval = wValue ;
					
					printk("BULK_EPIN - USB_REQ_SET_CONFIGURATION  wValue=%d  ,wIndex =%d ,wLength=%d \n",wValue,wIndex,wLength);
					_usb_device_send_data(handle, 0, 0 , 0,0);
					setup_state = TX_ZERO_LEN;

				//	_usb_device_init_endpoint(handle,3,512,0,2,0);
				//	_usb_device_init_endpoint(handle,2,512,1,2,1);

					//Jan23rd

				//PNP fix
					usb_cnxt_init_endpoint(handle,3,512,0x83,0x2);
					usb_cnxt_init_endpoint(handle,2,512,0x2,0x2);

					_usb_device_send_data(udc->handle,3,(u8 *)((u32)read_buff & 0xfffff000) ,64,(u32)read_buff & 0x00000fff);
					 read_stream = 1;
					


					x = (unsigned int *)USB_ENPTCTRL2_REG;
					printk(" PLUGFEST USB_ENPTCTRL2_REG = 0x%08x\n",*x);


					x = (unsigned int *)USB_ENPTCTRL3_REG;
					printk("PLUGFEST USB_ENPTCTRL3_REG = 0x%08x\n",*x);

				}

				}
				else
				{
					if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
					setup_state = TX_ZERO_LEN;

				}

#else
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				setup_state = TX_ZERO_LEN;
#endif
				break;
				
			case USB_REQ_SET_INTERFACE:
				DBG_ENUMERATION("USB_REQ_SET_INTERFACE\n");

//				printk("USB_REQ_SET_INTERFACE\n");
#ifdef PLUGFEST
			if(usbcv)
			{
				if (test_interface)
				{
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				setup_state = TX_ZERO_LEN;

				 test_interface=0;
				}
				else
				{
					_usb_device_send_data(handle, 0, 0 , 0 ,0);
					setup_state = TX_ZERO_LEN;


				}
			}else
			{
					if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
					setup_state = TX_ZERO_LEN;

			}

#else
				if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
					status = EINVAL;
				setup_state = TX_ZERO_LEN;
#endif
				break;
				
			case USB_REQ_SYNCH_FRAME:
				DBG_ENUMERATION("USB_REQ_SYNCH_FRAME\n");
//				printk("USB_REQ_SYNCH_FRAME\n");
				status = EINVAL;
				break;
				
			case USB_REQ_CLEAR_FEATURE:
				DBG_ENUMERATION("USB_REQ_CLEAR_FEATURE\n");
//				printk("USB_REQ_SYNCH_FRAME\n");
#ifdef PLUGFEST
				if(!IsBulk(wIndex))
				{
					if(wIndex == 0x83)
					{

						bulk_in_status = 0;

					

						(*((volatile unsigned int *)USB_ENPTCTRL3_REG)) = 0x880000;
					//	cmd = (*((volatile unsigned int *)USB_ENPTCTRL3_REG));
					//	(*((volatile unsigned int *)USB_ENPTCTRL3_REG)) = cmd & 0xFFFEFFFF;


//						cmd = (*((volatile unsigned int *)USB_ENPTCTRL2_REG));
//						(*((volatile unsigned int *)USB_ENPTCTRL2_REG)) = cmd | 0x00001;


					//	x = (unsigned int *)USB_ENPTCTRL2_REG;
					//	printk("USB_ENPTCTRL2_REG = 0x%08x\n",*x);

						x = (unsigned int *)USB_ENPTCTRL3_REG;
						printk("USB_REQ_CLEAR_FEATURE USB_ENPTCTRL3_REG = 0x%08x\n",*x);



					//	status = handleClearFeature(handle, &local_setup_packet);
					}

					if(wIndex == 0x02)
					{
						(*((volatile unsigned int *)USB_ENPTCTRL2_REG)) = 0x88;
					//	cmd = (*((volatile unsigned int *)USB_ENPTCTRL2_REG));
					//	(*((volatile unsigned int *)USB_ENPTCTRL2_REG)) = cmd &  0xFFFFFFFE ;


						x = (unsigned int *)USB_ENPTCTRL2_REG;
						printk("USB_ENPTCTRL2_REG = 0x%08x\n",*x);


						bulk_out_status = 0;
					}

					ep_status[1]=0;

				

			//	_usb_device_send_data(handle,0,(u8 *)((u32)ep_status & 0xfffff000) ,2,(u32)ep_status & 0x00000fff); //Send 2 bytes data
				_usb_device_send_data(handle, 0, 0 , 0 ,0);
				return;
				
			}

#endif
				status = handleClearFeature(handle, &local_setup_packet);
				break;      
				
			default:
				DBG_ENUMERATION("Unknown request\n");  
				status = EINVAL;
				break;
		}/* end switch */
	
		if (status)
		{
			DBG_ENUMERATION("Error processing request 0x%x\n", request);
			//_usb_device_stall_endpoint(handle, 0, 0);
			return;
		}
	
		if (isGet)
		{
			/* The host should now get the \data and send a 0 byte packet back */

//			printk(" OUT PACKET Recieve len packet \n");
			_usb_device_recv_data(handle, 0, 0 , 0);
			setup_state = RX_ZERO_LEN;
		}
	}/* end if setup */
}



static int handleClearFeature(_usb_device_handle handle,
							  struct usb_ctrlrequest *setup_ptr)
{
    switch (setup_ptr->bRequestType)
    {
	case 0:     // device
		if (setup_ptr->wValue == 1)
		{
			// clear remote wakeup
		}
		else
		{
			return EINVAL;
		} /* Endif */
		break;
		
	case 2:     // endpoint
		if (setup_ptr->wValue != 0)
			return EINVAL;
		
		_usb_device_unstall_endpoint(handle,
			setup_ptr->wIndex & 0x000f,
			(setup_ptr->wIndex & 0x0080) ? USB_SEND : USB_RECV);
		break;
		
	default:
		return EINVAL;
		
    };
    return 0;
}


#ifdef BULK_TEST
	unsigned char scsi_cmd[512];
#endif

static void handle_class_request(_usb_device_handle handle, 
						  boolean  setup, 
						  uint_8 direction, 
						  uint_32 length,
						  struct usb_ctrlrequest local_setup_packet)
{
	static struct vusbhs_req req1;
	struct vusbhs_req *req = &req1;



//	printk(" handle_class_request \n");


	if(0 /* first_out */)
	{
		first_out=0;
		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512); //Senthil Added June09th 
	}

//	printk( " bRequestType = %x wValue = %x wIndex = %x wLength  %x \n",local_setup_packet.bRequestType,local_setup_packet.wValue,local_setup_packet.wIndex, local_setup_packet.wLength);
	
	/* CDC_GET_ENCAPSULATED_RESPONSE */
	if (local_setup_packet.bRequestType & 0x80){

//		printk("T1\n");
		if(setup){
			if( udc->gadget_driver->setup(&udc->gadget,&local_setup_packet) < 0)
				USB_DEV_PRINT("ch9ClassSet: error in setup\n");
			_usb_device_recv_data(handle, 0, 0, 0);
			setup_state = RX_ZERO_LEN;
//			printk("T11\n");
#ifdef BULK_TEST
	
  //  v6_dma_inv_range(scsi_cmd , scsi_cmd + 31);
  	printk(" Program OUT qtd for BULK OUT Transfer  scs_cmd = %x \n",scsi_cmd);
	_usb_device_recv_data(handle, 2, scsi_cmd, 512);
#endif


			return;
		}
		else{
//			printk("T12\n");
			return;
		}
	}
	
	if(setup){
		/* CDC_SEND_ENCAPSULATED_COMMAND */
		printk_spl("CDC_SEND_ENCAPSULATED_COMMAND\n");
		if(local_setup_packet.wLength == 0){
			printk_spl("ch9ClassSet: 0 length packet\n");
			_usb_device_send_data(handle, 0, 0, 0, 0);
			setup_state = TX_ZERO_LEN;

//			printk("T21\n");
			return;
		}
		else {
			
			if((req->req.buf = kmalloc(local_setup_packet.wLength + sizeof(local_setup_packet), GFP_ATOMIC)) == NULL)
			{
				printk_spl("Buf alloc failed\n");

				return;
			}
			req->req.length = local_setup_packet.wLength;          
			_usb_device_recv_data(handle, 0, (unsigned char *)req->req.buf + sizeof(local_setup_packet),local_setup_packet.wLength);
		}
	}
	else if(direction == 0)
	{
	        if (unlikely ((length != local_setup_packet.wLength))){
			/* Zero length packet for GET CDC received now, do nothing */
				
//			printk("T31\n");
			return;	
		}	
		
            	if (likely(req && req->req.buf))
            	{
                	memcpy(req->req.buf, (unsigned char *)&local_setup_packet, sizeof(local_setup_packet));
	                printk_spl("send cdc encapsulated rndis message,length %d\n", local_setup_packet.wLength);
        	        if(udc->gadget_driver->setup(&udc->gadget,req->req.buf) < 0 ) {
	                    USB_DEV_PRINT("ch9ClassSet: error in setup\n"); 
                	}
	                kfree(req->req.buf); 
			setup_state = TX_ZERO_LEN;
        	}
	}


}


void handle_packet(_usb_device_handle handle, 
				   boolean                  setup, 
				   uint_8                   direction,
				   uint_32                  length, 
				   struct usb_ctrlrequest   local_setup_packet)
{
	
	u8 requestType = (local_setup_packet.bRequestType & 0x60);
	
	switch (requestType)
	{
	case USB_TYPE_STANDARD:
		USB_DEV_PRINT("standard request\n");
		DBG_ENUMERATION("standard request\n");
		handle_standard_request(handle,setup,direction,local_setup_packet);
		break;
		
	case USB_TYPE_CLASS:
		DBG_ENUMERATION("class specific request\n");
		handle_class_request(handle,setup,direction,length,local_setup_packet);  
		break;
		
	case USB_TYPE_VENDOR:
		DBG_ENUMERATION("vendor specific request\n");
		
	default:
		break;
	};
}

void service_ep1(_usb_device_handle handle, 
				 boolean        setup,
				 uint_8         direction,
				 uint_8_ptr     buffer,
				 uint_32        length,
				 uint_8         error)
{
	struct vusbhs_ep  *ep1_in_int = &udc->ep[5];
	struct vusbhs_req *req;
	
	if (!list_empty(&ep1_in_int->queue)) {
		
		req = container_of(ep1_in_int->queue.next, struct vusbhs_req, queue);
		
		if(req){
			list_del_init(&req->queue);  
			
			USB_DEV_PRINT("calling tx complete handler %p!! buffer: %p, len :%d\n",
				req->req.complete, req->req.buf, req->req.length);
			req->req.buf = buffer;
			req->req.length = length;
			req->req.actual = length;
			req->req.dma = 0;
			req->req.status = 0;
			spin_unlock(&ep1_in_int->udc->lock);
			if( req->req.complete)
				req->req.complete(&ep1_in_int->ep, &req->req);
			spin_lock(&ep1_in_int->udc->lock);
		}
	}
	//Call the complete function here for the status msg sent
	printk_spl( KERN_INFO "service ep1, setup=%d, direction=%d\n", setup, direction);
}

#ifdef BULK_IN

#if 0
unsigned char inquiry_in[INQUIRY_CMD_LEN_MAX]= { 0x00,0x80,0x02,0x02,0x1F,0x00,0x00,0x00,0x4B,0x69,0x6E,0x67,0x73,0x74,0x6F,0x6E,0x44,0x61,0x74,0x61,0x54,0x72,0x61,0x76,0x65,0x6C,0x65,0x72,0x20,0x32,0x2E,0x30,0x31,0x2E,0x30,0x30};
unsigned char read_format_capacity_in[READ_FORMAT_CAP_CMD_LEN_MAX]= { 0x00,0x00,0x00,0x08,0x00,0x78,0x60,0x00,0x02,0x00,0x02,0x00};
unsigned char read_capacity_in[READ_CAP_CMD_LEN_MAX]= { 0x00,0x78,0x5F,0xFF,0x00,0x00,0x20,0x00};
unsigned char read_10_in[512];


unsigned char status[13];
unsigned char scsi_cmd[512];
unsigned int tag,signature;
#endif


//u32 disable_printks=0;

void Intialize_Read_Buffer(void)
{
	unsigned int count=0;

	for(count=0;count < (240 * 512) ; count++)
	{
		read_10_in[count]= count;
	}

}

u32 writeonly=0;

void handle_scsi(_usb_device_handle handle,uint_8_ptr buffer, u32 IsCustom)
{
	unsigned int cmd /* ,data_cnt=0,read_10_loop=0,read_rem,write_rem ,loop=0*/;
//	volatile unsigned char status[13];
    
	if(IsCustom)
	{
		    //printk("Custom Filling \n");
			status[0] = scsi_cmd[0];
			status[1] = scsi_cmd[1];
			status[2] = scsi_cmd[2];
			status[3] = scsi_cmd[3];
			status[4] = scsi_cmd[4];
			status[5] = scsi_cmd[5];
			status[6] = scsi_cmd[6];
			status[7] = scsi_cmd[7];
			status[8]=0;
			status[9]=0;
			status[10]=0;
			status[11]=0;
			status[12]=0;
			cmd= scsi_cmd[15];

	}else
	{
		   // printk("Non Custom Filling \n");
			status[0] = buffer[0];
			status[1] = buffer[1];
			status[2] = buffer[2];
			status[3] = buffer[3];
			status[4] = buffer[4];
			status[5] = buffer[5];
			status[6] = buffer[6];
			status[7] = buffer[7];
			status[8]=0;
			status[9]=0;
			status[10]=0;
			status[11]=0;
			status[12]=0;

			cmd= buffer[15];

	}

	switch(cmd)
	{
		case SC_INQUIRY:

		/* if(scsi_cmd > 32)  */
			readwriteflag=1;


		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		_usb_device_send_data(handle,3,(u8 *)((u32)inquiry_in & 0xfffff000) ,INQUIRY_CMD_LEN_MAX,(u32)inquiry_in & 0x00000fff); //Send 36bytes data
		//_usb_device_send_data(handle,0,(u8 *)((u32)zero_buf & 0xfffff000) ,0,(u32)zero_buf & 0x00000fff); //Send 0 bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);

//		printk(" Handled SC_INQUIRY \n");

		break;
		
		case SC_READ_FORMAT_CAPACITIES:

		readwriteflag=1;

		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		_usb_device_send_data(handle,3,(u8 *)((u32)read_format_capacity_in & 0xfffff000) ,READ_FORMAT_CAP_CMD_LEN_MAX,(u32)read_format_capacity_in & 0x00000fff); //Send 36bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);

//		printk(" Handled SC_READ_FORMAT_CAPACITIES \n");

		break;

		case SC_READ_CAPACITY:

			readwriteflag=1;

		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		_usb_device_send_data(handle,3,(u8 *)((u32)read_capacity_in & 0xfffff000) ,READ_CAP_CMD_LEN_MAX,(u32)read_capacity_in & 0x00000fff); //Send 36bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);

//		printk(" Handled SC_READ_CAPACITY \n");

		break;
		
		case SC_READ_10:

		disable_printks=1;
		readwriteflag=1;

		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);

#if 0
		if( scsi_cmd[23] == 240)
		{
			
			big_flag=1;
			//activestatus_flag=1;
		} 
#endif

#ifdef CI_LOG
		printk(" USB host requested Transfer request in bytes = %d \n",scsi_cmd[23] * 512);
#endif

#if 1
		if( scsi_cmd[23] * 0x200 > 0x4000)
		{
		//	printk(" BIG READ_10 read_10_loop=%d ,read_rem=%d ***********\n",read_10_loop,read_rem); //June13th
#if 0			
			read_10_loop = (scsi_cmd[23] * 0x200) / 0x4000;
			read_rem = scsi_cmd[23] * 0x200 - 0x4000;
				
			

			for(data_cnt =0 ; data_cnt < read_10_loop ;data_cnt++)
			{
				_usb_device_send_data(handle,3,(u8 *)((u32)read_10_in & 0xfffff000) ,0x4000  ,(u32)read_10_in & 0x00000fff); //Send 16k bytes data
				
			}
				_usb_device_send_data(handle,3,(u8 *)((u32)read_10_in & 0xfffff000) ,read_rem  ,(u32)read_10_in & 0x00000fff); //Send 512 bytes data
				_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);
#endif
			
			_usb_device_send_data(handle,3,(u8 *)((u32)read_10_in & 0xfffff000) ,scsi_cmd[23] * 512  ,(u32)read_10_in & 0x00000fff); //Send 512 bytes data
			_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);


		}else
		{
				
		//	printk(" Normal  READ_10 ***********\n");
#endif
			
			_usb_device_send_data(handle,3,(u8 *)((u32)read_10_in & 0xfffff000) ,scsi_cmd[23] * 512  ,(u32)read_10_in & 0x00000fff); //Send 512 bytes data
			_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);
	
		}

//		printk(" Handled SC_READ_10 \n");

		break;

		case  SC_TEST_UNIT_READY:


		/* 	if(scsi_cmd > 32)  */
				readwriteflag=1;

			write_10 = 0;

		//	printk(" SC_TEST_UNIT_READY \n");

		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
	//	_usb_device_send_data(handle,3,(u8 *)((u32)tur & 0xfffff000) ,0,(u32)tur & 0x00000fff); //Send Zero bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);

	//	printk(" SC_TEST_UNIT_READY \n");

		break;

		case  SC_MODE_SENSE_6:


		/* 	if(scsi_cmd > 32)   */
				readwriteflag=1;


		

		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		_usb_device_send_data(handle,3,(u8 *)((u32)tur & 0xfffff000) ,8,(u32)tur & 0x00000fff); //Send zero bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);

		break;

		case SC_PREVENT_ALLOW_MEDIUM_REMOVAL:


		/* 	if(scsi_cmd > 32)   */
				readwriteflag=1;


		
		status[12]=1;
		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		//_usb_device_send_data(handle,3,(u8 *)((u32)tur & 0xfffff000) ,0,(u32)tur & 0x00000fff); //Send zero bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);


		break;

		case SC_REQUEST_SENSE:


		/* 	if(scsi_cmd > 32)  */
				readwriteflag=1;



		_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);
		_usb_device_send_data(handle,3,(u8 *)((u32)request_sense & 0xfffff000) ,18,(u32)request_sense & 0x00000fff); //Send zero bytes data
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);


		break;


		case SC_WRITE_10:
		
		disable_printks=1;
		readwriteflag=1;
		

	//	printk("SC_WRITE_10 \n");
		
	
		//if(!write_once_flag)
	//	{
			
	//		write_once_flag=1;
	//	}

	//	if( scsi_cmd[23] * 0x200 > 0x4000)
	//	{

	//		printk (" Total number of blocks = %d  bytes = %d  required for transfer \n",scsi_cmd[23] ,scsi_cmd[23] * 512);

	//	}

		out_payload_cnt++;
		_usb_device_recv_data(handle,2,(uchar_ptr)write_10_out ,scsi_cmd[23] * 512); //Recieve  bytes data

		write_10 = 1;

	//	for(loop=0; loop < 13 ; loop++)
	//	{
	//		printk(" %x=%d \t ",status[loop],status[loop]);

	//	}
	//	printk(" \n");
	//	v6_inv_data_cache_all();
		
		
	//	while(!out_sync_flag)
	//	{
	//		_usb_device_recv_data(handle, 2, scsi_cmd, 512);
	//		out_sync_flag=0;
	//	}
	//	printk("aann %x - %d \n ",status[4] ,status[4]);

		in_scsi_cnt++;
		_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);
		
		
	//	_usb_device_recv_data(handle, 2, scsi_cmd, 512);
		
#if 0		
		if( scsi_cmd[23] == 240)
		{
			writeonly=1;
		}
#endif
		break;


	//	printk(" SC_MODE_SENSE_6 \n");


		
	
		default:

			printk("**************Unsupported SCSI Command**************\n");
	}		

}

#endif

void service_ep2(_usb_device_handle handle, 
				 boolean        setup,
				 uint_8         direction,
				 uint_8_ptr     buffer,
				 uint_32        length,
				 uint_8         error)
{ 
	
	struct vusbhs_ep  *ep2_out_bulk = &udc->ep[2];
	struct vusbhs_req *req;

//	volatile unsigned char status[13];
	
	USB_DEV_PRINT( "service ep2, , setup=%d, direction=%d, error = %d\n", 
		setup, direction, error);

#ifdef USB_PROP_FILE_OP
	
	  handle_prop_cmd(handle);

	  return;

#endif

//	printk("Service_EP2 \n");
	
	/* rx from host */
	if (likely (direction == 0))
	{
		
		if (likely (!list_empty(&ep2_out_bulk->queue))) {
			
			USB_DEV_PRINT("name---> %s\n", ep2_out_bulk->name);
			req = container_of(ep2_out_bulk->queue.next, struct vusbhs_req, queue);
			list_del_init(&req->queue); 
			
			req->req.buf = buffer;
			req->req.length = length;
			req->req.actual = length;
			req->req.dma = 0;
			req->req.status = 0;
			USB_DEV_PRINT("calling rx complete handler %p!! buffer: %p, len :%d\n", 
				req->req.complete, req->req.buf, req->req.length);

			spin_unlock(&ep2_out_bulk->udc->lock);

#ifdef  BULK_IN
//			printk(" opcode = %x  tx_len= %x \n ", buffer[15],buffer[8]);
			
		//	signature= buffer[0];
		//	tag = buffer[4];

			status[0] = buffer[0];
			status[1] = buffer[1];
			status[2] = buffer[2];
			status[3] = buffer[3];
			status[4] = buffer[4];
			status[5] = buffer[5];
			status[6] = buffer[6];
			status[7] = buffer[7];
			status[8]=0;
			status[9]=0;
			status[10]=0;
			status[11]=0;
			status[12]=0;

//			printk(" sig0 = %x  sig1 = %x  sig2 = %x  sig3 = %x tag0= %x tag1= %x tag2= %x tag3= %x \n",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7]);

//			printk(" Scsi Command =%x \n", buffer[15]);
			
#endif
			if (likely (!error))
			{
#ifdef DEBUG_VUSBHS
				printk("Received packet!\n");
#endif /* DEBUG_VUSBHS */
				req->req.complete(&ep2_out_bulk->ep, &req->req);

				out_flag = 1; 

#ifdef  BULK_IN
				//Senthil Added June4th

				_usb_device_recv_data(handle, 2, (uchar_ptr)scsi_cmd, 512);


				_usb_device_send_data(handle,3,(u8 *)((u32)inquiry_in & 0xfffff000) ,36,(u32)inquiry_in & 0x00000fff); //Send 36bytes data
				_usb_device_send_data(handle,3,(u8 *)((u32)status & 0xfffff000) ,13,(u32)status & 0x00000fff);
				
				
				printk( " JUST FOR BREAK POINT PURPOSE \n");

#endif
			}
			else
			{
				printk_spl("%s,Dropping the received packet! vusbhs error: %x\n", __FUNCTION__, error);
#ifdef DEBUG_VUSBHS
				req->req.length = error;
				req->req.actual = error;
				
				req->req.complete(&ep2_out_bulk->ep, &req->req);
#endif /* DEBUG_VUSBHS */
			}
			spin_lock(&ep2_out_bulk->udc->lock);
		}else
		{
		if(!disable_printks)
		{
			printk(" scsi_cmd=%x \n",scsi_cmd[15]);
		}
			//OUT qtd programmed by the DCD
			handle_scsi(handle,NULL,1);
		}
	}
	else if( unlikely (direction == 1))
	{
		/* tx to host */
		printk_spl("%s: Invalid data flow!\n", __FUNCTION__);
	}
}


void service_ep3(_usb_device_handle handle, 
				 boolean         setup,
				 uint_8         direction,
				 uint_8_ptr     buffer,
				 uint_32     length,
				 uint_8         error)
{ 
	
	struct vusbhs_ep  *ep3_in_bulk = &udc->ep[7];
	struct vusbhs_req *req;
	
	USB_DEV_PRINT( "service ep3, , setup=%d, direction=%d, buffer=%p, \
		len=%d, err=%d\n", 
		setup, direction, buffer, length, error);
	
	/* tx to host */
	if (likely (direction == 1))
	{
		if (!list_empty(&ep3_in_bulk->queue)) {
			
			USB_DEV_PRINT("name---> %s\n", ep3_in_bulk->ep.name);
			req = container_of(ep3_in_bulk->queue.next, struct vusbhs_req, queue);
			list_del_init(&req->queue); 
			USB_DEV_PRINT("calling tx complete handler %p!! buffer: %p, len :%d\n", 
				req->req.complete, req->req.buf, req->req.length);
			req->req.buf = buffer;
			req->req.length = length;
			req->req.actual = length;
			req->req.dma = 0;
			req->req.status = 0;
			spin_unlock(&ep3_in_bulk->udc->lock);
			req->req.complete(&ep3_in_bulk->ep, &req->req);
			spin_lock(&ep3_in_bulk->udc->lock);
		}
	}
	/* rx from host */
	else if (unlikely (direction == 0))
	{
		printk_spl("%s: Invalid data flow!\n", __FUNCTION__);
		printk_spl("ep name ---> %s\n", ep3_in_bulk->ep.name);
	}
}


void reset_ep0(_usb_device_handle handle, 
			   boolean        setup,
			   uint_8         direction,
			   uint_8_ptr     buffer,
			   uint_32     length,
			   uint_8         error)
{
	
	int /* endpoint, dir, */ret=0;
	unsigned long flags;
	

	/* printk(" reset_ep0 \n"); */
	
#if 0  // SENTHIL TEST
	
	/*on a reset always cancel all transfers all EP 0 */
	for (endpoint = 0; endpoint < 1 /* 4 SENTHIL */  ; endpoint++)
	{
		for (dir = 0; dir < 2; dir++)
		{
			ret = _usb_device_cancel_transfer(handle, endpoint, dir);
			if (ret)
				break;
		}
		if (ret)
			break;
	}

#endif
	
	spin_lock_irqsave(&udc->lock, flags);
	nuke (&udc->ep[0], -ESHUTDOWN);

	/* SENTHIL */
#if 0
 	nuke (&udc->ep[7], -ESHUTDOWN);  
	nuke (&udc->ep[2], -ESHUTDOWN);
	nuke (&udc->ep[5], -ESHUTDOWN); 
#endif
	spin_unlock_irqrestore(&udc->lock, flags);
	
	if (ret)
	{
#if 0
		USB_DEV_PRINT("Can't cancel transfer on endpoint %d dir %d\n", endpoint, dir);
		printk("Can't cancel transfer on endpoint %d dir %d\n", endpoint, dir);
#endif
		usb_initTdi();
		return;
	}
	
	//SENTHIL 
#if 0
	/* Initialize the endpoint 0 in both directions */
	_usb_device_init_endpoint(handle, 0, USB2_MAX_PACKET_SIZE, 0,
		USB_ENDPOINT_XFER_CONTROL, 1);
	_usb_device_init_endpoint(handle, 0, USB2_MAX_PACKET_SIZE, 1,
		USB_ENDPOINT_XFER_CONTROL, 0);
#endif
	printk("RESET IS SUCCCESS \n");
	return;
}


void service_suspend(_usb_device_handle handle, 
					 boolean  setup,
					 uint_8 direction,
					 uint_8_ptr buffer,
					 uint_32 length,
					 uint_8 error)
{
	printk_spl( KERN_INFO "service_suspend : setup=%ld dir=%d len=%ld\n", 
		setup, direction, length);
}


void service_speed_detection(_usb_device_handle handle, uint_32 speed)
{
	
	switch(speed) /* TODO */
	{
	case 0:   
		udc->gadget.speed = 2;
		break;
		
	case 1:
		udc->gadget.speed = 1;
		break;
		
	case 2:
		udc->gadget.speed = 3;
		break;
		
	default:
		udc->gadget.speed = 0;
		break;
		
	}
	USB_DEV_PRINT("gadget.speed=%d\n",udc->gadget.speed);
}

int usb_initTdi(void)
{
	
	int ret = 0;
	_usb_device_handle   handle;
	
	// Initialize the USB interface
	ret = _usb_device_init(0, &handle, 6/* 8 SENTHIL */);
	
	udc->handle = handle;
	
	//Uncomment the following line to force full speed operation
//	_usb_dci_vusb20_set_speed_full(handle, 0);
	
	if (ret != 0)
	{
		printk_spl(KERN_INFO "USB Initialization failed.");
		return -1;
	}

	/* SENTHIL NOT REQUIRED */
#if 0
	/* Initialize the endpoint 0 in both directions */
	_usb_device_init_endpoint(handle, 0, USB2_MAX_PACKET_SIZE, 0,
		USB_ENDPOINT_XFER_CONTROL, 1);
	_usb_device_init_endpoint(handle, 0, USB2_MAX_PACKET_SIZE, 1,
		USB_ENDPOINT_XFER_CONTROL, 0);

#endif
	return 0;
	
}
//extern int v6_dma_inv_range(unsigned long, unsigned long);

#ifdef	CONFIG_USB_CNXT_OTG
extern int trans;
#endif

static int __init cnxt_udc_probe(struct platform_device *pdev)
{
	int ret = 0;
	
	USB_DEV_PRINT( KERN_INFO "cnxt_udc_probe udc0\n");
	
	udc = kmalloc (sizeof *udc, SLAB_KERNEL);
	if (!udc)
		return -ENOMEM;
	
	memset(udc, 0, sizeof *udc);
	spin_lock_init (&udc->lock); 
   
//vineet code

#if 0
	strcpy (udc->gadget.dev.bus_id, "cnxt_udc0");
    udc->gadget.dev.parent = &pdev->dev;
	device_add(&udc->gadget.dev);

#endif

	device_initialize(&udc->gadget.dev);
    strcpy (udc->gadget.dev.bus_id, "gadget");
    udc->gadget.dev.parent = &pdev->dev;
     device_add(&udc->gadget.dev);


 
	ret = request_irq(pdev->resource[1].start, usb_udc_irq,
			SA_SHIRQ, "cnxt_udc0", udc);
	
	
#ifdef USB_TASKLET
		
	  
    	usb_TrCompleteTasklet = (struct tasklet_struct *)kmalloc(
				sizeof(struct tasklet_struct),
				GFP_KERNEL);
	
	tasklet_init((struct tasklet_struct *)usb_TrCompleteTasklet, usb_TrCompleteTaskletHandler , (unsigned long)NULL);
#endif
	
	USB_DEV_PRINT("request interrupt ret = %d\n" ,ret);

#ifdef	CONFIG_USB_CNXT_OTG
	
		trans= 0;
		transceiver = otg_get_transceiver();
		if (transceiver) {
			int	status = otg_set_peripheral(transceiver,
						&udc->gadget);
			
		} else {
			printk( "can't find transceiver%d \n",trans);
			return -ENODEV;
		}
	
#endif

	return 0;
}



static int __exit cnxt_udc_remove(struct platform_device *pdev ,pm_message_t message)
{
	USB_DEV_PRINT( KERN_INFO "cnxt_udc_remove\n");
	return 0;
}


static int cnxt_udc_suspend(struct platform_device *dev ,pm_message_t message)
{
	USB_DEV_PRINT( KERN_INFO "cnxt_udc_suspend\n");
	return 0;
}

static int cnxt_udc_resume(struct platform_device *dev)
{
	USB_DEV_PRINT( KERN_INFO "cnxt_udc_resume\n");
	return 0;
}


/*-------------------------------------------------------------------------*/

static void usb_release(struct device *dev)
{
	/* normally not freed */
}


/* The dmamask must be set for usb device controller to work */
static u64 cnxt_udc_dmamask =(u64) (u64*)-1;

static struct resource cnxt_udc_resources0[] = {
	{
		.start	= ASX_USB0_VIRT,
		.end	= ASX_USB0_VIRT + 4096 - 1,
		.flags	= IORESOURCE_MEM,
	},
	{
		.start	= ITC_USB0_POS,
		.flags	= IORESOURCE_IRQ,
	},
};

static struct platform_device udc_device0 = {
	.name			= "cnxt_udc0",
	.id			= -1,
	.dev = {
		.release		= usb_release,
		.dma_mask		= &cnxt_udc_dmamask,
		.coherent_dma_mask	= 0xffffffff,
	},
	.num_resources	= ARRAY_SIZE(cnxt_udc_resources0),
	.resource		= cnxt_udc_resources0,
};

static struct platform_driver cnxt_udc0_driver = {
	.probe		= cnxt_udc_probe,
	.remove		= __exit_p(cnxt_udc_remove),
	.suspend	= cnxt_udc_suspend,
	.resume		= cnxt_udc_resume,
	.driver		= {
		.owner	= THIS_MODULE,
		.name	= (char *) driver_name,
	},
};

static int __init cnxt_udc0_init(void)
{
	int rc = 0;

	rc = platform_driver_register(&cnxt_udc0_driver);
	if (rc < 0)
		return rc;
		
	rc = platform_device_register(&udc_device0);
	if (rc)
		printk("can't register cnxt usb  device controller0 , %d\n", rc);

	printk("cnxt_udc0:: UDC Device Controller Registered \n");


	Intialize_Read_Buffer();
//	cnxt_udc_probe(&udc_device0);
#ifdef	CONFIG_CNXT_USB_PLUGFEST

    cnxt_usb_gadget_create_proc_entry();

#endif
	return rc;
	
}

module_init(cnxt_udc0_init);

static void __exit cnxt_udc0_exit(void)
{
	printk("****** cnxt_udc0_exit ******\n ");
	platform_driver_unregister(&cnxt_udc0_driver);
}
module_exit(cnxt_udc0_exit);

#ifdef	CONFIG_CNXT_USB_PLUGFEST

int cnxt_proc_usb_gadget1(char *buffer,char **buffer_location,off_t offset,
                             int buffer_length, int *eof, void *data)
{

		printk(KERN_INFO "cnxt_proc_usb_gadget1\n");

		return 0;
		
}

int cnxt_proc_usb_gadget2(char *buffer,char **buffer_location,off_t offset,
                             int buffer_length, int *eof, void *data)
{

		printk(KERN_INFO "cnxt_proc_usb_gadget2\n");

		return 0;
		
}

void cnxt_usb_gadget_create_proc_entry()
{
    static struct proc_dir_entry *gadget_proc_file;

    gadget_proc_file = create_proc_entry("usb_gadget1", 0644, NULL);
    if (gadget_proc_file == NULL) {
             remove_proc_entry("usb_gadget1", &proc_root);
             printk(KERN_ALERT "Error: Could not initialize /proc/%s\n","usb_gadget1");
             return;
    }
    gadget_proc_file->read_proc = cnxt_proc_usb_gadget1;
    gadget_proc_file->owner = THIS_MODULE;
    gadget_proc_file->mode = S_IFREG | S_IRUGO;
    gadget_proc_file->uid = 0;
    gadget_proc_file->gid = 0;
    gadget_proc_file->size = 100;

    gadget_proc_file = create_proc_entry("usb_gadget2", 0644, NULL);
    if (gadget_proc_file == NULL) {
             remove_proc_entry("usb_gadget2", &proc_root);
             printk(KERN_ALERT "Error: Could not initialize /proc/%s\n","usb_gadget2");
             return;
    }
    gadget_proc_file->read_proc = cnxt_proc_usb_gadget2;
    gadget_proc_file->owner = THIS_MODULE;
    gadget_proc_file->mode = S_IFREG | S_IRUGO;
    gadget_proc_file->uid = 0;
    gadget_proc_file->gid = 0;
    gadget_proc_file->size = 100;



}
void cnxt_usb_gadget_remove_proc_entry()
{

    remove_proc_entry("usb_gadget1", &proc_root);
    printk(KERN_INFO "/proc/%s removed\n", "usb_gadget1");
    remove_proc_entry("usb_gadget2", &proc_root);
    printk(KERN_INFO "/proc/%s removed\n", "usb_gadget2");
}

EXPORT_SYMBOL(cnxt_proc_usb_gadget1);
EXPORT_SYMBOL(cnxt_proc_usb_gadget2);
EXPORT_SYMBOL(cnxt_usb_gadget_create_proc_entry);
EXPORT_SYMBOL(cnxt_usb_gadget_remove_proc_entry);

#endif
EXPORT_SYMBOL (usb_gadget_unregister_driver);
EXPORT_SYMBOL (usb_gadget_register_driver);
MODULE_DESCRIPTION("USB Device Controller Driver");
MODULE_LICENSE("GPL");

/**************************************************************************************
* Modifications:
* $Logs: $
*
***************************************************************************************/
