#ifndef __devapi_h__
#define __devapi_h__ 1
/* ###########################################################################
# (c) Copyright Conexant Limited 2006
#
# Conexant Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Limited ("Conexant").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Conexant.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Conexant.  If you have not entered into a
# confidentiality agreement with Conexant granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@conexant.com
# ##########################################################################*/

/**HEADER*********************************************************
-----------------------------------------------------------------------------
 CONFIDENTIAL AND PROPRIETARY INFORMATION OF TRANSDIMENSION, INC. AND/OR ITS
 WHOLLY OWNED SUBSIDIARY SOFTCONNEX TECHNOLOGIES, INC. THIS NOTICE IS NOT TO
 BE DELETED, MODIFIED, MOVED OR CHANGED IN ANY WAY.

 (TransDimension, Inc. and SoftConnex Technologies, Inc. are referred to
 collectively below as TransDimension, Inc.) 
 Copyright (c) 1999 - 2004 by TransDimension, Inc. 

 This software is protected by copyright laws and international copyright 
 treaties, as well as other intellectual property laws and treaties.  This
 software is a CONFIDENTIAL, unpublished work of authorship, and with portions 
 constituting TRADE SECRETS of TransDimension, Inc..  Any unauthorized use, 
 disclosure, and/or reproduction of this software, or any part of this software;
 or distribution of this software in any form or by any means; or storage of 
 this software in any database or retrieval system, without the express written
 consent of, and license from, TransDimension, Inc. is strictly prohibited.  
 This software is protected under the copyright and/or trade secret laws in 
 other countries in addition to USA.  All Rights Reserved.  Failure to abide by
 the use, disclosure and/or reproduction restrictions may result in civil and
 or criminal penalties, and will be prosecuted to the maximum extent of the law.
 -------------------------------------------------------------------------------

*** Description:
***  This file contains the declarations specific to the USB Device API
***
**************************************************************************
**END*********************************************************/

#ifndef _USB_DEVAPI
#define _USB_DEVAPI



#define __USBHS__
#define __VUSBHS__
#define __USB_DEVICE__
#define __USB_DEV__
#define __ARM__
#define TRIP_WIRE   
#define _DATA_CACHE_
#define __USB_OS_MQX__
/* #define _DEVICE_DEBUG_ */
#define SOF_INTERRUPT_DISABLE
#define SET_ADDRESS_HARDWARE_ASSISTANCE 

#include "types.h"
#include "usb.h"
#include "usbprv.h"
#include "debug.h"

#include<linux/config.h>
#include "../udc-cnxt.h" 

extern unsigned long flags;




#if defined(CONFIG_ARCH_SOLOS_GALLUS) || defined(CONFIG_ARCH_SOLOSW_GALLUS)
#include <asm/arch/hardware.h>
#include <asm/arch/hardware/devconf.h>
#include <asm/arch/hardware/usb.h>
#include <asm/io.h> /* For readl and writel funtions */
#define ARC_USB_DEVICE_AMBA ASX_USB0_VIRT /* CAPRI_UAHB_VIRT + CAPRI_USB0_BASE */
#define _VIRT_MEM 1
#elif defined CONFIG_ARCH_NEVIS /* CONFIG_ARCH_PECOS *//*(CONFIG_ARCH_CAPRI) */
#include <asm/arch/hardware.h>
/*#include <asm/arch/hardware/usb.h> SENTHIL*/
#include <asm/io.h> /* For readl and writel funtions */
#define _DEVICE_DEBUG_ 1
#define ARC_USB_DEVICE_AMBA   ASX_USB0_VIRT /* CAPRI_UAHB_VIRT + CAPRI_USB0_BASE */

//#define USB_TASKLET 

#define DEBUG_2
//#define CI_LOG
//#define DMA_POOL
//#define PATCH_CNXT
//#define BULK_TEST
//#define JUNE_11   //July06 th
#define BULK_IN
#define USB_PROP_ENUM
#define USB_PROP_FILE_OP
#define PLUGFEST
#define BVT_FIX
//#define  TRAIL_1
#define _VIRT_MEM 1


#endif
  

#ifdef USB_TASKLET
extern void *usb_TrCompleteTasklet;
#endif

#define TX_ZERO_LEN 1
#define RX_ZERO_LEN 2


#ifdef _VIRT_MEM
unsigned long virt2phys(void*) ;
unsigned long phys2virt(uint_32) ;

/* Senthil Added */
#define phys2virt(ppage) __phys_to_virt(ppage)
#define virt2phys(ppage) __virt_to_phys(ppage)

#endif
void* usb2_allocateFromHeap(unsigned int size, unsigned int alignment);

#define  USB_SEND                         (1)
#define  USB_RECV                         (0)

/* Endpoint types */
#define  USB_CONTROL_ENDPOINT             (0)
#define  USB_ISOCHRONOUS_ENDPOINT         (1)
#define  USB_BULK_ENDPOINT                (2)
#define  USB_INTERRUPT_ENDPOINT           (3)

/* Informational Request/Set Types */
#define  USB_STATUS_DEVICE_STATE          (0x01)
#define  USB_STATUS_INTERFACE             (0x02)
#define  USB_STATUS_ADDRESS               (0x03)
#define  USB_STATUS_CURRENT_CONFIG        (0x04)
#define  USB_STATUS_SOF_COUNT             (0x05)
#define  USB_STATUS_DEVICE                (0x06)
#define  USB_STATUS_TEST_MODE             (0x07)
#define  USB_FORCE_FULL_SPEED             (0x08)
#define  USB_PHY_LOW_POWER_SUSPEND        (0x09)
#define  USB_STATUS_ENDPOINT              (0x10)
#define  USB_STATUS_ENDPOINT_NUMBER_MASK  (0x8F)

#define  USB_TEST_MODE_TEST_PACKET        (0x0400)

/* Available service types */
/* Services 0 through 15 are reserved for endpoints */
#define  USB_SERVICE_EP0                  (0x00)
#define  USB_SERVICE_EP1                  (0x01)
#define  USB_SERVICE_EP2                  (0x02)
#define  USB_SERVICE_EP3                  (0x03)
#define  USB_SERVICE_BUS_RESET            (0x10)
#define  USB_SERVICE_SUSPEND              (0x11)
#define  USB_SERVICE_SOF                  (0x12)
#define  USB_SERVICE_RESUME               (0x13)
#define  USB_SERVICE_SLEEP                (0x14)
#define  USB_SERVICE_SPEED_DETECTION      (0x15)
#define  USB_SERVICE_ERROR                (0x16)
#define  USB_SERVICE_STALL                (0x17)

typedef pointer _usb_device_handle;

#ifdef __cplusplus
extern "C" {
#endif

extern uint_8 _usb_device_init(uint_8, _usb_device_handle _PTR_, uint_8);
extern uint_8 _usb_device_recv_data(_usb_device_handle, uint_8, uchar_ptr,
   uint_32);
extern uint_8 _usb_device_send_data(_usb_device_handle, uint_8, uchar_ptr,
                                    uint_32, uint_32);
extern uint_8 _usb_device_get_transfer_status(_usb_device_handle, uint_8,
   uint_8);
extern void _usb_device_get_transfer_details(_usb_device_handle, uint_8,
   uint_8, uint_32_ptr _PTR_);
extern uint_8 _usb_device_cancel_transfer(_usb_device_handle, uint_8, uint_8);
extern uint_8 _usb_device_get_status(_usb_device_handle, uint_8, uint_16_ptr);
extern uint_8 _usb_device_set_status(_usb_device_handle, uint_8, uint_16);
extern uint_8 _usb_device_register_service(_usb_device_handle, uint_8,
   void(_CODE_PTR_ service)(pointer, boolean, uint_8, uint_8_ptr, uint_32, uint_8));
extern uint_8 _usb_device_unregister_service(_usb_device_handle, uint_8);
extern uint_8 _usb_device_call_service(_usb_device_handle, uint_8, boolean,
   boolean, uint_8_ptr, uint_32, uint_8);
extern void _usb_device_shutdown(_usb_device_handle);
extern void _usb_device_set_address(_usb_device_handle, uint_8);
extern void _usb_device_read_setup_data(_usb_device_handle, uint_8, uchar_ptr);
extern void _usb_device_assert_resume(_usb_device_handle);
extern uint_8 _usb_device_init_endpoint(_usb_device_handle, uint_8, uint_16,
   uint_8, uint_8, uint_8);
extern void _usb_device_stall_endpoint(_usb_device_handle,
   uint_8, uint_8);
extern void _usb_device_unstall_endpoint(_usb_device_handle,
   uint_8, uint_8);
extern uint_8 _usb_device_deinit_endpoint(_usb_device_handle, uint_8, uint_8);

void  _usb_print( _usb_device_handle handle);

#ifdef USB_TASKLET
extern void usb_TrCompleteTaskletHandler(unsigned long data);
#endif

void service_ep0
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void service_ep1
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void service_ep2
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void service_ep3
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void reset_ep0
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void service_suspend
(
    _usb_device_handle   handle,
    boolean              setup,
    uint_8               direction,
    uint_8_ptr           buffer,
    uint_32              length,
    uint_8               error
    );
void service_speed_detection
(
    _usb_device_handle   handle,
    uint_32              speed
    );


#ifdef __cplusplus
}
#endif

#endif


#endif
/* EOF */

