#ifndef __mqx_arc_h__
#define __mqx_arc_h__
/* ###########################################################################
# (c) Copyright Conexant Limited 2006
#
# Conexant Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Limited ("Conexant").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Conexant.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Conexant.  If you have not entered into a
# confidentiality agreement with Conexant granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@conexant.com
# ##########################################################################*/

/**HEADER*********************************************************
-----------------------------------------------------------------------------
 CONFIDENTIAL AND PROPRIETARY INFORMATION OF TRANSDIMENSION, INC. AND/OR ITS
 WHOLLY OWNED SUBSIDIARY SOFTCONNEX TECHNOLOGIES, INC. THIS NOTICE IS NOT TO
 BE DELETED, MODIFIED, MOVED OR CHANGED IN ANY WAY.

 (TransDimension, Inc. and SoftConnex Technologies, Inc. are referred to
 collectively below as TransDimension, Inc.) 
 Copyright (c) 1999 - 2004 by TransDimension, Inc. 

 This software is protected by copyright laws and international copyright 
 treaties, as well as other intellectual property laws and treaties.  This
 software is a CONFIDENTIAL, unpublished work of authorship, and with portions 
 constituting TRADE SECRETS of TransDimension, Inc..  Any unauthorized use, 
 disclosure, and/or reproduction of this software, or any part of this software;
 or distribution of this software in any form or by any means; or storage of 
 this software in any database or retrieval system, without the express written
 consent of, and license from, TransDimension, Inc. is strictly prohibited.  
 This software is protected under the copyright and/or trade secret laws in 
 other countries in addition to USA.  All Rights Reserved.  Failure to abide by
 the use, disclosure and/or reproduction restrictions may result in civil and
 or criminal penalties, and will be prosecuted to the maximum extent of the law.
 -------------------------------------------------------------------------------

*** Description:      
***  This file contains ARC-specifc defins with MQX RTOS.
***                                                               
**************************************************************************
**END*********************************************************/


#include "mqx.h"
#include "cache.h"

#define _disable_interrupts()                _int_disable()
#define _enable_interrupts()                 _int_enable()

typedef  uint_32  VUSB_REGISTER;
#define  BSP_MAX_USB_DRIVERS                 (1)
#define  BSP_VUSB20_HOST_BASE_ADDRESS0       (0xFC5100)
#define  BSP_VUSB20_HOST_VECTOR0             (5)
#define  ARC_JMP_TO_ADDR_INSTRN              ((uint_32)(0x381F0000))

#define  BSP_VUSB20_DEVICE_BASE_ADDRESS0     (0xFC5100)
#define  BSP_VUSB20_DEVICE_VECTOR0           (5)
#define  ARC_JMP_TO_ADDR_INSTRN              ((uint_32)(0x381F0000))

#define  BSP_VUSB20_OTG_BASE_ADDRESS0        (0xFC5100)
#define  BSP_VUSB20_OTG_VECTOR0              (5)
#define  BSP_VUSB20_OTG_USB_OFFSET           (0x70)

/* The ARC is little-endian, just like USB */
#define USB_uint_16_low(x)          ((x) & 0xFF)
#define USB_uint_16_high(x)         (((x) >> 8) & 0xFF)

#include "devapi.h"
#include "usbprv_dev.h"

/*
**
** Low-level function list structure for USB
**
** This is the structure used to store chip specific functions to be called 
** by generic layer
*/
typedef struct usb_chip_function_struct
{
   /* The device number */
   uint_32             DEV_NUM;

   /* The Host/Device init function */
   uint_8   (_CODE_PTR_ DEV_INIT)(uint_8, _usb_device_handle);

   /* The function to send data */
   uint_8 (_CODE_PTR_ DEV_SEND)(_usb_device_handle, XD_STRUCT_PTR);

   /* The function to receive data */
   uint_8 (_CODE_PTR_ DEV_RECV)(_usb_device_handle, XD_STRUCT_PTR);
   
   /* The function to cancel the transfer */
   uint_8 (_CODE_PTR_ DEV_CANCEL_TRANSFER)(_usb_device_handle, uint_8, uint_8);
   
   uint_8 (_CODE_PTR_ DEV_INIT_ENDPOINT)(_usb_device_handle, XD_STRUCT_PTR);
   
   uint_8 (_CODE_PTR_ DEV_DEINIT_ENDPOINT)(_usb_device_handle, uint_8, uint_8);
   
   void (_CODE_PTR_ DEV_UNSTALL_ENDPOINT)(_usb_device_handle, uint_8, uint_8);
   
   uint_8 (_CODE_PTR_ DEV_GET_ENDPOINT_STATUS)(_usb_device_handle, uint_8);
   
   void (_CODE_PTR_ DEV_SET_ENDPOINT_STATUS)(_usb_device_handle, uint_8, uint_8);

   void (_CODE_PTR_ DEV_RESET_DATA_TOGGLE)(_usb_device_handle, uint_8, uint_8);

   uint_8 (_CODE_PTR_ DEV_GET_TRANSFER_STATUS)(_usb_device_handle, uint_8, uint_8);
   
   void (_CODE_PTR_ DEV_SET_ADDRESS)(_usb_device_handle, uint_8);
   
   void (_CODE_PTR_ DEV_SHUTDOWN)(_usb_device_handle);
   
   void (_CODE_PTR_ DEV_GET_SETUP_DATA)(_usb_device_handle, uint_8, uchar_ptr);
   
   void (_CODE_PTR_ DEV_ASSERT_RESUME)(_usb_device_handle);
   
   void (_CODE_PTR_ DEV_STALL_ENDPOINT)(_usb_device_handle, uint_8, uint_8);
} USB_CALLBACK_FUNCTIONS_STRUCT, _PTR_ USB_CALLBACK_FUNCTIONS_STRUCT_PTR;


extern USB_CALLBACK_FUNCTIONS_STRUCT _bsp_usb_callback_table;

extern uint_8 _usb_driver_install(uint_32, pointer);

#endif
