/****************************************************************************
 * linux/drivers/usb/gadget/udc-cnxt.h
 *
 * Copyright (C) 2008 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *
 ****************************************************************************/

/****************************************************************************
 * $Header: $
 ****************************************************************************/

#ifndef _ASM_ARCH_USB
#define _ASM_ARCH_USB

#include <linux/usb_otg.h>


/* IRQ definations has to be defined in common header */
#define IRQ_USB0	13
#define IRQ_USB1    17
#define IRQ_USB2    20


/*  No required for UDC0 #ifdef CONFIG_EHCI_CNXT_3CTRLER  */
#define ASX_USB0_VIRT	(0xE8000000) 
#define ASX_USB1_VIRT	(0xE8001000)
#define ASX_USB2_VIRT	(0xE8002000)
/* #endif */

#ifdef CONFIG_EHCI_CNXT_2CTRLER
#define ASX_USB0_VIRT	(0xE0530000)  
#define ASX_USB1_VIRT	(0xE0531000)
#endif


#define USB_CMD_REG 0xe8000140
#define USB_STS_REG 0xe8000144
#define USB_INE_REG 0xe8000148
#define USB_FRI_REG 0xe800014C
#define USB_CTL_SEG 0xe8000150
#define USB_DEVADDR_REG 0xe8000154
#define USB_ENPLISTADDR_REG 0xe8000158
#define USB_TTL_REG 0xe800015C

#define USB_BUR_REG 0xe8000060
#define USB_TXF_REG 0xe8000164

#define USB_ENPNAK_REG 0xe8000178
#define USB_ENPNAK_EN_REG 0xe800017C

#define USB_COF_REG 0xe8000180
#define USB_PST_REG 0xe8000184
#define USB_OTGSC_REG 0xe80001a4
#define USB_USM_REG 0xe80001a8

#define USB_ENPTSETUPSTAT_REG 0xe80001aC
#define USB_ENPTPRIME_REG 0xe80001b0
#define USB_ENPTFLUSH_REG 0xe80001b4
#define USB_ENPTSTAT_REG 0xe80001b8
#define USB_ENPTCOMPLETE_REG 0xe80001bC
#define USB_ENPTCTRL0_REG 0xe80001C0 
#define USB_ENPTCTRL1_REG 0xe80001C4 
#define USB_ENPTCTRL2_REG 0xe80001C8 
#define USB_ENPTCTRL3_REG 0xe80001CC 


#define USB_CAP_LEN 0xe8000100
#define USB_HCI_VER 0xe8000102
#define USB_HSCPARM 0xe8000104
#define USB_HCCPARM 0xe8000108
#define USB_DCI_VER 0xe8000120
#define USB_DCCPARM 0xe8000124




#define CMD_ITC_1   (1<<16)		/* interrupt threshold control */

#define CNXT_USB_CAP_OFFSET (0x100)

static const char	hcd_name_cnxt [] = "ehci_cnxt";

#define INQUIRY_CMD_LEN_MAX		36
#define READ_FORMAT_CAP_CMD_LEN_MAX  12
#define READ_CAP_CMD_LEN_MAX  8


/* SCSI commands that we recognize */
#define SC_FORMAT_UNIT			0x04
#define SC_INQUIRY			0x12
#define SC_MODE_SELECT_6		0x15
#define SC_MODE_SELECT_10		0x55
#define SC_MODE_SENSE_6			0x1a
#define SC_MODE_SENSE_10		0x5a
#define SC_PREVENT_ALLOW_MEDIUM_REMOVAL	0x1e
#define SC_READ_6			0x08
#define SC_READ_10			0x28
#define SC_READ_12			0xa8
#define SC_READ_CAPACITY		0x25
#define SC_READ_FORMAT_CAPACITIES	0x23
#define SC_RELEASE			0x17
#define SC_REQUEST_SENSE		0x03
#define SC_RESERVE			0x16
#define SC_SEND_DIAGNOSTIC		0x1d
#define SC_START_STOP_UNIT		0x1b
#define SC_SYNCHRONIZE_CACHE		0x35
#define SC_TEST_UNIT_READY		0x00
#define SC_VERIFY			0x2f
#define SC_WRITE_6			0x0a
#define SC_WRITE_10			0x2a
#define SC_WRITE_12			0xaa

/* SCSI Sense Key/Additional Sense Code/ASC Qualifier values */
#define SS_NO_SENSE				0
#define SS_COMMUNICATION_FAILURE		0x040800
#define SS_INVALID_COMMAND			0x052000
#define SS_INVALID_FIELD_IN_CDB			0x052400
#define SS_LOGICAL_BLOCK_ADDRESS_OUT_OF_RANGE	0x052100
#define SS_LOGICAL_UNIT_NOT_SUPPORTED		0x052500
#define SS_MEDIUM_NOT_PRESENT			0x023a00
#define SS_MEDIUM_REMOVAL_PREVENTED		0x055302
#define SS_NOT_READY_TO_READY_TRANSITION	0x062800
#define SS_RESET_OCCURRED			0x062900
#define SS_SAVING_PARAMETERS_NOT_SUPPORTED	0x053900
#define SS_UNRECOVERED_READ_ERROR		0x031100
#define SS_WRITE_ERROR				0x030c02
#define SS_WRITE_PROTECTED			0x072700


#endif
/**************************************************************************************
* Modifications:
* $Logs: $
*
***************************************************************************************/

