/****************************************************************************
 * linux/drivers/usb/host/ehci-cnxt.h
 *
 * Copyright (C) 2007 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *
 ****************************************************************************/

/****************************************************************************
 * $Header$
 ****************************************************************************/

#ifndef _ASM_ARCH_USB
#define _ASM_ARCH_USB


/* IRQ definations has to be defined in common header */
#define IRQ_USB0	13
#define IRQ_USB1    17
#define IRQ_USB2    20


#ifdef CONFIG_EHCI_CNXT_3CTRLER
#define ASX_USB0_VIRT	(0xE8000000) 
#define ASX_USB1_VIRT	(0xE8001000)
#define ASX_USB2_VIRT	(0xE8002000)
#endif

#ifdef CONFIG_EHCI_CNXT_2CTRLER
#define ASX_USB0_VIRT	(0xE0530000)  
#define ASX_USB1_VIRT	(0xE0531000)
#endif


#define USB_CMD_REG 0xe8000140
#define USB_STS_REG 0xe8000144
#define USB_INE_REG 0xe8000148
#define USB_FRI_REG 0xe800014C
#define USB_CTL_SEG 0xe8000150
#define USB_PRL_REG 0xe8000154
#define USB_ASY_REG 0xe8000158
#define USB_TTL_REG 0xe800015C

#define USB_BUR_REG 0xe8000060

#define USB_TXF_REG 0xe8000164
#define USB_COF_REG 0xe8000180
#define USB_PST_REG 0xe8000184

#define USB_USM_REG 0xe80001a8

#define USB_CAP_LEN 0xe8000100
#define USB_HCI_VER 0xe8000102
#define USB_HSCPARM 0xe8000104
#define USB_HCCPARM 0xe8000108


#define CMD_ITC_1   (1<<16)		/* interrupt threshold control */

#define CNXT_USB_CAP_OFFSET (0x100)

static const char	hcd_name_cnxt [] = "ehci_cnxt";


#endif
/**************************************************************************************
* Modifications:
* $Logs$
*
***************************************************************************************/

