/******************************************************************************
 * include/asm-arm/arch-nevis/entry-macro.S
 *
 *  Copyright (C) 2007 Conexant Systems Inc, USA.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *
 ****************************************************************************/
/*$Id$
 ****************************************************************************/

/*
 * include/asm-arm/arch-nevis/entry-macro.S
 *
 * Author: Noida
 * Copyright (C) 2006 Conexant inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#include <asm-arm/arch/nevis.h>
/* #define ITC_INTENABLE_REG   0x30450004  Primary Interrupt Status */
/* #define ITC_INTSTATSET_REG  0x30450014  Primary Interrupt Status */
#define MAXIRQNUM 32

                .macro  disable_fiq
                .endm

  .equ itc_intstatset_1, ITC_INTSTATSET_REG(0,0)
  .equ itc_intstatenable_1, ITC_INTENABLE_REG(0,0)
  .equ itc_intstatset_2, ITC_INTSTATSET_REG(0,1)
  .equ itc_intstatenable_2, ITC_INTENABLE_REG(0,1)
  .equ itc_intstatset_3, ITC_INTSTATSET_REG(0,2)
  .equ itc_intstatenable_3, ITC_INTENABLE_REG(0,2)
  .equ itc_intstatset_4, ITC_INTSTATSET_REG(0,3)
  .equ itc_intstatenable_4, ITC_INTENABLE_REG(0,3)

                .macro  get_irqnr_and_base, irqnr, irqstat, base, tmp
        /* Read PIC_0  */
                ldr     \tmp, =itc_intstatset_1
                ldr     \irqstat, [\tmp]
                ldr     \tmp, =itc_intstatenable_1
                ldr     \tmp, [\tmp]
        	and     \irqstat, \irqstat, \tmp
                teq     \irqstat, #0
		beq	1001f
                mov     \irqnr, #0

1100:           movs    \irqstat,\irqstat,lsr #1
                bcs     1101f
                add     \irqnr, \irqnr, #1
                bne     1100b
1101:	        movs    \irqstat, #1   @ Force !Z 
                b  1004f


1001:        /* Read PIC_1 ... */
                ldr     \tmp, =itc_intstatset_2
                ldr     \irqstat, [\tmp]
                ldr     \tmp, =itc_intstatenable_2
                ldr     \tmp, [\tmp]
        	and     \irqstat, \irqstat, \tmp
		teq     \irqstat, #0
                beq      1002f
                mov     \irqnr, #32

1200:           movs    \irqstat,\irqstat,lsr #1
                bcs     1201f
                add     \irqnr, \irqnr, #1
                bne     1200b
1201:	        movs    \irqstat, #1   @ Force !Z 
                b  1004f

                /* Any pending irqs are now in \irqnr */

1002:       /* Read PIC_2 */
                ldr     \tmp, =itc_intstatset_3
                ldr     \irqstat, [\tmp]
                ldr     \tmp, =itc_intstatenable_3
                ldr     \tmp, [\tmp]
        	and     \irqstat, \irqstat, \tmp
		teq     \irqstat, #0
                beq      1003f
                mov     \irqnr, #64

1300:           movs    \irqstat,\irqstat,lsr #1
                bcs     1301f
                add     \irqnr, \irqnr, #1
                bne     1300b
1301:	        movs    \irqstat, #1   @ Force !Z 
                b  1004f

1003:       /* Read PIC_3 */
                ldr \tmp, =itc_intstatset_4
                ldr \irqstat, [\tmp]
                ldr \tmp, =itc_intstatenable_4
                ldr \tmp, [\tmp]
                and \irqstat, \irqstat, \tmp
                teq \irqstat, #0
                beq 1004f
                mov \irqnr, #96

1400:           movs \irqstat,\irqstat,lsr #1
                bcs 1401f
                add \irqnr, \irqnr, #1
                bne 1400b
1401:           movs \irqstat, #1 @ Force !Z 
                b 1004f

        	teq     \irqnr, #0
1004:		/* If No IRQ are set */
                .endm

                .macro  irq_prio_table
                .endm

/**************************************************************************************
* Modifications:
* $Log $
*
***************************************************************************************/








