#ifndef _MEMMAP_H_
#define _MEMMAP_H_

/*
            Fixed Mappings
*/

   // Virtual Addresses 
//#define FLASH_VADDR_BASE     0xF0000000  /* FC00.0000 - FCFF.FFFF */
#define ASX_VADDR_BASE       0xE0000000  /* E000.0000 - E07F.FFFF */
#define EXT_IO_VADDR_BASE    0xE1000000  /* E100.0000 - E17F.FFFF */
#define TEMPEST_VADDR_BASE   0xE4000000  /* E400.0000 - E407.FFFF */
//#define PCI_MEM_VADDR_BASE   0x80000000  /* 8000.0000 - 9FFF.FFFF */
#define APP_VADDR_BASE       0xE8000000  /* 8000.0000 - 9FFF.FFFF */

/* MFB: TODO: remove me */

#define IO_BASE              (ASX_VADDR_BASE)

#define IO_ADDRESS(x)        (((x) & 0x00ffffff) | IO_BASE)

   // Mapping Range 
// AIX_3RDPARTY_CODE_CHANGED
#define FLASH_SIZE           0x04000000 /* aix:js: always map 64MB, else RealSetupROMs will crash */
//#ifdef CONFIG_ED_MAGNUM
//#define FLASH_SIZE           0x04000000
//#else
//#define FLASH_SIZE           0x02000000
//#endif

#define ASX_IO_SIZE          0x01000000 
#define EXT_IO_SIZE          0x01000000 /* EXT IO ecompases PCI IO and ISA IO */
#define TEMPEST_IO_SIZE      0x01000000
#define PCI_MEM_SIZE         0x20000000
#define PCI_IO_SIZE          0x00100000
#define APP_IO_SIZE          0x00040000
#define SHARED_MEM_SIZE      0x00800000

// Physical Addresses 
//#define FLASH_PHYS_BASE      0xF0000000
#define ASX_PHYS_BASE        0xE0000000
#define EXT_IO_PHYS_BASE     0xE1000000 /* Include PCI IO and ISA IO */
#define TEMPEST_PHYS_BASE    0xE4000000
#define PCI_MEM_PHYS_BASE    0x80000000
#define APP_PHYS_BASE        0xE8000000
#define SHARED_MEM_PHYS_BASE 0x0F800000

extern unsigned long KAL_mem_phys_base;
extern unsigned long KAL_mem_size;

#define KAL_MEM_PHYS_BASE    KAL_mem_phys_base
#define KAL_MEM_SIZE         KAL_mem_size

#endif

