/********************************************************************************
 *  linux/include/asm-arm/arch-pecos/memory.h
 *
 *  Copyright (C) 2007 Conexant Systems Inc.
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *
 *********************************************************************************/
/*$Id: memory.h,v 1.4, 2007-07-23 14:31:47Z, Naveen Burmi$
 *********************************************************************************/

#ifndef __ASM_ARCH_MEMORY_H
#define __ASM_ARCH_MEMORY_H

/*
 * Task size: 1GB
 */
#define TASK_SIZE	UL(0x7f000000) 
/*
#define TASK_SIZE	UL(0x40000000)
#define TASK_SIZE_26	UL(0x04000000)
*/

#define TASK_UNMAPPED_BASE (PAGE_ALIGN((TASK_SIZE + 0x10000000) / 3))

/*
 * Page offset: 1GB
 */
#define PHYS_OFFSET	(0x00000000)
#define PAGE_OFFSET     (PHYS_OFFSET + 0x80000000)

/*
 * On brazos and trinity, the dram is contiguous
 */
#define __virt_to_phys__is_a_macro
#define __virt_to_phys(vpage) ((vpage) - PAGE_OFFSET + PHYS_OFFSET)
#define __phys_to_virt__is_a_macro
#define __phys_to_virt(ppage) ((ppage) + PAGE_OFFSET - PHYS_OFFSET)

/*
 * Virtual view <-> DMA view memory address translations
 * virt_to_bus: Used to translate the virtual address to an
 *              address suitable to be passed to set_dma_addr
 * bus_to_virt: Used to convert an address for DMA operations
 *              to an address that the kernel can use.
 */
#define __virt_to_bus__is_a_macro
#define __virt_to_bus(x)	__virt_to_phys(x)
#define __bus_to_virt__is_a_macro
#define __bus_to_virt(x)	__phys_to_virt(x)

/*
 * Given a physical address, convert it to a node id.
 */
#define PHYS_TO_NID(addr)	(0)

#endif

/**************************************************************************************
 * Modifications:
 * $Log:
 *  5    Linux_SDK 1.4         7/23/2007 8:01:47 PM   Naveen Burmi    CR[s]
 *       29260 30015 30014 : Now KAL memory area is part of linux kernel. Hence
 *       page descriptors will get generated for KAL memory area. Even though
 *       KAL memory area is part of linux kernel but it will be reserved and
 *       exclusively available for cnxt heap manager. 
 *  4    Linux_SDK 1.3         7/2/2007 7:26:44 PM    Naveen Burmi    CR[s]
 *       29139 29652 : Now, Linux kernel memory is increased to 256MB.
 *  3    Linux_SDK 1.2         5/10/2007 10:06:14 PM  Yogesh Gaur     Relocated
 *       Linux Kernel above 256M.
 *  2    Linux_SDK 1.1         3/27/2007 5:40:42 PM   Satpal Parmar   GPL
 *       header and starteam footer addition.
 *  1    Linux_SDK 1.0         3/1/2007 10:48:22 PM   Vineet Seth     
 * $
 *
 **************************************************************************************/









