/***********************************************************************************************
 *  linux/include/asm-arm/arch-pecos/vmalloc.h
 *
 *  Copyright (C) 2007 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 ************************************************************************************************/
/*$Id: vmalloc.h,v 1.6, 2007-07-23 14:32:03Z, Naveen Burmi$
 ************************************************************************************************/


/*
 * Just any arbitrary offset to the start of the vmalloc VM area: the
 * current 8MB value just means that there will be a 8MB "hole" after the
 * physical memory until the kernel virtual memory starts.  That means that
 * any out-of-bounds memory accesses will hopefully be caught.
 * The vmalloc() routines leaves a hole of 4kB between each vmalloced
 * area for the same reason. ;)
 */

#define VMALLOC_OFFSET    (8*1024*1024)
#define VMALLOC_START     (MODULE_END + VMALLOC_OFFSET + 0x10000000)
#define VMALLOC_END       (MODULE_END + 0x30000000 - VMALLOC_OFFSET)

/**************************************************************************************
 * Modifications:
 * $Log:
 *  7    Linux_SDK 1.6         7/23/2007 8:02:03 PM   Naveen Burmi    CR[s]
 *       29260 30015 30014 : Now KAL memory area is part of linux kernel. Hence
 *       page descriptors will get generated for KAL memory area. Even though
 *       KAL memory area is part of linux kernel but it will be reserved and
 *       exclusively available for cnxt heap manager. 
 *  6    Linux_SDK 1.5         5/10/2007 10:06:15 PM  Yogesh Gaur     Relocated
 *       Linux Kernel above 256M.
 *  5    Linux_SDK 1.4         4/3/2007 3:49:08 PM    Naveen Burmi    FLAG
 *       "NEW_KAL_MEM" removed. Defined the appropriate values for
 *       VMALLOC_START and VMALLOC_END.
 *  4    Linux_SDK 1.3         3/30/2007 11:48:50 PM  Naveen Burmi    "#if
 *       NEW_KAL_MEM" replaced with "#ifdef NEW_KAL_MEM".
 *  3    Linux_SDK 1.2         3/30/2007 4:43:19 PM   Naveen Burmi    changed
 *       the settings for VMALLOC address range
 *  2    Linux_SDK 1.1         3/27/2007 5:40:59 PM   Satpal Parmar   GPL
 *       header and starteam footer addition.
 *  1    Linux_SDK 1.0         3/1/2007 10:48:30 PM   Vineet Seth     
 * $
 *
 **************************************************************************************/








