/********************************************************************************
 *  linux/include/asm-arm/arch-bronco/io.h
 *
 *  Copyright (C) 2004 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *********************************************************************************/
/*$Id: io.h,v 1.2, 2007-09-07 00:36:14Z, Miles Bintz$
 *********************************************************************************/

#ifndef __ASM_ARM_ARCH_IO_H
#define __ASM_ARM_ARCH_IO_H

#include <asm/cpu-single.h>
#define IO_SPACE_LIMIT 0xffffffff

/*
 * Generic virtual read/write
 */

#define __io(a)               ((void __iomem *)(a))
//#define __arch_getw(a)      (*(volatile unsigned short *) (a))
//#define __arch_putw(b, a)   (*(volatile unsigned short *) (a) = (b))

#define __mem_pci(a)		(a)
#define __mem_isa(a)		(a)


/*
 * Validate the pci memory address for ioremap.
 */
#define iomem_valid_addr(iomem,size)	(1)

/*
 * Convert PCI memory space to a CPU physical address
 */
#define iomem_to_phys(iomem)	(iomem)

/* DMA operations */

extern void v6_dma_inv_range(void *,void *);
extern void v6_dma_clean_range(void *,void *); 
extern void v6_dma_flush_range(void *,void *); 

inline static void dma_cache_inv(unsigned long start, unsigned long size) 
{
	void *_start = (void*) start;
	void *_end = (void*) (start + size);
	v6_dma_inv_range(_start,_end);
}

inline static void dma_cache_wback(unsigned long start, unsigned long size)
{
	void *_start = (void*) start;
	void *_end = (void*) (start + size);
	v6_dma_clean_range(_start,_end);
}

inline static void dma_cache_wback_inv(unsigned long start, unsigned long size)
{
	void *_start = (void*) start;
	void *_end = (void*) (start + size);
	v6_dma_flush_range(_start,_end);
}

#endif

/**************************************************************************************
 * Modifications:
 * $Log:
 *  3    Linux_SDK 1.2         9/7/07 6:06:14 AM IST  Miles Bintz
 *       Modifications to remove warnings
 *  2    Linux_SDK 1.1         3/27/07 5:40:34 PM IST Satpal Parmar   GPL
 *       header and starteam footer addition.
 *  1    Linux_SDK 1.0         3/1/07 10:48:20 PM IST Vineet Seth     
 * $
 *
 **************************************************************************************/

















