/****************************************************************************
 *  include/asm-arm/arch-pecos/system.h
 *
 *  Copyright (C) 2007 Conexant Systems Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 *****************************************************************************/
/*$Id: system.h,v 1.2, 2007-09-07 00:36:14Z, Miles Bintz$
 *****************************************************************************/

#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <asm/io.h>
#include <asm/arch/hardware.h>

extern void cnxt_mip_idle(void);

static inline void arch_idle( void )
{
   /* The 'normal' thing is to call cpu_do_idle();     */
   /* which puts the 1176 in 'wait for interrupt' mode. */
	
   /* FIXME! Implement mipidle stuff from here */
   cnxt_mip_idle();  
}

static inline void arch_reset( char mode )
{
     /* Any write to this register resets the IRD! */
     __raw_writel( 0x1, (void*)ASX_TO_VIRT( RST_SOFTRESET_REG ) );
     while( 1 );
}

#endif

/**************************************************************************************
 * Modifications:
 * $Log:
 *  3    Linux_SDK 1.2         9/7/07 6:06:14 AM IST  Miles Bintz
 *       Modifications to remove warnings
 *  2    Linux_SDK 1.1         3/27/07 5:40:54 PM IST Satpal Parmar   GPL
 *       header and starteam footer addition.
 *  1    Linux_SDK 1.0         3/1/07 10:48:29 PM IST Vineet Seth     
 * $
 *
 **************************************************************************************/









