/* ************************************************************* */
/* *        Board software configuration header file           * */
/* ************************************************************* */
/* * This file is automatically generated by the build process * */
/* * from the supplied configuration file. Editing it is,      * */
/* * therefore, completely futile!                             * */
/* ************************************************************* */

#ifndef __BUILD_HWOPTS__
#define __BUILD_HWOPTS__

/*   ***************************************************************  */
/*   *            CONEXANT PROPRIETARY AND CONFIDENTIAL            *  */
/*   *                SOFTWARE FILE/MODULE HEADER                  *  */
/*   *             Conexant Systems Inc. (c) 1998-2008             *  */
/*   *                     All Rights Reserved                     *  */
/*   ***************************************************************  */
/*   *                                                             *  */
/*   * Filename:     HWCONFIG.CFG                                  *  */
/*   *                                                             *  */
/*   *                                                             *  */
/*   * Description:  Hardware Configuration Option Definition File *  */
/*   *                                                             *  */
/*   *                                                             *  */
/*   * Author:       Dave Wilson                                   *  */
/*   *                                                             *  */
/*   ***************************************************************  */
/*   * $Id: hwconfig.cfg 66076 2008-12-01 22:08:45Z swartzwg $  */
/*   ***************************************************************  */

/*   ***********************************************************  */
/*   * Some basic definitions used throughout the config files *  */
/*   ***********************************************************  */
#define YES 1
#define NO 0
#define NEGATIVE 0
#define POSITIVE 1
#define ENABLED 1
#define DISABLED 0
#define PRESENT 1
#define NOT_PRESENT 0
#define AUTOSENSE (-1)
#define HW_NONE NOT_PRESENT
#define FROM_CONFIG (-2)
#define NOT_DETERMINED (-1)
#define INVALID_UNIT (-1)

/*   **************************************************************  */
/*   * GPIO pin definition values (used in hardware config files) *  */
/*   **************************************************************  */

#define GPIO_MASK_PIN_NUMBER 0x00000FFF

#define GPIO_DEVICE_FLAGS_MASK 0x000FF000
#define GPIO_DEVICE_FLAG_PWM 0x00001000

#define GPIO_MASK_DEVICE_ID 0x0FF00000
#define GPIO_DEVICE_ID_INTERNAL 0x00000000
#define GPIO_DEVICE_ID_I2C_1 0x00100000
#define GPIO_DEVICE_ID_I2C_2 0x00200000
#define GPIO_DEVICE_ID_ISA_1 0x00300000
#define GPIO_DEVICE_ID_ISA_2 0x00400000
#define GPIO_DEVICE_ID_DEMOD 0x00500000

#define GPIO_PIN_INPUT_MASK 0x40000000
#define GPIO_PIN_IS_INPUT 0x40000000
#define GPIO_PIN_IS_OUTPUT 0x00000000

#define GPIO_POLARITY_MASK 0x80000000
#define GPIO_NEGATIVE_POLARITY 0x80000000
#define GPIO_POSITIVE_POLARITY 0x00000000

/*   This invalid value may be used to mark an unpopulated GPIO function  */
#define GPIO_INVALID (GPIO_DEVICE_ID_I2C_1+0xFFF)

/*   **************************************************************  */
/*   * PIT bit definition values (used in hardware config files)  *  */
/*   **************************************************************  */
#define PIT_GEN_CLOCK_SYNC 0x00000001
#define PIT_GEN_ASTB 0x00000002
#define PIT_DATA_BURST_WHEN_INDIC 0x00000001
#define PIT_DATA_MEM_BURST 0x00000002
#define PIT_DATA_LOCAL_READ_CACHE 0x00000004
#define PIT_DATA_WRITE_GATHER 0x00000008
#define PIT_DATA_READ_REORDER 0x00000010
#define PIT_INSTR_BUFFER 0x00000001
#define PIT_INSTR_BUFFER_NONCACHE 0x00000002
#define PIT_INSTR_CONCUR_MEMXFER 0x00000004
#define PIT_INSTR_AUTO_POSTLOAD 0x00000008
#define PIT_INSTR_PGTBL_PARLEL_FETCH 0x00000010
#define PIT_INSTR_PARSER_BUF 0x00002000
#define PIT_INSTR_ROM_BUF 0x00004000
#define PIT_INSTR_MEM_BUF 0x00008000
#define PIT_INSTR_AUTO_BUF_REFETCH 0x00010000
#define PIT_INSTR_PREFETCH_INDICATOR 0x00020000

/*   *****************************************************************************  */
/*   * Chip-specific feature definitions.                                        *  */
/*   * These values define the function or implementation of particular blocks   *  */
/*   * of a chip in terms of previous chips using the same implementation. This  *  */
/*   * allows code to be more modular and not tied to one specific product since *  */
/*   * we can define the functionality of a module on a new chip in terms of a   *  */
/*   * previous one if it is the same.                                           *  */
/*   *****************************************************************************  */

/*   *************  */
/*   * CHIP_NAME *  */
/*   *************  */
#define TRINITY 0x417014F1
/*   Note, PECOS A ID should be 0x2427, but actually it is 0x4170 due to a bug; PECOS B ID is correct.   */
#define PECOS 0x242714F1
/*   Note, NEVIS A ID should be 0x2450, but actually it is 0x4170 due to a bug; NEVIS B ID is correct.   */
#define NEVIS 0x245014F1
#define RIDGE 0x245014F1

/*   ************  */
/*   * CPU_TYPE *  */
/*   ************  */
/*   NB: NOT_PRESENT (with value 0) is used as part of this set so do not  */
/*       define a valid CPU type with value 0   */
#define CPU_ARM940T 1
#define CPU_ARM920T 2
#define CPU_ARM926T 3
#define CPU_ARM1176 4


/*******************************************************/
/* Possible values for key(s) MASTER_CPU_TYPE */
/*  <p>The valid values are of CPU_TYPE defined above. The default value is for Trinity.  */
/* End of possible values for key MASTER_CPU_TYPE */
/*******************************************************/

/*   ************  */
/*   * MMU_TYPE *  */
/*   ************  */
#define MMU_TYPE_940T 0
#define MMU_TYPE_920T 1
#define MMU_TYPE_1176 2

/*   ************  */
/*   * L2 CACHE *  */
/*   ************  */
/*  CFG_KEY = L2_CACHE_TYPE  */
/*  ?<p>This parameter controls what kind of L2 cache controller is present in the   */
/*  ?current version of the hardware.  The builds will use this to control which   */
/*  ?type of support to include for the L2 cache hardware that may be present in  */
/*  ?a given device.  */
/*  [  */
/*     ?<p>The valid values include L2_CACHE_TYPE_NONE and L2_CACHE_TYPE_L220.  */
#define L2_CACHE_TYPE_NONE 0
#define L2_CACHE_TYPE_L220 1
#define L2_CACHE_TYPE_A8L2 2
/*     CFG_DEFAULT = L2_CACHE_TYPE_NONE  */
/*  ]  */

/*   *********************************  */
/*   * PCI Configuration Information *  */
/*   *********************************  */

/*   Trinity chips  */
#define PCI_VEND_DEV_ID_TRINITY 0x417014F1
#define PCI_REV_ID_A_TRINITY 0


/*   ************************  */
/*   * Board Vendor Code/ID *  */
/*   ************************  */
#define VENDOR_ARM (-1)
#define CONEXANT 0
#define CNXT 0

#define VENDOR_ID_MASK 0x780
#define VENDOR_ID_SHIFT 7

/*   **************************************  */
/*   * Generic Config Bit Definitions for *  */
/*   * accessing register as a DWORD      *  */
/*   **************************************  */
#define RSO_VENDOR_ID 0x00000780
#define RSO_ROM0_WIDTH 0x18000000
#define RSO_DBGREQ_ACK 0x20000000
#define RSO_6_CHAN_AUDIO 0x40000000
#define RSO_PLL_BYPASS 0x80000000
#define RSO_PLL_BYPASS_CLK_SEL 0x00800000
#define RSO_ROM0_XOE_MASK 0x01000000

#define RSO_ROM0_SHIFT 27
#define RSO_ROM0_32BIT 0
#define RSO_ROM0_16BIT 2
#define RSO_ROM0_8BIT 1

#define CS0DEFAULT_MASKED 1
#define CS0DEFAULT_UNMASKED 0

#define ROM0WIDTH_32 0
#define ROM0WIDTH_8 1
#define ROM0WIDTH_16 2
#define ROM0WIDTH_32_ALT 3

#define AUDCHANNELS_6 0
#define AUDCHANNELS_2 1

#define PLLBYPASS_BYPASS 0
#define PLLBYPASS_NOBYPASS 1

/*   ***************************************************  */
/*   *  HSX Arbiter - controls priorities on HSX bus   *  */
/*   ***************************************************  */
#define HSX_ARBITER_NONE 0
#define HSX_ARBITER_TRINITY TRINITY

/*   **********************************************  */
/*   * Config file keys and valid values for each *  */
/*   **********************************************  */

/*   ****************************************************  */
/*   * Processor- and Chip-specific Configuration Items *  */
/*   ****************************************************  */


/*******************************************************/
/* Possible values for key(s) PAGE_TABLE_INITIALIZATION */
#define PHYSICAL_RAM 0
#define VIRTUAL_SECTION_FORMAT 1
/* End of possible values for key PAGE_TABLE_INITIALIZATION */
/*******************************************************/

/*   **********************************************  */
/*   * Overrides and hardware problem workarounds *  */
/*   **********************************************  */
/*******************************************************/
/* Possible values for key(s) OVERRIDE_ACTUAL_TARGET_RAM_SIZE */
/*  <p>Valid walues are YES or NO. If set to YES, GetRAMSize reports the system  */
/*   RAM size according to the value of the RAM_SIZE_OVERRIDE config key.  */
/* End of possible values for key OVERRIDE_ACTUAL_TARGET_RAM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) RAM_SIZE_OVERRIDE */
/*  <p>Valid walues are integers reporesenting the number of kilobytes of RAM  */
/*   that will be reported by the GetRAMSize function (regardless of the amount  */
/*   that is actually detected on the target). If the RAM detected is smaller  */
/*   than the value defined here, the actual RAM size will be returned.  */
/* End of possible values for key RAM_SIZE_OVERRIDE */
/*******************************************************/

/*   **********************************************  */
/*   * RAM PHYSICAL BASE ADDRESS OVERRIDE         *  */
/*   **********************************************  */
/*******************************************************/
/* Possible values for key(s) OVERRIDE_PHYS_RAM_BASE */
/*  <p>Valid walues are YES or NO. If set to YES, the physical ram base  */
/*   address will start with the value of the RAM_BASE_OVERRIDE config key.  */
/* End of possible values for key OVERRIDE_PHYS_RAM_BASE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) RAM_BASE_OVERRIDE */
/*  <p>Valid walues are 32bits of RAM address  */
/* End of possible values for key RAM_BASE_OVERRIDE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ARM9_RESET_ADDR */
/*  <p>Valid walues are normally 0x10000 or 0x08010000  */
/* End of possible values for key ARM9_RESET_ADDR */
/*******************************************************/
/*   ****************************************************  */
/*   * Board- and IRD-specific Configuration Items      *  */
/*   ****************************************************  */


/*******************************************************/
/* Possible values for key(s) SRAMWA */
/*  <p>The SRAM WorkAround is disabled by default.  */
/* End of possible values for key SRAMWA */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TRINITY_A_DDR_FIB */
/*  <p>Valid values are YES and NO. By default, it is assumed that the Trinity does not have the FIB applied.  */
/* End of possible values for key TRINITY_A_DDR_FIB */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SD_SELECT_GPIO */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*   defined at the top of HWCONFIG.CFG or GPIO_INVALID if no GPIO is used to  */
/*   indicate the mode.  */
/* End of possible values for key SD_SELECT_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SD_YPRPB_RGB_SELECT_GPIO */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*   defined at the top of HWCONFIG.CFG or GPIO_INVALID if no GPIO is used to  */
/*   indicate the mode.  */
/* End of possible values for key SD_YPRPB_RGB_SELECT_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CABLECARD_DRIVER_INCLUDE */
/*  <p>Valid values are YES and NO. By default, it is assumed that Podo is not connected.  */
/* End of possible values for key CABLECARD_DRIVER_INCLUDE */
/*******************************************************/

/*   ** POD (Cablecard) Vpp control pins: 3.3 v if CTRL_1 = low & CTRL_2 = high, 5 v if CTRL_2 = low & CTRL_1 = high   */

/*******************************************************/
/* Possible values for key(s) POD_VPP_CTRL_1_GPIO */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*   defined at the top of HWCONFIG.CFG or GPIO_INVALID if no GPIO is used to  */
/*   indicate the mode.  */
/* End of possible values for key POD_VPP_CTRL_1_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) POD_VPP_CTRL_2_GPIO */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*   defined at the top of HWCONFIG.CFG or GPIO_INVALID if no GPIO is used to  */
/*   indicate the mode.  */
/* End of possible values for key POD_VPP_CTRL_2_GPIO */
/*******************************************************/

/*    */
/*   DDR default bringup values  */
/*    */

/*******************************************************/
/* Possible values for key(s) DDR_MEM_TYPE */
#define DDR_TYPE_128MBIT_X8 1
#define DDR_TYPE_256MBIT_X8 2
#define DDR_TYPE_512MBIT_X8 3
#define DDR_TYPE_1GBIT_X8 4
#define DDR_TYPE_128MBIT_X16 5
#define DDR_TYPE_256MBIT_X16 6
#define DDR_TYPE_512MBIT_X16 7
#define DDR_TYPE_1GBIT_X16 8
#define DDR2_667D_CL5_512MBIT 9
#define DDR2_667D_CL5_1GBIT 10
/* End of possible values for key DDR_MEM_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DDR_DELAY_REG_DEFAULT */
/*  <p>A valid delay value for current IRD's memory controller.  */
/* End of possible values for key DDR_DELAY_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DDR_CNTL_REG_DEFAULT */
/*  <p>A valid value for current IRD's Memory Controller Control Register.  */
/* End of possible values for key DDR_CNTL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DDR_TILE_WIDTH */
#define DDR_TILE_WIDTH_32 32
#define DDR_TILE_WIDTH_64 64
#define DDR_TILE_WIDTH_128 128
#define DDR_TILE_WIDTH_256 256
/* End of possible values for key DDR_TILE_WIDTH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DDR_TILE_HEIGHT */
#define DDR_TILE_HEIGHT_8 8
#define DDR_TILE_HEIGHT_16 16
#define DDR_TILE_HEIGHT_32 32
#define DDR_TILE_HEIGHT_64 64
/* End of possible values for key DDR_TILE_HEIGHT */
/*******************************************************/

/*    */
/*    */
/*    */


/*******************************************************/
/* Possible values for key(s) PLL_CONFIG0_REG_DEFAULT */
/*  <p>A valid PLL_CONFIG0_REG_DEFAULT value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_CONFIG0_REG_DEFAULT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PLL_PIN_ALT_FUNC_REG_DEFAULT */
/*  <p>A valid PLL_PIN_ALT_FUNC_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_ALT_FUNC_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX0_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX0_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX0_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX1_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX1_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX1_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX2_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX2_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX2_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX3_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX3_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX3_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX4_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX4_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX4_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_PIN_GPIO_MUX5_REG_DEFAULT */
/*  <p>A valid PLL_PIN_GPIO_MUX5_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_PIN_GPIO_MUX5_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX0_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX0_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX1_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX1_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX2_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX2_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX3_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX3_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX4_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX4_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SREG_2ND_PIN_MUX5_REG_DEFAULT */
/*  <p>A valid value for the secondary pin mux reg, or NOT_DETERMINED.  */
/* End of possible values for key SREG_2ND_PIN_MUX5_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX0_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX0_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX0_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX1_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX1_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX1_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX2_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX2_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX2_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX3_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX3_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX3_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX4_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX4_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX4_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PLL_2ND_PIN_MUX5_REG_DEFAULT */
/*  <p>A valid PLL_2ND_PIN_MUX5_REG value for current IRD or NOT_DETERMINED if not yet determined.  */
/* End of possible values for key PLL_2ND_PIN_MUX5_REG_DEFAULT */
/*******************************************************/

/*   ******************************  */
/*   * PIT Configuration          *  */
/*   ******************************  */

/*******************************************************/
/* Possible values for key(s) HSX_PIT_GENERAL_REG_DEFAULT */
/*  <p>A description of the General PIT settings using combinations of the PIT_GEN_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_GENERAL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HSX_PIT_DATA_REG_DEFAULT */
/*  <p>A description of the General PIT settings using combinations of the PIT_DATA_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_DATA_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HSX_PIT_INSTR_REG_DEFAULT */
/*  <p>A description of the General PIT settings using combinations of the PIT_INSTR_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_INSTR_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HSX_PIT_GENERAL_REG_DEFAULT_DEBUG */
/*  <p>A description of the General PIT settings using combinations of the PIT_GEN_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_GENERAL_REG_DEFAULT_DEBUG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HSX_PIT_DATA_REG_DEFAULT_DEBUG */
/*  <p>A description of the General PIT settings using combinations of the PIT_DATA_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_DATA_REG_DEFAULT_DEBUG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HSX_PIT_INSTR_REG_DEFAULT_DEBUG */
/*  <p>A description of the General PIT settings using combinations of the PIT_INSTR_XXX   */
/*  labels defined at the top of HWCONFIG.CFG  */
/* End of possible values for key HSX_PIT_INSTR_REG_DEFAULT_DEBUG */
/*******************************************************/


/*   ******************************  */
/*   * RAM type and configuration *  */
/*   ******************************  */

/*******************************************************/
/* Possible values for key(s) DDR_CONFIG */
#define DDR_CONFIG_EMPTY 0
#define DDR_CONFIG_2RAMS_16MB_64MBIT 1
#define DDR_CONFIG_2RAMS_32MB_128MBIT 2
#define DDR_CONFIG_2RAMS_64MB_256MBIT 3
#define DDR_CONFIG_2RAMS_128MB_512MBIT 4
#define DDR_CONFIG_2RAMS_256MB_1024MBIT 5
/*  <p><b><i>What is the correct default value? The original HWCONFIG.H did not set a default.</i></b>  */
/* End of possible values for key DDR_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) RAM_BUS_WIDTH */
#define RAM_BUS_32BITS_WIDE 0
#define RAM_BUS_16BITS_WIDE 1
#define RAM_BUS_32BITS_WIDE_FORCED 2
#define RAM_BUS_16BITS_WIDE_FORCED 3
/* End of possible values for key RAM_BUS_WIDTH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DDR_CNTL_RD_VALID_SELECT */
#define READ_VALID_N_MINUS_3 0
#define READ_VALID_N_MINUS_2 1
#define READ_VALID_N_MINUS_1 2
#define READ_VALID_EARLIEST 3
/* End of possible values for key DDR_CNTL_RD_VALID_SELECT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CODELDR_RAM_BASE */
/*  <p>See description above  */
/* End of possible values for key CODELDR_RAM_BASE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) EMULATION_LEVEL */
#define PID7T 1
#define PHASE2 2
#define PHASE3 3
#define FINAL_HARDWARE 4
/* End of possible values for key EMULATION_LEVEL */
/*******************************************************/

/*   ******************************  */
/*   * ROM type and configuration *  */
/*   ******************************  */

/*******************************************************/
/* Possible values for key(s) FLASH_ALGORITHM_SUPPORT */
#define FLASH_ALGORITHM_ALL 0
#define FLASH_ALGORITHM_INTEL 1
#define FLASH_ALGORITHM_AMD 2

/* End of possible values for key FLASH_ALGORITHM_SUPPORT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FLASH_PART0 */
#define FLASH_ALL_PARTS 0
#define FLASH_NONE 0xFFFF

#define FLASH_INT_28F800B 0x0100
#define FLASH_INT_28F008B 0x0101
#define FLASH_INT_28F800F3 0x0101
#define FLASH_INT_28F160F3 0x0102
#define FLASH_INT_28F160C3 0x0103
#define FLASH_INT_28F320C3 0x0104
#define FLASH_INT_28F320J3 0x0105
#define FLASH_INT_28F640J3 0x0106
#define FLASH_INT_28F128J3 0x0107

#define FLASH_AMD_29F800BB 0x0200
#define FLASH_AMD_29PL160CB 0x0201
#define FLASH_AMD_29LV160DB 0x0202
#define FLASH_AMD_29LV160DT 0x0203
#define FLASH_AMD_29LV200BB 0x0204
#define FLASH_AMD_29LV200BT 0x0205
#define FLASH_AMD_29LV641D 0x0206

#define FLASH_FUJ_29PL160BD 0x0400
#define FLASH_FUJ_29PL160TD 0x0401
#define FLASH_FUJ_29LV160B 0x0402
#define FLASH_FUJ_29LV160T 0x0403
#define FLASH_FUJ_29DL324BD 0x0404
#define FLASH_FUJ_29DL324TD 0x0405
#define FLASH_FUJ_29LV160BE 0x0406

#define FLASH_SST_39VF160 0x0800

#define FLASH_ATMEL_AT49BV32X 0x1000
#define FLASH_ATMEL_AT49BV32XT 0x1001
#define FLASH_ATMEL_AT49LV1614 0x1002

#define FLASH_ST_M29W160DB 0x2000
#define FLASH_ST_M58LW032D 0x2001

#define FLASH_TOSH_TC58VB160FT 0x4000

#define FLASH_MAC_MX29LV320BTC 0x8001

/* End of possible values for key FLASH_PART0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FLASH_PART1 */
/*  <p>Default to none assuming flash_part0 is defaults to FLASH_ALL_PARTS  */
/* End of possible values for key FLASH_PART1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FLASH_PART2 */
/*  <p>Default to none assuming flash_part0 is defaults to FLASH_ALL_PARTS  */
/* End of possible values for key FLASH_PART2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FLASH_PART3 */
/*  <p>Default to none assuming flash_part0 is defaults to FLASH_ALL_PARTS  */
/* End of possible values for key FLASH_PART3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FLASH_PART4 */
/*  <p>Default to none assuming flash_part0 is defaults to FLASH_ALL_PARTS  */
/* End of possible values for key FLASH_PART4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FLASH_PEN */
/*  <p>Most STB's have the program-flash signal tied high.  By default, this  */
/*  signal is not used.  */
/* End of possible values for key PIO_FLASH_PEN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FLASH_PEN2 */
/*  <p>Most STB's have the program-flash signal tied high.  By default, this  */
/*  signal is not used.  */
/* End of possible values for key PIO_FLASH_PEN2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ROM_SIZE */
/*  <p>Valid values are integers which are multiples of 64KB (65536) and which  */
/*  are less than or equal to the total size of flash installed.  */
/* End of possible values for key ROM_SIZE */
/*******************************************************/

/*   *************************************  */
/*   *       Video Encoder Options       *  */
/*   *************************************  */



/*******************************************************/
/* Possible values for key(s) HAS_HDMI */
/*  <p>Set to YES or NO to indicate whether the box has HDMI or not.  */
/* End of possible values for key HAS_HDMI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HDMI_HOTPLUG_INTERRUPT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key HDMI_HOTPLUG_INTERRUPT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_NUM_DACS */
/*  <p>This is the number of video DACs in Trinity.  */
/* End of possible values for key ENCODER_NUM_DACS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NUM_OUTPUT_VIDEO_CONNECTIONS */
/*  <p>Valid values are 1 or 2.  */
/* End of possible values for key NUM_OUTPUT_VIDEO_CONNECTIONS */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC output selection table                                      *  */
/*   * Video output selection from channel 0 are designated by _0            *  */
/*   * and channel 1 by_1.                                                   *  */
/*   *************************************************************************  */
#define ENCODER_DAC_HD_R_PR 0
#define ENCODER_DAC_HD_G_Y 1
#define ENCODER_DAC_HD_B_PB 2
#define ENCODER_DAC_CVBS_0 3
#define ENCODER_DAC_CVBS_DLY_0 4
#define ENCODER_DAC_Y_SVID_0 5
#define ENCODER_DAC_C_SVID_0 6
#define ENCODER_DAC_SD_Y_0 7
#define ENCODER_DAC_SD_PR_0 8
#define ENCODER_DAC_SD_PB_0 9
#define ENCODER_DAC_SD_R_0 0xa
#define ENCODER_DAC_SD_G_0 0xb
#define ENCODER_DAC_SD_B_0 0xc
#define ENCODER_DAC_CVBS_1 0xd
#define ENCODER_DAC_CVBS_DLY_1 0x0e
#define ENCODER_DAC_Y_SVID_1 0x0f
#define ENCODER_DAC_C_SVID_1 0x10
#define ENCODER_DAC_SD_Y_1 0x11
#define ENCODER_DAC_SD_PR_1 0x12
#define ENCODER_DAC_SD_PB_1 0x13
#define ENCODER_DAC_SD_R_1 0x14
#define ENCODER_DAC_SD_G_1 0x15
#define ENCODER_DAC_SD_B_1 0x16
#define ENCODER_DAC_UHF_CVBS_0 0x17
#define ENCODER_DAC_UHF_CVBS_1 0x18
#define ENCODER_DAC_NICAM_1 0x19
#define ENCODER_DAC_NICAM_2 0x1A
#define ENCODER_DAC_NOT_USED 0x1F

/*   *************************************************************************  */
/*   * Video DAC Mappings in Normal HD mode(non-split mode) when channel 0   *  */
/*   * is driving HD formats( 1080i, 720p, 480p, 576p )                      *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_HD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is HD_G_Y, Dac B is HD_B_PB, Dac C is HD_R_PR  */
/* End of possible values for key ENCODER_HD_MODE_CH0_HD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_HD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_1, Dac E is C_SVID_1, Dac F is Y_SVID_1  */
/* End of possible values for key ENCODER_HD_MODE_CH0_HD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_HD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_1, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_HD_MODE_CH0_HD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_HD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_HD_MODE_CH0_HD_JKL */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC Mappings in Normal HD mode(non-split mode) when channel 0   *  */
/*   * is driving SD formats( 480i, 576i )                                   *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_SD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is SD_Y_0, Dac B is SD_PB_0, Dac C is SD_PR_0  */
/* End of possible values for key ENCODER_HD_MODE_CH0_SD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_SD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_1, Dac E is C_SVID_1, Dac F is Y_SVID_1  */
/* End of possible values for key ENCODER_HD_MODE_CH0_SD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_SD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_1, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_HD_MODE_CH0_SD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_HD_MODE_CH0_SD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_HD_MODE_CH0_SD_JKL */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC Mappings in Dual SD mode, both channel 0 and channel 1 are  *  */
/*   * driving SD formats( 480i, 576i )                                      *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_DUAL_SD_MODE_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is SD_Y_0, Dac B is SD_PB_0, Dac C is SD_PR_0  */
/* End of possible values for key ENCODER_DUAL_SD_MODE_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_DUAL_SD_MODE_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_1, Dac E is C_SVID_0, Dac F is Y_SVID_0  */
/* End of possible values for key ENCODER_DUAL_SD_MODE_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_DUAL_SD_MODE_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_0, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_DUAL_SD_MODE_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_DUAL_SD_MODE_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_DUAL_SD_MODE_JKL */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC Mappings in split mode when channel 0 HD Encoder            *  */
/*   * is driving HD formats( 1080i, 720p, 480p, 576p )                      *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_HD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is HD_G_Y, Dac B is HD_B_PB, Dac C is HD_R_PR  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_HD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_HD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_1, Dac E is C_SVID_0, Dac F is Y_SVID_0  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_HD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_HD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_0, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_HD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_HD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_HD_JKL */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC Mappings in split mode when channel 0                       *  */
/*   * is driving SD formats( 480i, 576i ), HD Encoder is not active         *  */
/*   * in this case                                                          *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_SD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is SD_Y_0, Dac B is SD_PB_0, Dac C is SD_PR_0  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_SD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_SD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_1, Dac E is C_SVID_0, Dac F is Y_SVID_0  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_SD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_SD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_0, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_SD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_MODE_CH0_SD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_MODE_CH0_SD_JKL */
/*******************************************************/

/*   ******************************************************************************************  */
/*   * Video DAC Mappings in split ss(graphics only)mode when channel 0 HD Encoder            *  */
/*   * is driving HD formats( 1080i, 720p, 480p, 576p )                                       *  */
/*   ******************************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_HD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is HD_G_Y, Dac B is HD_B_PB, Dac C is HD_R_PR  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_HD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_HD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_0, Dac E is C_SVID_1, Dac F is Y_SVID_1  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_HD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_HD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_1, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_HD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_HD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_HD_JKL */
/*******************************************************/

/*   *************************************************************************  */
/*   * Video DAC Mappings in split ss mode when channel 0                    *  */
/*   * is driving SD formats( 480i, 576i ), HD Encoder is not active         *  */
/*   * in this case                                                          *  */
/*   *************************************************************************  */
/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_SD_ABC */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac A is SD_Y_1, Dac B is SD_PB_1, Dac C is SD_PR_1  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_SD_ABC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_SD_DEF */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac D is CVBS_0, Dac E is C_SVID_1, Dac F is Y_SVID_1  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_SD_DEF */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_SD_GHI */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac G is CVBS_1, Dac H and I are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_SD_GHI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ENCODER_SPLIT_SS_MODE_CH0_SD_JKL */
/*  <p>the default is set to the DAC configuration in Apex IRD.  */
/*   Dac J K and L are not availabe in Trinity.  */
/* End of possible values for key ENCODER_SPLIT_SS_MODE_CH0_SD_JKL */
/*******************************************************/

/*   *****************************************  */
/*   *       HDCP KEYS STORAGE Options       *  */
/*   *****************************************  */


/*******************************************************/
/* Possible values for key(s) HDCP_KEYS_LOAD_FROM_EXT */
/*  <p>Set to YES or NO to indicate whether the HDCP keys and KSV are stored in flash or not.  */
/* End of possible values for key HDCP_KEYS_LOAD_FROM_EXT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HDCP_KEYS_ADDRESS */
/*  <p>Set to valid address if HDCP_KEYS_LOAD_FROM_EXT is set to YES, or NOT_PRESENT if HDCP_KEYS_LOAD_FROM_EXT is set to NO.  */
/* End of possible values for key HDCP_KEYS_ADDRESS */
/*******************************************************/

/*   ************************************  */
/*   *    Analog Video Decoder Type     *  */
/*   ************************************  */

/*******************************************************/
/* Possible values for key(s) EXTERNAL_DECODER */
#define BT835 835
#define PHILIPS7112 7112
/* End of possible values for key EXTERNAL_DECODER */
/*******************************************************/

/*   ***********************************  */
/*   * Analog/Digital TV Tuner Options *  */
/*   ***********************************  */

/*******************************************************/
/* Possible values for key(s) OREN_NIM_1_HAS_ANALOG_OUTPUT */
/*  <p>Valid values are YES and NO. Set this option to YES if the analog output from the first Oren NIM is connected to a video encoder in the IRD.  */
/* End of possible values for key OREN_NIM_1_HAS_ANALOG_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) OREN_NIM_2_HAS_ANALOG_OUTPUT */
/*  <p>Valid values are YES and NO. Set this option to YES if the analog output from the second Oren NIM is connected to a video encoder in the IRD.  */
/* End of possible values for key OREN_NIM_2_HAS_ANALOG_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24227_1_HAS_ANALOG_OUTPUT */
/*  <p>Valid values are YES and NO. Set this option to YES if the analog output from the first CX24227 NIM is connected to a video encoder in the IRD.  */
/* End of possible values for key CX24227_1_HAS_ANALOG_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24227_2_HAS_ANALOG_OUTPUT */
/*  <p>Valid values are YES and NO. Set this option to YES if the analog output from the second CX24227 NIM is connected to a video encoder in the IRD.  */
/* End of possible values for key CX24227_2_HAS_ANALOG_OUTPUT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NUM_BASEBAND_INPUTS */
/*  <p>Valid values are 0 to 2 inclusive indicating how many physical inputs  */
/*   the box has.  */
/* End of possible values for key NUM_BASEBAND_INPUTS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NUM_SATELLITE_INPUTS */
/*  <p>Valid values are 0 to 3 inclusive indicating how many physical inputs  */
/*   the box has.  */
/* End of possible values for key NUM_SATELLITE_INPUTS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NUM_CABLE_INPUTS */
/*  <p>Valid values are 0 to 1 inclusive indicating how many physical inputs  */
/*   the box has.  */
/* End of possible values for key NUM_CABLE_INPUTS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NUM_TERRESTRIAL_INPUTS */
/*  <p>Valid values are 0 to 1 inclusive indicating how many physical inputs  */
/*   the box has.  */
/* End of possible values for key NUM_TERRESTRIAL_INPUTS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_BASEBAND_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. If connected to pin HS5, correct value is 5.  */
/*   If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_BASEBAND_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_BASEBAND_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. If connected to pin HS5, correct value is 5.  */
/*   If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_BASEBAND_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_BASEBAND_3 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. If connected to pin HS5, correct value is 5.  */
/*   If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_BASEBAND_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_OREN_51132_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. For example, if connected to pin HS5, correct value   */
/*   is 5. If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_OREN_51132_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_OREN_51132_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. For example, if connected to pin HS5, correct value   */
/*   is 5. If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_OREN_51132_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_DEMOD_THIRDPARTY_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. For example, if connected to pin HS5, correct value   */
/*   is 5. If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_DEMOD_THIRDPARTY_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_DEMOD_THIRDPARTY_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the   */
/*   unit is connected to. For example, if connected to pin HS5, correct value   */
/*   is 5. If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key PHYS_UNIT_DEMOD_THIRDPARTY_2 */
/*******************************************************/


/*   *******************************************  */
/*   * Other demod-related general definitions *  */
/*   *******************************************  */
/*******************************************************/
/* Possible values for key(s) DEMOD_0_HSDP_IN */
/*  <p>Any integer value is valid, but this is expected to be small.  */
/* End of possible values for key DEMOD_0_HSDP_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DEMOD_1_HSDP_IN */
/*  <p>Any integer value is valid, but this is expected to be small.  */
/* End of possible values for key DEMOD_1_HSDP_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DEMOD_2_HSDP_IN */
/*  <p>Any integer value is valid, but this is expected to be small.  */
/* End of possible values for key DEMOD_2_HSDP_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MAX_DISEQC_RECEIVE_MSG_SIZE */
/*  <p>Any integer value is valid, but this is expected to be small.  */
/* End of possible values for key MAX_DISEQC_RECEIVE_MSG_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHANTOM_HW_REVISION */
#define PHANTOM_HW_REVISION_A 0
#define PHANTOM_HW_REVISION_B 1
#define PHANTOM_HW_REVISION_ALL 2
/* End of possible values for key PHANTOM_HW_REVISION */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHANTOM_HW_VERSION */
#define PHANTOM_CX24116 0
#define PHANTOM_CX24126 1
/* End of possible values for key PHANTOM_HW_VERSION */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) COBRA_PHANTOM_TO_SINGLE_TUNER */
/*  <p>Set to YES or NO to indicate whether the above mixed demod NIM configuration exists.  */
/* End of possible values for key COBRA_PHANTOM_TO_SINGLE_TUNER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHANTOM_ADDR_FOR_COBRA_TUNER_CNTRL */
/*  <p>Set to the I2C address of the phantom demod that the cobra driver will use to talk to the tuner.  */
/* End of possible values for key PHANTOM_ADDR_FOR_COBRA_TUNER_CNTRL */
/*******************************************************/

/*   ****************************  */
/*   * Audio Capture ADC Params *  */
/*   ****************************  */

/*******************************************************/
/* Possible values for key(s) ACAP_MODE */
/*  <p>The default value is set based on the Conexant Reference IRD  */
#define ACAP_MODE_MONO 0
#define ACAP_MODE_STEREO 1
/* End of possible values for key ACAP_MODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ACAP_FORMAT */
#define ACAP_FORMAT_LEFT_JUST 0
#define ACAP_FORMAT_RIGHT_JUST 1
#define ACAP_FORMAT_I2S 2
/* End of possible values for key ACAP_FORMAT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) ACAP_NUM_BITS */
/*  <p>These are some commonly used sample sizes. Feel free to add to here.  */
#define ACAP_NUM_BITS_16 0
#define ACAP_NUM_BITS_18 2
#define ACAP_NUM_BITS_20 4
/* End of possible values for key ACAP_NUM_BITS */
/*******************************************************/

/*   ***************  */
/*   * USB Control *  */
/*   ***************  */
/*******************************************************/
/* Possible values for key(s) HAS_USB_SERIAL */
/*  <p>Set to YES or NO to indicate whether the box has USB Serial support or not (via external USB RS232 Dongle).  */
/* End of possible values for key HAS_USB_SERIAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) USB_POWER_ENABLE */
#define ALWAYS_ON 1
#define KLONDIKE_CONTROL 2
/* End of possible values for key USB_POWER_ENABLE */
/*******************************************************/

/*   *********************  */
/*   * I2C EEPROM Device *  */
/*   *********************  */


/*******************************************************/
/* Possible values for key(s) EEPROM_TYPE */
#define EEPROM_512B 512
#define EEPROM_8KB 8192
#define EEPROM_16KB 16384
#define EEPROM_32KB 32768
#define EEPROM_64KB 65536
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key EEPROM_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM1_PAGE_SIZE */
/*  <p>The page size can be found in the datasheet for the EEPROM device in   */
/*   use. The default value matches the 32KB devices used in the Apex reference  */
/*   IRD.  */
/* End of possible values for key EEPROM1_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM2_PAGE_SIZE */
/*  <p>The page size can be found in the datasheet for the EEPROM device in   */
/*   use. The default value matches the 32KB devices used in the Apex reference  */
/*   IRD.  */
/* End of possible values for key EEPROM2_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM3_PAGE_SIZE */
/*  <p>The page size can be found in the datasheet for the EEPROM device in   */
/*   use. The default value matches the 32KB devices used in the Apex reference  */
/*   IRD.  */
/* End of possible values for key EEPROM3_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM1_SETUP_TIME */
/*  <p>The setup time ccan be found in the datasheet for the EEPROM device in   */
/*   use. The value is expressed in milliseconds. The default value matches   */
/*   the 32KB devices used in the Apex reference IRD.  */
/* End of possible values for key EEPROM1_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM2_SETUP_TIME */
/*  <p>The setup time ccan be found in the datasheet for the EEPROM device in   */
/*   use. The value is expressed in milliseconds. The default value matches   */
/*   the 32KB devices used in the Apex reference IRD.  */
/* End of possible values for key EEPROM2_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) EEPROM3_SETUP_TIME */
/*  <p>The setup time ccan be found in the datasheet for the EEPROM device in   */
/*   use. The value is expressed in milliseconds. The default value matches   */
/*   the 32KB devices used in the Apex reference IRD.  */
/* End of possible values for key EEPROM3_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_EEPROM1_WRITE_ENABLE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_EEPROM1_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_EEPROM2_WRITE_ENABLE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_EEPROM2_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_EEPROM3_WRITE_ENABLE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_EEPROM3_WRITE_ENABLE */
/*******************************************************/

/*   *****************************  */
/*   * Serial Port Configuration *  */
/*   *****************************  */

/*******************************************************/
/* Possible values for key(s) SERIAL1 */
#define UART_NONE 0
#define INTERNAL_UART1 1
#define INTERNAL_UART2 2
#define INTERNAL_UART3 3
#define TELEGRAPH_UART1 4
#define TELEGRAPH_UART2 5
#define ISA_UART 6
#define MULTIICE 7
#define ETHERNET 8
#define MEMORY 9
#define USB1 11
#define USB2 12
#define USB3 13
/*  (Dual-UART ISA card used for emulation.)  */
/* End of possible values for key SERIAL1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SERIAL2 */
/*  <p>Valid values here are as for SERIAL1.  */
/* End of possible values for key SERIAL2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NUM_AV_DECODERS */
/*  <p>Valid values are 1 to 2 inclusive indicating how many decoders  */
/*   the box has.  */
/* End of possible values for key NUM_AV_DECODERS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TRACE_PORT */
/*  <p>Any value in the valid list for SERIAL1 is valid here along with the   */
/*  following two values which are specific to TRACE_PORT:<br>  */
#define TRACE_MULTIICE 7
#define TRACE_ETHERNET 8
#define TRACE_MEMORY 9
#define TRACE_USB1 11
#define TRACE_USB2 12
#define TRACE_USB3 13
/* End of possible values for key TRACE_PORT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) REDIRECTOR_PORT */
/*  <p>Valid values here are as for SERIAL1.  */
/* End of possible values for key REDIRECTOR_PORT */
/*******************************************************/

/*   *****************  */
/*   * GPIO Extender *  */
/*   *****************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PIO_EXP_TYPE */
#define GPIO_EXTEND_IIC 1
#define GPIO_EXTEND_IO 2
/*  NOT_PRESENT is also valid  */
/* End of possible values for key CNXT_PIO_EXP_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) DEFAULT_PIO_EXP_REG_VALUE */
/*  <p>Valid values depend upon the extender size in use - 0x00 to 0xFF for an  */
/*   8-bit device, 0x0000 to 0xFFFF for a 16-bit device. The default value will  */
/*   turn off all LEDs other than the power LED on a TrinityDVT IRD and ensure  */
/*   that the Oren NIMs are reset and do not hang the I2C bus.  */
/* End of possible values for key DEFAULT_PIO_EXP_REG_VALUE */
/*******************************************************/

/*   See also settings under ISA Descriptors below   */

/*   **********************  */
/*   * Front Panel Keypad *  */
/*   **********************  */

/*******************************************************/
/* Possible values for key(s) FRONT_PANEL_KEYPAD_TYPE */
#define FRONT_PANEL_KEYPAD_LEGACY 0
#define FRONT_PANEL_KEYPAD_NONE 1
#define FRONT_PANEL_KEYPAD_TRINITY 2
#define FRONT_PANEL_KEYPAD_APEX 3
#define FRONT_PANEL_KEYPAD_GPIO 4
#define FRONT_PANEL_KEYPAD_CUSTOM_1 5
#define FRONT_PANEL_KEYPAD_CUSTOM_2 6
#define FRONT_PANEL_KEYPAD_MAGNUM 7
/* End of possible values for key FRONT_PANEL_KEYPAD_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_PANEL_KEYPAD_NUM_ROWS */
/*  <p>The value of this key should be an integer greater than 0.   */
/* End of possible values for key FRONT_PANEL_KEYPAD_NUM_ROWS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_ROW_0 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_ROW_0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_ROW_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_ROW_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_ROW_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_ROW_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_ROW_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_ROW_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_PANEL_KEYPAD_NUM_COLS */
/*  <p>The value of this key should be an integer greater than 0.   */
/* End of possible values for key FRONT_PANEL_KEYPAD_NUM_COLS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_COL_0 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_COL_0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_COL_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_COL_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_COL_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_COL_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_COL_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_COL_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_UP */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */

/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_UP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_DOWN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_DOWN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_LEFT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_LEFT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_RIGHT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_RIGHT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_BACKUP */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_BACKUP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_GUIDE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_GUIDE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_INFO */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_INFO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_SELECT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_SELECT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_POWER */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_POWER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_ACTIVE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_ACTIVE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_FORMAT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_FORMAT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_RESET */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_FUNCTION */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_FUNCTION */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_FRONT_PANEL_KEYPAD_MENU */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_FRONT_PANEL_KEYPAD_MENU */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CODELDR_DEBUG_KEY_CODE */
/*  <p>The value here should be one of the BTN_CODE_xxx definitions as found in the buttons.h header   */
/*   file in the CODELDR directory. Note that you cannot use the labels in the config file since the  */
/*   header containing them will not have been included when the config file is read.  */
/*   <p>The default value is equivalent to BTN_CODE_GUIDE and ensures that the Guide key is used to put   */
/*   the IRD into debug mode with the slave CPU (if any) held in reset.  */
/* End of possible values for key CODELDR_DEBUG_KEY_CODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CODELDR_DEBUG_2_KEY_CODE */
/*  <p>The value here should be one of the BTN_CODE_xxx definitions as found in the buttons.h header   */
/*   file in the CODELDR directory. Note that you cannot use the labels in the config file since the  */
/*   header containing them will not have been included when the config file is read.  */
/*   <p>The default value is equivalent to BTN_CODE_BACKUP and ensures that the Backup key is used to put   */
/*   the IRD into debug mode with the slave CPU running.  */
/*  <p>Setting this value to 0 indicates that this function is not available on the target IRD.  */
/* End of possible values for key CODELDR_DEBUG_2_KEY_CODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CODELDR_DEBUG_3_KEY_CODE */
/*  <p>The value here should be one of the BTN_CODE_xxx definitions as found in the buttons.h header   */
/*   file in the CODELDR directory. Note that you cannot use the labels in the config file since the  */
/*   header containing them will not have been included when the config file is read.  */
/*   <p>The default value is equivalent to BTN_CODE_INFO and ensures that the Info key is used to   */
/*   suppress firmware download to the slave CPU.  */
/*  <p>Setting this value to 0 indicates that this function is not available on the target IRD.  */
/* End of possible values for key CODELDR_DEBUG_3_KEY_CODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) APP_SHOW_STARTUP_SET_DEFAULTS_KEY_CODE */
/*  <p>If this function is not to be made available, set the value to CFG_BUTTON_NONE.   */
/*  <p>WARNING! To ensure correct operation of the PANEL_BUTTONS driver, these codes must be numbered from -1   */
/*  <p> for CFG_BUTTON_NONE then 0 upwards for valid keycodes. Do not leave gaps in the numbering if new  */
/*  <p> values are added.  */
#define CFG_BUTTON_NONE -1
#define CFG_BUTTON_BACKUP 0
#define CFG_BUTTON_GUIDE 1
#define CFG_BUTTON_INFO 2
#define CFG_BUTTON_LEFT 3
#define CFG_BUTTON_RIGHT 4
#define CFG_BUTTON_UP 5
#define CFG_BUTTON_DOWN 6
#define CFG_BUTTON_SELECT 7
#define CFG_BUTTON_POWER 8
#define CFG_BUTTON_ACTIVE 9
#define CFG_BUTTON_FORMAT 10
#define CFG_BUTTON_MENU 11
#define CFG_BUTTON_RESET 12
#define CFG_BUTTON_FUNCTION 13
#define CFG_BUTTON_MODE 14
#define CFG_BUTTON_SYS_INFO 15
#define CFG_BUTTON_HD_SD 16
/* End of possible values for key APP_SHOW_STARTUP_SET_DEFAULTS_KEY_CODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) APP_SHOW_STARTUP_KEY_CODE */
/*  <p>Valid values for this key are as for APP_SHOW_STARTUP_SET_DEFAULTS_KEY_CODE.  */
/*  <p>If this function is not to be made available, set the value to CFG_BUTTON_NONE.  */
/* End of possible values for key APP_SHOW_STARTUP_KEY_CODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) APP_STARTUP_DEFAULTS_KEY_CODE */
/*  <p>Valid values for this key are as for APP_SHOW_STARTUP_SET_DEFAULTS_KEY_CODE.  */
/*  <p>If this function is not to be made available, set the value to CFG_BUTTON_NONE.  */
/* End of possible values for key APP_STARTUP_DEFAULTS_KEY_CODE */
/*******************************************************/

/*   *************************  */
/*   * SCART controller type *  */
/*   *************************  */
/*******************************************************/
/* Possible values for key(s) SCART_CONTROLLER_TYPE */
#define SCART_TYPE_NONE 0
#define SCART_TYPE_TDK_AVPRO_5002B 1
#define SCART_TYPE_SONY_CXA2161R 2
#define SCART_TYPE_ST_STV6412A 3
#define SCART_TYPE_SONY_CXA7002R 4
/* End of possible values for key SCART_CONTROLLER_TYPE */
/*******************************************************/

/*   ********************  */
/*   * NIM GPIO numbers *  */
/*   ********************  */
/*******************************************************/
/* Possible values for key(s) PIO_SINGLE_NIM_HS2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_SINGLE_NIM_HS2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_OREN_NIM_2_LOCK */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_OREN_NIM_2_LOCK */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_OREN_NIM_1_LOCK */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_OREN_NIM_1_LOCK */
/*******************************************************/

/*   **********************************  */
/*   * Generic DEMOD GPIO Definitions *  */
/*   **********************************  */
/*******************************************************/
/* Possible values for key(s) NUMBER_OF_DEMOD_RESETS */
/*  <p>The number of GPIO reset pins connected to device.  Default value is valid  */
/*   for APEX/TRINDVT using the OREN defintions.  */
/* End of possible values for key NUMBER_OF_DEMOD_RESETS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_RESET_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_RESET_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_RESET_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_RESET_2 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_RESET_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_RESET_3 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_RESET_4 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels   */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_RESET_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_RX_1 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_RX_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_RX_2 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_RX_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_RX_3 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_RX_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_RX_4 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_RX_4 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_HIGH_1 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_HIGH_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_LOW_1 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_LOW_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_HIGH_2 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_HIGH_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_LOW_2 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_LOW_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_HIGH_3 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_HIGH_3 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_LOW_3 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_LOW_3 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_HIGH_4 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_HIGH_4 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_DISEQC_LOAD_LOW_4 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_DISEQC_LOAD_LOW_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_1 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_2 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_3 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_4 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_1 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_2 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_3 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_4 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_DEMOD_LNB_HIGHV_ENABLE_5 */
/*  <p> A description of the GPIO using combinations of the GPIO_XXX lables  */
/*  defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DEMOD_LNB_HIGHV_ENABLE_5 */
/*******************************************************/


/*   ***************************************  */
/*   * Smartcard 0/1 Voltage configuration *  */
/*   ***************************************  */

/*******************************************************/
/* Possible values for key(s) PIO_SC0_VOLT_CTRL */
/*  <p> Currently on the ISA GPIO Bank  */
/* End of possible values for key PIO_SC0_VOLT_CTRL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_SC1_VOLT_CTRL */
/*  <p> Currently on the ISA GPIO Bank  */
/* End of possible values for key PIO_SC1_VOLT_CTRL */
/*******************************************************/

/*  smartcard pin for external clock  */
/*******************************************************/
/* Possible values for key(s) PIO_SC0_CLK_DIV1 */
/*  used to define external smartcard clock  */
/* End of possible values for key PIO_SC0_CLK_DIV1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PIO_SC0_CLK_DIV2 */
/*  used to define external smartcard clock  */
/* End of possible values for key PIO_SC0_CLK_DIV2 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) PIO_107_INTCLK2 */
/*  used to define external smartcard clock  */
/* End of possible values for key PIO_107_INTCLK2 */
/*******************************************************/

/*  board revision pin  */

/*******************************************************/
/* Possible values for key(s) BOARD_REV_BIT_0 */
/*  used to define r15 board revision  */
/* End of possible values for key BOARD_REV_BIT_0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BOARD_REV_BIT_1 */
/*  used to define r15 board revision  */
/* End of possible values for key BOARD_REV_BIT_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BOARD_REV_BIT_2 */
/*  used to define r15 board revision  */
/* End of possible values for key BOARD_REV_BIT_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BOARD_REV_BIT_3 */
/*  used to define r15 board revision  */
/* End of possible values for key BOARD_REV_BIT_3 */
/*******************************************************/

/*  Early power failed detection bin  */
/*******************************************************/
/* Possible values for key(s) PIO_EPF */
/*  used to define r15 early power failed  */
/* End of possible values for key PIO_EPF */
/*******************************************************/


/*   ********************  */
/*   * SPI  */
/*   ********************  */
/*******************************************************/
/* Possible values for key(s) SPI_SUPPORT */
/*  <p>Flag to control the SPI support  */
/* End of possible values for key SPI_SUPPORT */
/*******************************************************/

/*   ********************  */
/*   * Front Panel LEDs *  */
/*   ********************  */

/*******************************************************/
/* Possible values for key(s) LEDS_SPI */
/*  <p>Control interface for LEDs on the target IRD.  */
/* End of possible values for key LEDS_SPI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NUMBER_OF_LEDS */
/*  <p>The number of LEDs on the target IRD.  */
/* End of possible values for key NUMBER_OF_LEDS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_POWER */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_POWER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_IR_MSG */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_IR_MSG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_ONLINE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_ONLINE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_ONLINE_MSG */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_ONLINE_MSG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_DOWNSTREAM_MSG */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_DOWNSTREAM_MSG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_UPSTREAM_MSG */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_UPSTREAM_MSG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_HARD_DISK */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_HARD_DISK */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_RECORDING */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_RECORDING */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_NTSC */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_NTSC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_PAL */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_PAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_SECAM */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_SECAM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_480P */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_480P */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_576P */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_576P */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_720P */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_720P */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LED_FORMAT_1080I */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LED_FORMAT_1080I */
/*******************************************************/

/*    */
/*   LNB Control Options   */
/*    */

/*******************************************************/
/* Possible values for key(s) LNB_CTL_TYPE */
#define LNB_CTL_TYPE_NONE 0
#define LNB_CTL_TYPE_LNBH221PD 1
#define LNB_CTL_TYPE_ISL6405 2
#define LNB_CTL_TYPE_DEMOD 3
#define LNB_CTL_TYPE_ISL6422 4
#define LNB_CTL_TYPE_A8290 5
#define LNB_CTL_TYPE_A8286 6
/* End of possible values for key LNB_CTL_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) LNB_22KHZ_CONTROL */
#define LNB_22KHZ_ENABLE 0
#define LNB_22KHZ_TONE 1
#define LNB_22KHZ_NONE 2
/* End of possible values for key LNB_22KHZ_CONTROL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) LNB_TONE_TYPE */
#define LNB_22KHZ_DIGITAL 0
#define LNB_22KHZ_SIGMA_DELTA 1
/* End of possible values for key LNB_TONE_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_ENABLE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_22KHZ_DIRECTION */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_22KHZ_DIRECTION */
/*******************************************************/

/*   ********************************  */
/*   * RF Modulator Options.        *  */
/*   ********************************  */


/*******************************************************/
/* Possible values for key(s) HAS_RFMOD */
/*  <p>Set to YES or NO to indicate whether the box has RF modulator or not.  */
/* End of possible values for key HAS_RFMOD */
/*******************************************************/

/*   RF Modulator antenna switch GPIO pin definitions   */
/*******************************************************/
/* Possible values for key(s) PIO_RFMOD_ANTENNA_SWITCH_ENABLE */
/*  <p>The default value is set for TrinityDVT and Apex reference IRDs.  */
/* End of possible values for key PIO_RFMOD_ANTENNA_SWITCH_ENABLE */
/*******************************************************/

/*   RF Modulator Antena switch GPIO pin definitions   */
/*******************************************************/
/* Possible values for key(s) PIO_RFMOD_3_4_SELECT_SWITCH */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/*   By default, this switch is assumed not to exist.  */
/* End of possible values for key PIO_RFMOD_3_4_SELECT_SWITCH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_8VSB_TUNER_SEL0 */
/*  <p>PIN to decide if RF modulator is Philips or not  */
/* End of possible values for key PIO_8VSB_TUNER_SEL0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_8VSB_TUNER_SEL1 */
/*  <p>PIN to decide if RF modulator is Philips or not  */
/* End of possible values for key PIO_8VSB_TUNER_SEL1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_RF_SW_CTL */
/*  <p>PIN to decide if 3-4 channel RF modulator or loop through analog signal  */
/* End of possible values for key PIO_RF_SW_CTL */
/*******************************************************/

/*   ***************  */
/*   * PCI IO Mode *  */
/*   ***************  */

/*******************************************************/
/* Possible values for key(s) EXTERNAL_PCI_IO_MODE */
/*  <p><i><b>What is this and what values can it take?</b></i>  */
/* End of possible values for key EXTERNAL_PCI_IO_MODE */
/*******************************************************/

/*   *********************************  */
/*   * Transport Stream Switch (TSS) *  */
/*   *********************************  */

/*******************************************************/
/* Possible values for key(s) TSS_0_4_REMAP */
#define TSS_REMAP_OFF 0
#define TSS_REMAP_ON 1
/* End of possible values for key TSS_0_4_REMAP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_1_5_REMAP */
/*  <p>TSS_REMAP_OFF or TSS_REMAP_ON  */
/* End of possible values for key TSS_1_5_REMAP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_2_6_REMAP */
/*  <p>TSS_REMAP_OFF or TSS_REMAP_ON  */
/* End of possible values for key TSS_2_6_REMAP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_3_7_REMAP */
/*  <p>TSS_REMAP_OFF or TSS_REMAP_ON  */
/* End of possible values for key TSS_3_7_REMAP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HS8_REMAP_ENABLE */
/*  <p>TSS_REMAP_OFF or TSS_REMAP_ON  */
/* End of possible values for key TSS_HS8_REMAP_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HS8_REMAP_SELECT */
/*  <p>The universal high speed port number to be replaced (0-7)  */
/* End of possible values for key TSS_HS8_REMAP_SELECT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) TSS_HSDP0_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP0_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP1_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP1_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP2_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP2_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP3_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP3_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP0_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSS driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSS_HSDP0_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP1_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSS driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSS_HSDP1_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP2_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSS driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSS_HSDP2_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP3_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSS driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSS_HSDP3_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP0_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP0_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP1_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP1_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP2_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP2_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_HSDP3_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_HSDP3_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM0_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM0_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM1_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM1_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM2_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM2_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM3_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM3_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM0_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM0_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM1_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM1_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM2_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM2_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_NIM3_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_NIM3_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP0_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP0_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP1_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP1_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP2_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP2_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP3_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP3_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP4_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP4_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP5_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP5_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP6_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP6_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSS_TSP7_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSS_TSP7_PORT_CONFIG */
/*******************************************************/

/*   ******************************************  */
/*   * Transport Stream Crossbar Switch (TSX) *  */
/*   ******************************************  */


/*******************************************************/
/* Possible values for key(s) TSX_HSDP0_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP0_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP1_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP1_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP2_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP2_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP3_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP3_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP4_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP4_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP5_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP5_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP6_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP6_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP7_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP7_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP8_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP8_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP9_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP9_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP0_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP0_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP1_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP1_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP2_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP2_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP3_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP3_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP4_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP4_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP5_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP5_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP6_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP6_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP7_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP7_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP8_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP8_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP9_PACKET_CONFIG */
/*  <p>Bit values taken from chip spec. The TSX driver programs the packet length,  */
/*  threshold, and sync byte dynamically depending upon the operational mode.  */
/* End of possible values for key TSX_HSDP9_PACKET_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP0_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP0_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP1_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP1_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP2_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP2_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP3_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP3_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP4_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP4_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP5_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP5_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP6_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP6_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP7_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP7_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP8_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP8_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_HSDP9_CLOCK_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_HSDP9_CLOCK_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP0_IN_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP0_IN_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP1_IN_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP1_IN_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP2_IN_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP2_IN_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP3_IN_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP3_IN_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP0_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP0_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP1_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP1_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP2_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP2_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP3_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP3_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP4_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP4_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP5_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP5_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP6_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP6_OUT_PORT_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) TSX_TSP7_OUT_PORT_CONFIG */
/*  <p>Bit values taken from chip spec  */
/* End of possible values for key TSX_TSP7_OUT_PORT_CONFIG */
/*******************************************************/


/*   *********************  */
/*   * Crystal Frequency *  */
/*   *********************  */

/*******************************************************/
/* Possible values for key(s) CRYSTAL_FREQUENCY */
/*  <p>This key should be set to the system crystal frequency in hertz.    */
/* End of possible values for key CRYSTAL_FREQUENCY */
/*******************************************************/

/*   *****************  */
/*   * Dial-up modem *  */
/*   *****************  */
/*******************************************************/
/* Possible values for key(s) MODEM_TYPE */
#define INTERNAL_NULL_MODEM 0
#define EXTERNAL_MODEM_16550_UART 1
#define EXTERNAL_MODEM_INTERNAL_UART 2
#define INTERNAL_MODEM_FLIPPER_V22BIS 3
#define INTERNAL_MODEM_CORSICA_V22BIS 4
#define INTERNAL_MODEM_CORSICA_V34 5
#define INTERNAL_MODEM_CORSICA_V90 6
/* End of possible values for key MODEM_TYPE */
/*******************************************************/


/*   Parameters Common to type EXTERNAL_... modems   */
/*******************************************************/
/* Possible values for key(s) EXTERNAL_MODEM_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined  */
/*   at the top of HWCONFIG.CFG.  Default value applies to SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key EXTERNAL_MODEM_RESET */
/*******************************************************/


/*   Parameters for type EXTERNAL_MODEM_16550   */
/*******************************************************/
/* Possible values for key(s) MODEM_DESCRIPTOR */
/*  <p>Valid values are 2-6, Default value applies to SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key MODEM_DESCRIPTOR */
/*******************************************************/

/*   The following parameters are defined in the same way as the CNXT_DESC parameters   */
/*   used for defining and setting up the I/O Descriptors.                              */


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_CHIP_SELECT */
/*  <p>The chip select line to use to access the PATA control registers. Valid  */
/*   values are 1 through 6. Default value applies to SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_CHIP_SELECT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_SYNC_IO */
/*  <p>The I/O mode to use to access the external modem device. Valid values  */
/*   are SYNCHRONOUS or ASYNCHRONOUS. Default value applies to SPEAK/SCXV.xx  */
/*   on APEX.  */
/*  <p>ASYNCHRONOUS   (0)<br>  */
/*  SYNCHRONOUS    (1)  */
/* End of possible values for key CNXT_DESC_MODEM_SYNC_IO */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_XOE */
/*  <p>The transceiver output enable setting to use to access the device using  */
/*   the chip select programmed for descriptor 3. Valid values are YES and  */
/*   NO. Default value applies to SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_XOE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_EXT_WAIT */
/*  <p>The external wait state setting to use to access the device using  */
/*   descriptor 3. Valid values are IO_NO_WAIT, IO_WAIT_FOR_0, and  */
/*   IO_WAIT_FOR_1. Default value applies to SPEAK/SCXV.xx on APEX.  */
/*  <p>IO_NO_WAIT    (0)<br>  */
/*  IO_WAIT_FOR_0 (2)<br>  */
/*  IO_WAIT_FOR_1 (3)  */
/* End of possible values for key CNXT_DESC_MODEM_EXT_WAIT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_IO_ACCESS */
/*  <p>The type of access to use to access the device using descriptor 3. Valid  */
/*   values are YES, indicating an I/O access, and NO, indicating a memory  */
/*   access. Default value applies to SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_IO_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_IO_REG_MODE */
/*  <p>The I/O register mode to use to access the device using descriptor 3. Valid  */
/*   values are IO_REG_OFF, IO_REG_PCCARD, and IO_REG_PROGRAMMABLE. Default  */
/*   value applies to SPEAK/SCXV.xx on APEX.  */
/*  <p>IO_REG_OFF          (0)<br>  */
/*  IO_REG_PCCARD       (1)<br>  */
/*  IO_REG_PROGRAMMABLE (2)  */
/* End of possible values for key CNXT_DESC_MODEM_IO_REG_MODE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_WRITE_ACCESS */
/*  <p>The write access time to use to access the device using descriptor 3.  */
/*   Values are supplied in nanoseconds. Default value applies to SPEAK/SCXV.xx  */
/*   on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_WRITE_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_READ_ACCESS */
/*  <p>The read access time to use to access the device using descriptor 3.  */
/*   Values are supplied in nanoseconds. Default value applies to SPEAK/SCXV.xx  */
/*   on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_READ_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_IO_REG_SETUP */
/*  <p>The I/O register setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_IO_REG_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_IO_REG_ACCESS */
/*  <p>The I/O register access time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_IO_REG_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_CS_SETUP */
/*  <p>The chip select setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_CS_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_CS_HOLD */
/*  <p>The chip select hold time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_CS_HOLD */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_CONTROL_SETUP */
/*  <p>The control signal setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_CONTROL_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_MODEM_CONTROL_HOLD */
/*  <p>The control signal hold time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   SPEAK/SCXV.xx on APEX.  */
/* End of possible values for key CNXT_DESC_MODEM_CONTROL_HOLD */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MODEM_INTERRUPT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key MODEM_INTERRUPT */
/*******************************************************/



/*   Parameters for type EXTERNAL_MODEM_UART   */
/*******************************************************/
/* Possible values for key(s) MODEM_PORT */
/*  <p>Any of the INTERNAL_UARTs is valid for this parameter.  The default  */
/*   value is NOT_DETERMINED, and is applicable to the APEX platform.  */
/* End of possible values for key MODEM_PORT */
/*******************************************************/



/*   Parameters common to Internal (i.e. SOFTMODEM) modem types   */

/*******************************************************/
/* Possible values for key(s) MODEM_DAA_PLL_SELECT */
/*  <p>One of 4 possible values can be selected for this parameter.  A value of  */
/*   NOT_DETERMINED indicates that the modem driver (or host function) is NOT  */
/*   to make any changes to the existing configuration ... it is assumed that the  */
/*   PLLs are setup correctly.  */
#define MODEM_DAA_PLL_MPG0 0
#define MODEM_DAA_PLL_MEM 1
#define MODEM_DAA_PLL_ARM 2
#define MODEM_DAA_PLL_USB 3
/* End of possible values for key MODEM_DAA_PLL_SELECT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MODEM_DAA_PLL_VCO_VALUE */
/*  <p>This value can be any legitimate PLL value, but must be an integer multiple  */
/*   of 4.032 MHz or 4.096 MHz.  It is also subject to the requirement that it can  */
/*   be properly divided down by the two-stage divider for the DAACLK.  */
/* End of possible values for key MODEM_DAA_PLL_VCO_VALUE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MODEM_DAA_PLL_DIVIDER */
/*  <p>This value must be programmed in conjuction with the MODEM_DAA_PLL_VCO_VALUE  */
/*   in order to obtain a proper DAACLK.  For the default value of 229,376,000 Hz  */
/*   a DIVIDER value of 0x7722 will result in a DAA High Clock of 16,384,000 Hz.  */
/*   The DAACLK will be 4,096,000 Hz.  */
/* End of possible values for key MODEM_DAA_PLL_DIVIDER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MODEM_DAACLK_IS_4096 */
/*  <p>TRUE and FALSE are the acceptable parameters.  */
/* End of possible values for key MODEM_DAACLK_IS_4096 */
/*******************************************************/

/*   ********************************  */
/*   * Smart card hardware settings *  */
/*   ********************************  */
/*******************************************************/
/* Possible values for key(s) SMC_SLOT0 */
#define SMC_CONTROLLER0 0
#define SMC_CONTROLLER1 1
#define SMC_CONTROLLER2 2
#define SMC_NONE -1
/* End of possible values for key SMC_SLOT0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SMC_SLOT1 */
/*  <p>Slot 1 defaults to controller 1 (uses definitions from SMC_SLOT0)  */
/* End of possible values for key SMC_SLOT1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SMC_SLOT2 */
/*  <p>Slot 2 defaults to not used (uses definitions from SMC_SLOT0)  */
/* End of possible values for key SMC_SLOT2 */
/*******************************************************/

/*   ********************************************  */
/*   * The number of smart card slots supported *  */
/*   ********************************************  */
/*******************************************************/
/* Possible values for key(s) SMC_NUM_SLOTS */
/*  <p> There're three slots for smart card on Trinity. Default is 2  */
/* End of possible values for key SMC_NUM_SLOTS */
/*******************************************************/

/*   ********************************************  */
/*   * Smartcard hardware flow control support  *  */
/*   ********************************************  */
/*******************************************************/
/* Possible values for key(s) SMC_SUPPORT_FLOW_CONTROL */
/*  <p>Valid values are YES and NO. By default, it is assumed that the Trinity does not support flow control.  */
/* End of possible values for key SMC_SUPPORT_FLOW_CONTROL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SMC_R15_SET_UP */
/*  <p>Valid values are YES and NO. By default,assumed not r15 box   */
/* End of possible values for key SMC_R15_SET_UP */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SMC_EXT_CLOCK */
/*  <p>Valid values are YES and NO. By default,assumed not r15 box   */
/* End of possible values for key SMC_EXT_CLOCK */
/*******************************************************/

/*   ********************************************  */
/*   * Smartcard start clock                    *  */
/*   ********************************************  */
/*******************************************************/
/* Possible values for key(s) SMC_START_CLOCK */
#define SMC_START_CLOCK_AFTER_ACTIVATION 0
#define SMC_START_CLOCK_AFTER_DETECTION 1
#define SMC_START_CLOCK_WHEN_UNIT_OPENED 2
/* End of possible values for key SMC_START_CLOCK */
/*******************************************************/

/*   ********************************************  */
/*   * Smartcard Open Drain/CMOS support        *  */
/*   ********************************************  */
/*******************************************************/
/* Possible values for key(s) SMC_CONFIG_OPENDRAIN_CMOS */
#define SMC_CONFIG_OPEN_DRAIN 0
#define SMC_CONFIG_CMOS 1
/* End of possible values for key SMC_CONFIG_OPENDRAIN_CMOS */
/*******************************************************/


/*   **********************************  */
/*   * Chip revision and test options *  */
/*   **********************************  */
/*******************************************************/
/* Possible values for key(s) CHIP_REV */
#define REV_A_TRINITY 0
#define REV_B_TRINITY 1
#define REV_B2_TRINITY 2
#define REV_B1_TRINITY 3
#define REV_C_TRINITY 4
#define REV_C1_TRINITY 6
#define REV_C2_TRINITY 7
#define REV_D_TRINITY 7
#define REV_A_PECOS 0x00
#define REV_A_NEVIS 0x00
#define REV_B_PECOS 0x10
#define REV_B_NEVIS 0x10
#define REV_C_NEVIS 0x20
#define REV_A_RIDGE 0x20
#define REV_D_NEVIS 0x30
/* End of possible values for key CHIP_REV */
/*******************************************************/

/*   ********************  */
/*   * I2C Bus Settings *  */
/*   ********************  */

/*******************************************************/
/* Possible values for key(s) I2C_BUS_0_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_0_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_0_SPEED */
#define I2C_SPEED_100KHZ 0
#define I2C_SPEED_400KHZ 1
/* End of possible values for key I2C_BUS_0_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_1_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_1_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_1_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_1_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_2_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_2_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_2_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_2_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_3_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_3_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_3_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_3_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_4_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_4_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_4_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_4_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_5_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_5_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_3_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_3_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_6_STATUS */
/*  <p>Valid values are PRESENT or NOT_PRESENT.  */
/* End of possible values for key I2C_BUS_6_STATUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_6_SPEED */
/*  <p>Valid values are as for I2C_BUS_0_SPEED.  */
/* End of possible values for key I2C_BUS_6_SPEED */
/*******************************************************/

/*   *******************************************  */
/*   * Device I2C Addresses and Bus Connection *  */
/*   *******************************************  */


/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24114_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24114_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24114_1 */
#define I2C_BUS_NONE 0
#define I2C_BUS_0 1
#define I2C_BUS_1 2
#define I2C_BUS_2 3
#define I2C_BUS_3 4
#define I2C_BUS_4 5
#define I2C_BUS_5 6
#define I2C_BUS_6 7
/* End of possible values for key I2C_BUS_CX24114_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24114_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24114_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24114_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24114_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24114_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24114_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24114_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24114_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24114_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24114_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24114_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24114_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24114_3 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24114_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24114_3 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24114_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24114_3 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24114_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24114_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24114_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24127 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24127 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24127 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24127 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24127_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24127_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24127_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24127_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24127_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24127_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24127_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24127_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24127_3 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24127_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24127_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24127_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24122 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24122 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24122 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24122 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24122_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24122_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24122_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24122_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24122_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24122_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24122_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24122_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24117 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24117 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24117 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24117 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24117_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24117_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24117_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24117_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24117_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24117_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24117_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24117_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24125 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24125 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24125 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24125 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24125_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24125_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24125_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24125_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24125_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24125_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24125_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24125_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24125_3 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24125_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24125_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24125_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24120 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24120 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24120 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24120 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24120 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24120 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24120 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24120 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) STINGER_TUNER_CONFIG */
/*  <p>Tuner connection type , feeding a Stinger demod chip.  */
#define ALL_DEMOD_SINGLE_TUNER 0
#define DEMOD0_DEMOD2_DUAL_TUNER 1
#define DEMOD0_DEMOD1_DUAL_TUNER 2
#define DEMOD1_DEMOD2_DUAL_TUNER 3
/* End of possible values for key STINGER_TUNER_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SKYHAWK_BOARD_TYPE */
/*  <p>Type of skyhawk stinger NIM.  */
#define SKYHAWK_BOARD_TYPE_SKYHAWK 0
#define SKYHAWK_BOARD_TYPE_SKYHAWK_LITE 1
#define SKYHAWK_BOARD_TYPE_MESO 2
/* End of possible values for key SKYHAWK_BOARD_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24205 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24205 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24205 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24205 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24205 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24205 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24205_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24205_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24205_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24205_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24200 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24200 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24200 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24200 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24200 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24200 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24200_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24200_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24200_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24200_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24201 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24201 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24201 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24201 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24201 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24201 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24201_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24201_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24201_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24201_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24202 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24202 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24202 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24202 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24202 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24202 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24202_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24202_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24202_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24202_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24203 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24203 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24203 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24203 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24203 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24203 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24203_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24203_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24203_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24203_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24204 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24204 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24204 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24204 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24204 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24204 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24204_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24204_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24204_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24204_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24210 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24210 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24210 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24210 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24210 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24210 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24210_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24210_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24210_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24210_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX22702_TUNER_TYPE */
/*  <p>Tuner type on the digital terrestrial NIM (if fitted), feeding a CX22702 demod chip.  */
#define TTT_THOMSON_7575_TUNER 0
#define TTT_ALPS_TDLB7_TUNER 1
#define TTT_THOMSON_7580_TUNER 2
#define TTT_THOMSON_7579_TUNER 3
/* End of possible values for key CX22702_TUNER_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX22702_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702_TUNER_DEVICE_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX22702_TUNER_DEVICE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX22702_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX22702_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX22702_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX22702_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX22702_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702_TUNER_DEVICE_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX22702_TUNER_DEVICE_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX22702_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX22702_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX22702_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX22702_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24230_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24230_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24230_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24230_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24230_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24230_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24230_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24230_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24230_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24230_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24230_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24230_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24130_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24130_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24130_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24130_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24130_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24130_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24130_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24130_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24130_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24130_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24130_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24130_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24130_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24130_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24130_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24130_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24130_3 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24130_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24130_3 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24130_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24130_3 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24130_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24130_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24130_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24130_4 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24130_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24130_4 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24130_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24130_4 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24130_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24130_4 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24130_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MAX_NO_CX24130_UNITS */
/*  <p>Defines the number of CX24130 units we can possibly have in the box.  */
/* End of possible values for key MAX_NO_CX24130_UNITS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24123_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24123_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24123_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24123_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24123_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24123_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24123_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24123_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24123_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24123_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24123_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24123_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24123_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24123_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24123_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24123_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24123_3 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24123_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24123_3 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24123_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24123_3 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24123_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24123_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24123_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24123_4 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24123_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24123_4 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24123_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24123_4 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24123_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24123_4 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24123_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MAX_NO_CX24123_UNITS */
/*  <p>Defines the number of CX24123 units we can possibly have in the box.  */
/* End of possible values for key MAX_NO_CX24123_UNITS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FORCE_QPSK_DEMOD_POLLING */
/*   <p>Valid values are YES and NO.  */
/* End of possible values for key FORCE_QPSK_DEMOD_POLLING */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) QPSK_DEMOD_RSCNTL1_OUTPUT */
#define QPSK_INACTIVE 0
#define QPSK_FAIL 1
#define QPSK_VALID 2
#define QPSK_START 3
/* End of possible values for key QPSK_DEMOD_RSCNTL1_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) QPSK_DEMOD_RSCNTL2_OUTPUT */
/*  <p>Valid values are as for QPSK_DEMOD_RSCNTL1_OUTPUT.  */
/* End of possible values for key QPSK_DEMOD_RSCNTL2_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) QPSK_DEMOD_RSCNTL3_OUTPUT */
/*  <p>Valid values are as for QPSK_DEMOD_RSCNTL1_OUTPUT.  */
/* End of possible values for key QPSK_DEMOD_RSCNTL3_OUTPUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24116_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  Valid addresses for this device are 0xAA, 0x8A, 0x2A or 0x0A.  */
/* End of possible values for key I2C_ADDR_CX24116_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24116_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24116_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24116_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/*  If not connected, the correct value is NOT_DETERMINED.  */
/* End of possible values for key PHYS_UNIT_CX24116_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24116_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24116_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24116_1_TUNER_NUMBER */
/*  <p>Valid values are 0 to 1 inclusive indicating the tuner  that the unit is   */
/*  connected to.   */
/* End of possible values for key CX24116_1_TUNER_NUMBER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24116_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  Valid addresses for this device are 0xAA, 0x8A, 0x2A or 0x0A.  */
/* End of possible values for key I2C_ADDR_CX24116_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24116_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24116_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24116_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24116_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24116_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24116_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24116_2_TUNER_NUMBER */
/*  <p>Valid values are 0 to 1 inclusive indicating the tuner  that the unit is   */
/*  connected to.   */
/* End of possible values for key CX24116_2_TUNER_NUMBER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24116_3 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  Valid addresses for this device are 0xAA, 0x8A, 0x2A or 0x0A.  */
/* End of possible values for key I2C_ADDR_CX24116_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24116_3 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24116_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24116_3 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24116_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24116_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24116_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24116_4 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  Valid addresses for this device are 0xAA, 0x8A, 0x2A or 0x0A.  */
/* End of possible values for key I2C_ADDR_CX24116_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24116_3_TUNER_NUMBER */
/*  <p>Valid values are 0 to 1 inclusive indicating the tuner  that the unit is   */
/*  connected to.   */
/* End of possible values for key CX24116_3_TUNER_NUMBER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24116_4 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24116_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24116_4 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_CX24116_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24116_4 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24116_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24116_4_TUNER_NUMBER */
/*  <p>Valid values are 0 to 1 inclusive indicating the tuner  that the unit is   */
/*  connected to.   */
/* End of possible values for key CX24116_4_TUNER_NUMBER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MAX_NO_CX24116_UNITS */
/*  <p>Defines the number of CX24116 units we can possibly have in the box.  */
/* End of possible values for key MAX_NO_CX24116_UNITS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_ISL6405_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_ISL6405_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_ISL6405_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_ISL6405_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6405_1A */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_ISL6405_1A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6405_1B */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS6, correct value is 6.  */
/* End of possible values for key PHYS_UNIT_ISL6405_1B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_POWER_ENABLE_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined   */
/*  at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_POWER_ENABLE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_POWER_ENABLE_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined   */
/*  at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_POWER_ENABLE_2 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) I2C_ADDR_ISL6405_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_ISL6405_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_ISL6405_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_ISL6405_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6405_2A */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_ISL6405_2A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6405_2B */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS6, correct value is 6.  */
/* End of possible values for key PHYS_UNIT_ISL6405_2B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_POWER_ENABLE_3 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined   */
/*  at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_POWER_ENABLE_3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_LNB_POWER_ENABLE_4 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined   */
/*  at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_LNB_POWER_ENABLE_4 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NO_OF_ISL6405_CHIPS */
/*  <p>The number of ISL6405 chips present. Note that each chip can control 2 units.  */
/* End of possible values for key NO_OF_ISL6405_CHIPS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_ISL6422_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_ISL6422_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_ISL6422_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_ISL6422_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6422_1A */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_ISL6422_1A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6422_1B */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS6, correct value is 6.  */
/* End of possible values for key PHYS_UNIT_ISL6422_1B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_ISL6422_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_ISL6422_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_ISL6422_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_ISL6422_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6422_2A */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS5, correct value is 5.  */
/* End of possible values for key PHYS_UNIT_ISL6422_2A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NO_OF_ISL6422_CHIPS */
/*  <p>The number of ISL6422 chips present. Note that each chip can control 2 units.  */
/* End of possible values for key NO_OF_ISL6422_CHIPS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_ISL6422_2B */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS6, correct value is 6.  */
/* End of possible values for key PHYS_UNIT_ISL6422_2B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_LNBH221_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_LNBH221_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_LNBH221_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_LNBH221_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_LNBH221_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS4, correct value is 4.  */
/* End of possible values for key PHYS_UNIT_LNBH221_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_LNBH221_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_LNBH221_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_LNBH221_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_LNBH221_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_LNBH221_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS2, correct value is 2.  */
/* End of possible values for key PHYS_UNIT_LNBH221_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_A8290 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_A8290 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_A8290 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_A8290 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_A8290 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS4, correct value is 4.  */
/* End of possible values for key PHYS_UNIT_A8290 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_A8286 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_A8286 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_A8286 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_A8286 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_A8286_1 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS4, correct value is 4.  */
/* End of possible values for key PHYS_UNIT_A8286_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_A8286_2 */
/*  <p>Valid values are 0 to 8 inclusive indicating the NIM input that the unit is   */
/*  connected to. If connected to pin HS4, correct value is 4.  */
/* End of possible values for key PHYS_UNIT_A8286_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) A8286_OUTPUT_VOLTAGE_TYPE */
#define USE_1V_HIGHER 0
#define USE_CORRECT_VALUE 1
/* End of possible values for key A8286_OUTPUT_VOLTAGE_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HM1221_1811 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HM1221_1811 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HM1221_1811 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HM1221_1811 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HM1221_SER */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HM1221_SER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HM1221_SER */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HM1221_SER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HM1221_PAR */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HM1221_PAR */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HM1221_PAR */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HM1221_PAR */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HM1221_SER0 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HM1221_SER0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HM1221_SER0 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HM1221_SER0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HM1221_SER1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HM1221_SER1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HM1221_SER1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HM1221_SER1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_DEMOD_THIRDPARTY_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_DEMOD_THIRDPARTY_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_DEMOD_THIRDPARTY_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_DEMOD_THIRDPARTY_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_DEMOD_THIRDPARTY_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_DEMOD_THIRDPARTY_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_DEMOD_THIRDPARTY_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_DEMOD_THIRDPARTY_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_BT861 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  <p>If the same as the Bt865 address, software will autodetect which encoder is installed.  */
/* End of possible values for key I2C_ADDR_BT861 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_BT861 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_BT861 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_BT865 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/*  <p>If the same as the Bt861 address, software will autodetect which encoder is installed.  */
/* End of possible values for key I2C_ADDR_BT865 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_BT865 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_BT865 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_STV6412A */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_STV6412A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_STV6412A */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_STV6412A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_AVPRO5002B */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_AVPRO5002B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_AVPRO5002B */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_AVPRO5002B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CXA2161R */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CXA2161R */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CXA2161R */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CXA2161R */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_LCD_MATRIX */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_LCD_MATRIX */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_LCD_MATRIX */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_LCD_MATRIX */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_RF_MOD */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_RF_MOD */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_RF_MOD */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_RF_MOD */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_RF_MOD_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_RF_MOD_1 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_RF_MOD_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_RF_MOD_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_RF_MOD_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_RF_MOD_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_BUS_RF_MOD_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_RF_MOD_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_EEPROM1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_EEPROM1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_EEPROM1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_EEPROM1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_EEPROM2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_EEPROM2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_EEPROM2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_EEPROM2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_EEPROM3 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_EEPROM3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_EEPROM3 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_EEPROM3 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_CONFIG_EEPROM_ADDR */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_CONFIG_EEPROM_ADDR */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_CONFIG_EEPROM_BUS */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_CONFIG_EEPROM_BUS */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_GPIO2_EXT */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_GPIO2_EXT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_GPIO2_EXT */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_GPIO2_EXT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_NIM_EXT */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_NIM_EXT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_NIM_EXT */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_NIM_EXT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) I2C_ADDR_EEPROM_MDM */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_EEPROM_MDM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_EEPROM_MDM */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_EEPROM_MDM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_EEPROM_NADA */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_EEPROM_NADA */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_EEPROM_NADA */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_EEPROM_NADA */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_BT829 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_BT829 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_BT829 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_BT829 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_BT835 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_BT835 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_BT835 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_BT835 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX22702 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX22702 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX22702 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX22702_TUNER_DEVICE */
/*  <p>Set to the device address [1-255] if present, otherwise set to   */
/*   NOT_PRESENT. The default is for a Thomson tuner can device.  */
/* End of possible values for key I2C_ADDR_CX22702_TUNER_DEVICE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_SAMSUNG_TUNER */
/*  <p>Set to the device address [1-255] if present, otherwise set to   */
/*   NOT_PRESENT. The default is for a samsung tuner can device.  */
/* End of possible values for key I2C_ADDR_SAMSUNG_TUNER */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24227_DEMOD_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24227_DEMOD_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24227_DEMOD_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24227_DEMOD_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CX24227_DEMOD_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CX24227_DEMOD_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CX24227_DEMOD_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_CX24227_DEMOD_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24227_1 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24227_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_CX24227_2 */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_CX24227_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24227_NIM_1_LOCK */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24227_NIM_1_LOCK */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_CX24227_NIM_2_LOCK */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CX24227_NIM_2_LOCK */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_OREN_51132_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_OREN_51132_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_OREN_51132_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_OREN_51132_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_OREN_51132_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_OREN_51132_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_OREN_51132_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_OREN_51132_2 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) I2C_ADDR_INFINEON_TUA6030_TUNER_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_INFINEON_TUA6030_TUNER_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_INFINEON_TUA6030_TUNER_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_INFINEON_TUA6030_TUNER_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_INFINEON_TUA6030_TUNER_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_INFINEON_TUA6030_TUNER_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_INFINEON_TUA6030_TUNER_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_INFINEON_TUA6030_TUNER_2 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) I2C_ADDR_PHILIPS_TDA9885_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_PHILIPS_TDA9885_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_PHILIPS_TDA9885_1 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_PHILIPS_TDA9885_1 */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) I2C_ADDR_PHILIPS_TDA9885_2 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_PHILIPS_TDA9885_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_PHILIPS_TDA9885_2 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_PHILIPS_TDA9885_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_THOMSON_STV_0297_1 */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_THOMSON_STV_0297_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_THOMSON_STV_0297 */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_THOMSON_STV_0297 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_THOMSON_STV_0297_A */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_THOMSON_STV_0297_A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_THOMSON_STV_0297_B */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_THOMSON_STV_0297_B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_THOMSON_STV_0297_ENABLE */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_THOMSON_STV_0297_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) STV0297_TUNER_TYPE */
#define CTT_THOMSON_TUNER 1
#define CTT_SVA_TUNER 2
#define CTT_XIMEI_TUNER 3
/* End of possible values for key STV0297_TUNER_TYPE */
/*******************************************************/
/*   ***********************  */
/*   * Cable related stuff *  */
/*   ***********************  */

/*******************************************************/
/* Possible values for key(s) CABLE_MODEM */
#define EXTERNAL_CX24951 1
#define EXTERNAL_CX24452 2
/*  NOT_PRESENT  */
/* End of possible values for key CABLE_MODEM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CABLE_MODEM_SDRAM_SIZE */
#define USE_8MB_SDRAM 1
#define USE_16MB_SDRAM 2
#define USE_32MB_SDRAM 3
/* End of possible values for key CABLE_MODEM_SDRAM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CX24452_TUNER_TYPE */
#define CONEXANT_SIDEWINDER 1
#define ANADIGICS_AIT1021 2
/* End of possible values for key CX24452_TUNER_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) HW_SUNBURST_ENABLE */
/*  <p> set to 1 if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key HW_SUNBURST_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_SUNBURST_QAM_A */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_SUNBURST_QAM_A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_SUNBURST_QAM_B */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_SUNBURST_QAM_B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PHYS_UNIT_SUNBURST_QAM_C */
/*  <p>Valid values are 4, 5, 6 or 7 indicating the NIM input that the unit is   */
/*  connected to.  */
/* End of possible values for key PHYS_UNIT_SUNBURST_QAM_C */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_HDMI */
/*  <p>Set to the device address [1-255] if present, otherwise set to NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_HDMI */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_HDMI */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/* End of possible values for key I2C_BUS_HDMI */
/*******************************************************/

/*   ******************************************************************************  */
/*   * Internal Audio DAC Information ... slightly different than the othern        *  */
/*   * CS Audio DACS ... has an I2C interface, and a few control registers        *  */
/*   ******************************************************************************  */

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_INTERNAL_DAC */
/*  <p>Set to the device address [1-255] if present, otherwise set to  */
/*   NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_INTERNAL_DAC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_INTERNAL_DAC */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/*  I2C_BUS_2 (3)  */
/* End of possible values for key I2C_BUS_INTERNAL_DAC */
/*******************************************************/


/*   ******************************************************************************  */
/*   * CS4391 Audio DAC Information ... slightly different than the othern        *  */
/*   * CS Audio DACS ... has an I2C interface, and a few control registers        *  */
/*   ******************************************************************************  */

/*******************************************************/
/* Possible values for key(s) DAC_HAS_EXTERNAL_ATTENUATOR */
/*  <p>Defaults to NOT_PRESENT  */
/* End of possible values for key DAC_HAS_EXTERNAL_ATTENUATOR */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CS4391_A */
/*  <p>Set to the device address [1-255] if present, otherwise set to  */
/*   NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CS4391_A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CS4391_A */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/*  I2C_BUS_2 (3)  */
/* End of possible values for key I2C_BUS_CS4391_A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_RESET_CS4391_A */
/*  <p> GPIO Definition for Reset Pin  */
/* End of possible values for key PIO_RESET_CS4391_A */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_ADDR_CS4391_B */
/*  <p>Set to the device address [1-255] if present, otherwise set to  */
/*   NOT_PRESENT.  */
/* End of possible values for key I2C_ADDR_CS4391_B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) I2C_BUS_CS4391_B */
/*  <p>I2C_BUS_NONE (0)<br>  */
/*  I2C_BUS_0 (1)<br>  */
/*  I2C_BUS_1 (2)  */
/*  I2C_BUS_2 (3)  */
/* End of possible values for key I2C_BUS_CS4391_B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_RESET_CS4391_B */
/*  <p> GPIO Definition for Reset Pin  */
/* End of possible values for key PIO_RESET_CS4391_B */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_A_MODE_CONTROL_1_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_A_MODE_CONTROL_1_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_A_VOLUME_AND_MIXING_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_A_VOLUME_AND_MIXING_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_A_CHANNEL_A_VOLUME_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_A_CHANNEL_A_VOLUME_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_A_CHANNEL_B_VOLUME_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_A_CHANNEL_B_VOLUME_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_A_MODE_CONTROL_2_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_A_MODE_CONTROL_2_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_B_MODE_CONTROL_1_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_B_MODE_CONTROL_1_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_B_VOLUME_AND_MIXING_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_B_VOLUME_AND_MIXING_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_B_CHANNEL_A_VOLUME_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_B_CHANNEL_A_VOLUME_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_B_CHANNEL_B_VOLUME_CONTROL_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_B_CHANNEL_B_VOLUME_CONTROL_REG_DEFAULT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CS4391_B_MODE_CONTROL_2_REG_DEFAULT */
/*  <p> Set Default value to Chip's power-up/reset value  */
/* End of possible values for key CS4391_B_MODE_CONTROL_2_REG_DEFAULT */
/*******************************************************/

/*   ******************************************************************************  */
/*   * ISA Device Chip Select and Descriptor Customisation                        *  */
/*   ******************************************************************************  */


/*   ******************************  */
/*   * Global I/O Timeout Setting *  */
/*   ******************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_IO_WAITSTATE_TIMEOUT */
/*  <p>The number of memory clock cycles to wait before terminating an I/O bus  */
/*   cycle. A setting of 0 could potentially cause a system hang if an I/O  */
/*   device is unresponsive.  */
/* End of possible values for key CNXT_IO_WAITSTATE_TIMEOUT */
/*******************************************************/

/*   **********************************  */
/*   * ROM Descriptor 0 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_ROM_DESC_0_EARLY_OVERRIDE */
/*  <p>The indication of whether startup code is to program ROM descriptor 0  */
/*   before changing PLL settings. The default value is 0, indicating that no  */
/*   override is necessary. Any non-zero value indicates to program the  */
/*   descriptor to that value.  */
/* End of possible values for key CNXT_ROM_DESC_0_EARLY_OVERRIDE */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 2 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_2 */
/*  <p>The indication of whether startup code is to program I/O descriptor 2 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is YES for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_2 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_CHIP_SELECT */
/*  <p>The chip select line to use to access the device using descriptor 2.  */
/*   Valid values are 1 through 6. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_2_CHIP_SELECT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_SYNC_IO */
/*  <p>The I/O mode to use to access the device using descriptor 2. Valid values  */
/*   are SYNCHRONOUS or ASYNCHRONOUS. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
#define ASYNCHRONOUS 0
#define SYNCHRONOUS 1
/* End of possible values for key CNXT_DESC_2_SYNC_IO */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_XOE */
/*  <p>The transceiver output enable setting to use to access the device using  */
/*   the chip select programmed for descriptor 2. Valid values are YES and  */
/*   NO. Default value applies to the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_XOE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_EXT_WAIT */
/*  <p>The external wait state setting to use to access the device using  */
/*   descriptor 2. Valid values are IO_NO_WAIT, IO_WAIT_FOR_0, and  */
/*   IO_WAIT_FOR_1. Default value applies to the TrinityDVT reference IRD.  */
#define IO_NO_WAIT 0
#define IO_WAIT_FOR_0 2
#define IO_WAIT_FOR_1 3
/* End of possible values for key CNXT_DESC_2_EXT_WAIT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_IO_ACCESS */
/*  <p>The type of access to use to access the device using descriptor 2. Valid  */
/*   values are YES, indicating an I/O access, and NO, indicating a memory  */
/*   access. Default value applies to the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_IO_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_IO_REG_MODE */
/*  <p>The I/O register mode to use to access the device using descriptor 2. Valid  */
/*   values are IO_REG_OFF, IO_REG_PCCARD, and IO_REG_PROGRAMMABLE. Default  */
/*   value applies to the TrinityDVT reference IRD.  */
#define IO_REG_OFF 0
#define IO_REG_PCCARD 1
#define IO_REG_PROGRAMMABLE 2
/* End of possible values for key CNXT_DESC_2_IO_REG_MODE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_WRITE_ACCESS */
/*  <p>The write access time to use to access the device using descriptor 2.  */
/*   Values are supplied in nanoseconds. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_2_WRITE_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_READ_ACCESS */
/*  <p>The read access time to use to access the device using descriptor 2.  */
/*   Values are supplied in nanoseconds. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_2_READ_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_IO_REG_SETUP */
/*  <p>The I/O register setup time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_IO_REG_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_IO_REG_ACCESS */
/*  <p>The I/O register access time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_IO_REG_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_CS_SETUP */
/*  <p>The chip select setup time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_CS_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_CS_HOLD */
/*  <p>The chip select hold time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_CS_HOLD */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_CONTROL_SETUP */
/*  <p>The control signal setup time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_CONTROL_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_CONTROL_HOLD */
/*  <p>The control signal hold time to use to access the device using  */
/*   descriptor 2. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_2_CONTROL_HOLD */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_WIDTH */
/*  <p>Data widths can be either 8, 16, or unspecified.  If the ARM generates  */
/*  a word transaction, the bus controller will use the knowledge of the bus   */
/*  width to form a 32 bit word  */
#define DESC_WIDTH_16 2
#define DESC_WIDTH_8 1
#define DESC_WIDTH_UNSPEC 0
/* End of possible values for key CNXT_DESC_2_WIDTH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_DESC_2_INCR */
/*  <p>This field tells the ISA controller how to access the registers on an  */
/*  ISA device.  If increment is 0, the bus controller will perform  */
/*  xaction_size(ARM)/desc_width number of transactions at the address  */
/*  requested by the arm.  If increment is 1, the bus controller will increment  */
/*  the address by one byte for width=8 and by two bytes for width=16  */
/* End of possible values for key CNXT_DESC_2_INCR */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 3 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_3 */
/*  <p>The indication of whether startup code is to program I/O descriptor 3 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is YES for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_3 */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_CHIP_SELECT */
/*  <p>The chip select line to use to access the device using descriptor 3.  */
/*   Valid values are 1 through 6. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_3_CHIP_SELECT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_SYNC_IO */
/*  <p>The I/O mode to use to access the device using descriptor 3. Valid values  */
/*   are SYNCHRONOUS or ASYNCHRONOUS. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/*  <p>ASYNCHRONOUS   (0)<br>  */
/*  SYNCHRONOUS    (1)  */
/* End of possible values for key CNXT_DESC_3_SYNC_IO */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_XOE */
/*  <p>The transceiver output enable setting to use to access the device using  */
/*   the chip select programmed for descriptor 3. Valid values are YES and  */
/*   NO. Default value applies to the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_XOE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_EXT_WAIT */
/*  <p>The external wait state setting to use to access the device using  */
/*   descriptor 3. Valid values are IO_NO_WAIT, IO_WAIT_FOR_0, and  */
/*   IO_WAIT_FOR_1. Default value applies to the TrinityDVT reference IRD.  */
/*  <p>IO_NO_WAIT    (0)<br>  */
/*  IO_WAIT_FOR_0 (2)<br>  */
/*  IO_WAIT_FOR_1 (3)  */
/* End of possible values for key CNXT_DESC_3_EXT_WAIT */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_IO_ACCESS */
/*  <p>The type of access to use to access the device using descriptor 3. Valid  */
/*   values are YES, indicating an I/O access, and NO, indicating a memory  */
/*   access. Default value applies to the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_IO_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_IO_REG_MODE */
/*  <p>The I/O register mode to use to access the device using descriptor 3. Valid  */
/*   values are IO_REG_OFF, IO_REG_PCCARD, and IO_REG_PROGRAMMABLE. Default  */
/*   value applies to the TrinityDVT reference IRD.  */
/*  <p>IO_REG_OFF          (0)<br>  */
/*  IO_REG_PCCARD       (1)<br>  */
/*  IO_REG_PROGRAMMABLE (2)  */
/* End of possible values for key CNXT_DESC_3_IO_REG_MODE */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_WRITE_ACCESS */
/*  <p>The write access time to use to access the device using descriptor 3.  */
/*   Values are supplied in nanoseconds. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_3_WRITE_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_READ_ACCESS */
/*  <p>The read access time to use to access the device using descriptor 3.  */
/*   Values are supplied in nanoseconds. Default value applies to the TrinityDVT  */
/*   reference IRD.  */
/* End of possible values for key CNXT_DESC_3_READ_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_IO_REG_SETUP */
/*  <p>The I/O register setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_IO_REG_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_IO_REG_ACCESS */
/*  <p>The I/O register access time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_IO_REG_ACCESS */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_CS_SETUP */
/*  <p>The chip select setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_CS_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_CS_HOLD */
/*  <p>The chip select hold time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_CS_HOLD */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_CONTROL_SETUP */
/*  <p>The control signal setup time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_CONTROL_SETUP */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_CONTROL_HOLD */
/*  <p>The control signal hold time to use to access the device using  */
/*   descriptor 3. Values are supplied in nanoseconds. Default value applies to  */
/*   the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_DESC_3_CONTROL_HOLD */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_WIDTH */
/*  Default is no unspecified  */
/* End of possible values for key CNXT_DESC_3_WIDTH */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) CNXT_DESC_3_INCR */
/*  Default is no incrementing  */
/* End of possible values for key CNXT_DESC_3_INCR */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 4 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_4 */
/*  <p>The indication of whether startup code is to program I/O descriptor 4 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is NO for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will not be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_4 */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 5 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_5 */
/*  <p>The indication of whether startup code is to program I/O descriptor 5 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is NO for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will not be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_5 */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 6 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_6 */
/*  <p>The indication of whether startup code is to program I/O descriptor 6 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is YES for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_6 */
/*******************************************************/

/*   **********************************  */
/*   * I/O Descriptor 7 Customization *  */
/*   **********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PROGRAM_DESC_7 */
/*  <p>The indication of whether startup code is to program I/O descriptor 7 or  */
/*   whether it will be programmed by the driver that will use it. The default  */
/*   value is NO for the TrinityDVT reference IRD, indicating the descriptor  */
/*   will not be programmed by startup code.  */
/* End of possible values for key CNXT_PROGRAM_DESC_7 */
/*******************************************************/

/*   ********************************  */
/*   * Default I/O Descriptor Usage *  */
/*   ********************************  */

/*******************************************************/
/* Possible values for key(s) CNXT_PATA_DESCRIPTOR */
/*  <p>The default IDE descriptor is 2 for the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_PATA_DESCRIPTOR */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_PATA_CHIP_SELECT */
/*  <p>The chip select line to use to access the PATA control registers. Valid  */
/*   values are 1 through 6. Default value applies to the TrinityDVT reference  */
/*   IRD.  */
/* End of possible values for key CNXT_PATA_CHIP_SELECT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_PIO_EXP_DESCRIPTOR */
/*  <p>The default PIO expander descriptor is 3 for the TrinityDVT reference  */
/*   IRD.  */
/* End of possible values for key CNXT_PIO_EXP_DESCRIPTOR */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) CNXT_PIO_EXP_CHIP_SELECT */
/*  <p>The chip select line to use to access the GPIO expander. Valid values   */
/*   are 1 through 6. Default value applies to the TrinityDVT reference IRD.  */
/* End of possible values for key CNXT_PIO_EXP_CHIP_SELECT */
/*******************************************************/

/*   *********************************************************************************  */
/*   * 1394 Device Customisation                                          *  */
/*   *********************************************************************************  */


/*******************************************************/
/* Possible values for key(s) CNXT_FIREWIRE_LLC_RESET_GPIO */
/*  <p>The GPIO line to use for TI1394 LLC Reset Signal.   */
/* End of possible values for key CNXT_FIREWIRE_LLC_RESET_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_FIREWIRE_ARM_RESET_GPIO */
/*  <p>The GPIO line to use for TI1394 ARM Reset Signal.   */
/* End of possible values for key CNXT_FIREWIRE_ARM_RESET_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FIREWIRE_DRIVER_INCLUDE */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key FIREWIRE_DRIVER_INCLUDE */
/*******************************************************/

/*   *****************************  */
/*   * PATA Device Customisation *  */
/*   *****************************  */


/*******************************************************/
/* Possible values for key(s) ATA_DEVICE */
#define PATA_DEVICE_PRESENT 0
#define SATA_DEVICE_PRESENT 1
#define ATA_DEVICE_NOT_PRESENT 2
/* End of possible values for key ATA_DEVICE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_PATA_IRQ_GPIO */
/*  <p>The GPIO line to use for PATA INTRQ signal.  */
/* End of possible values for key CNXT_PATA_IRQ_GPIO */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) CNXT_PATA_USE_FAST_UDMA */
/*  <p>1 - enables UDMA100 and UDMA133.<br>0 - disables UDMA100 and UDMA133 support.  */
/* End of possible values for key CNXT_PATA_USE_FAST_UDMA */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) CNXT_SATA_PHY_OSC */
/*  <p>AUTO enables clock autodetection.<br>FORCE_60 forces the driver to configure  */
/*   the SATA PHY to use the external 60MHz oscillator.<br>FORCE_74 forces the PHY  */
/*   to use the internal 74.25MHz clock even if an external oscillator is connected.  */
/*   Use this mode if external interference causes misdetections.  */
#define CNXT_SATA_PHY_OSC_AUTO 0
#define CNXT_SATA_PHY_OSC_FORCE_60 60
#define CNXT_SATA_PHY_OSC_FORCE_74 74
/* End of possible values for key CNXT_SATA_PHY_OSC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CNXT_SATA_DISABLE_SLEEP_TO_ACTIVE */
/*  <p>NO - (default) Allows a power management request to wake a drive to ACTIVE  */
/*   from SLEEP.  */
/*  <p>YES - Disables the SLEEP to ACTIVE transition to match with the ATA defined  */
/*   transition diagram.  */
/* End of possible values for key CNXT_SATA_DISABLE_SLEEP_TO_ACTIVE */
/*******************************************************/

/*    */
/*   UART Setup Definitions (GPIO, DMA, etc)   */
/*    */

/*    */
/*******************************************************/
/* Possible values for key(s) PIO_UART1_FLOW_CONTROL_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_FLOW_CONTROL_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART1_FLOW_CONTROL_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_FLOW_CONTROL_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART1_FLOW_READY_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_FLOW_READY_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART1_FLOW_READY_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_FLOW_READY_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART1_RING_INDICATE_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_RING_INDICATE_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART1_CARRIER_DETECT_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART1_CARRIER_DETECT_IN */
/*******************************************************/

/*    */
/*******************************************************/
/* Possible values for key(s) PIO_UART2_FLOW_CONTROL_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_FLOW_CONTROL_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART2_FLOW_CONTROL_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_FLOW_CONTROL_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART2_FLOW_READY_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_FLOW_READY_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART2_FLOW_READY_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_FLOW_READY_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART2_RING_INDICATE_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_RING_INDICATE_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART2_CARRIER_DETECT_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART2_CARRIER_DETECT_IN */
/*******************************************************/


/*    */
/*******************************************************/
/* Possible values for key(s) PIO_UART3_FLOW_CONTROL_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_FLOW_CONTROL_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART3_FLOW_CONTROL_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_FLOW_CONTROL_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART3_FLOW_READY_OUT */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_FLOW_READY_OUT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART3_FLOW_READY_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_FLOW_READY_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART3_RING_INDICATE_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_RING_INDICATE_IN */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_UART3_CARRIER_DETECT_IN */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_UART3_CARRIER_DETECT_IN */
/*******************************************************/


/*   **************************************  */
/*   * Single/Dual Plane Graphics Options *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) GRAPHICS_PLANES */
#define GP_SINGLE 1
#define GP_DUAL 2
/* End of possible values for key GRAPHICS_PLANES */
/*******************************************************/

/*   **************************************  */
/*   * CWP buffer memory size             *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) CWP_SIZE_KBYTES */
#define CWP_NOT_ALLOCATED 0
#define CWP_SIZE_4K 4
/* End of possible values for key CWP_SIZE_KBYTES */
/*******************************************************/

/*   **************************************  */
/*   * CAP buffer memory size             *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) CAP_SIZE_KBYTES */
#define CAP_NOT_ALLOCATED 0
#define CAP_SIZE_4K 4
/* End of possible values for key CAP_SIZE_KBYTES */
/*******************************************************/

/*   **************************************  */
/*   * DP header reset                    *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) PIO_DP_HEADER_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_DP_HEADER_RESET */
/*******************************************************/

/*   **************************************  */
/*   * AV Chip reset                      *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) PIO_AV_CHIP_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_AV_CHIP_RESET */
/*******************************************************/

/*   **************************************  */
/*   * AV Chip connection                 *  */
/*   **************************************  */
/*******************************************************/
/* Possible values for key(s) AV_CHIP_CONNECTION */
/*  <p>A description of how AV chip is connected.  */
#define AV_CHIP_ON_SMC0 0
#define AV_CHIP_ON_SYNC_SERIAL 1
/* End of possible values for key AV_CHIP_CONNECTION */
/*******************************************************/
/*   ********************************  */
/*   * Board-level audio mute GPIOs *  */
/*   ********************************  */

/*******************************************************/
/* Possible values for key(s) PIO_AUDIO_DAC_MUTE_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_AUDIO_DAC_MUTE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_AUDIO_DAC_MUTE_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_AUDIO_DAC_MUTE_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_AUDIO_ANALOG_MUTE_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_AUDIO_ANALOG_MUTE_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_AUDIO_ANALOG_MUTE_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_AUDIO_ANALOG_MUTE_2 */
/*******************************************************/

/*   ****************************  */
/*   * Audio (PCM) Port Options *  */
/*   ****************************  */
/*******************************************************/
/* Possible values for key(s) AUDIO_A_RCA_JACKS_PORT_TYPE */
#define AUDIO_DAC_CS4335 0
#define AUDIO_ADC_CS5333 1
#define AUDIO_SPDIF_OUT 2
#define AUDIO_RF 3
#define AUDIO_HDMI 4
#define AUDIO_DAC_CS4345 5
#define AUDIO_BTSC_OUT 6
#define AUDIO_BTSC_IN 7
#define AUDIO_SPDIF_IN 8
#define AUDIO_DAC_UDA1334 9
#define AUDIO_DAC_CS4391_A 10
#define AUDIO_DAC_CS4391_B 11
#define AUDIO_ADC_CX2584X 12
#define AUDIO_DAC_INTERNAL 13
#define AUDIO_PORT_INVALID 0xFF
/* End of possible values for key AUDIO_A_RCA_JACKS_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_RCA_JACKS_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_RCA_JACKS_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_RCA_JACKS_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_RCA_JACKS_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_ANALOG_TV_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_ANALOG_TV_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_ANALOG_TV_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_ANALOG_TV_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_ANALOG_TV_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_ANALOG_TV_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_OUT_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_SPDIF_OUT_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_OUT_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_SPDIF_OUT_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_OUT_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_SPDIF_OUT_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_SPDIF_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_SPDIF_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_SPDIF_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_SPDIF_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_UHF_MODULATOR_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_UHF_MODULATOR_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_UHF_MODULATOR_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_UHF_MODULATOR_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_UHF_MODULATOR_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_UHF_MODULATOR_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_OUT_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_OUT_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_OUT_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_OUT_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_OUT_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_OUT_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_BTSC_MODULATOR_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_BTSC_MODULATOR_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_VHF_MODULATOR_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_VHF_MODULATOR_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_VHF_MODULATOR_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_VHF_MODULATOR_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_VHF_MODULATOR_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_VHF_MODULATOR_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_HDMI_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_A_HDMI_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_HDMI_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_A_HDMI_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_A_HDMI_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_A_HDMI_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_RCA_JACKS_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_RCA_JACKS_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_RCA_JACKS_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_RCA_JACKS_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_RCA_JACKS_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_RCA_JACKS_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_ANALOG_TV_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_ANALOG_TV_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_ANALOG_TV_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_ANALOG_TV_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_ANALOG_TV_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_ANALOG_TV_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_OUT_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_SPDIF_OUT_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_OUT_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_SPDIF_OUT_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_OUT_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_SPDIF_OUT_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_SPDIF_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_SPDIF_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_SPDIF_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_SPDIF_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_UHF_MODULATOR_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_UHF_MODULATOR_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_UHF_MODULATOR_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_UHF_MODULATOR_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_UHF_MODULATOR_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_UHF_MODULATOR_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_OUT_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_OUT_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_OUT_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_OUT_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_OUT_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_OUT_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_IN_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_IN_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_IN_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_IN_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_BTSC_MODULATOR_IN_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_BTSC_MODULATOR_IN_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_VHF_MODULATOR_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_VHF_MODULATOR_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_VHF_MODULATOR_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_VHF_MODULATOR_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_VHF_MODULATOR_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_VHF_MODULATOR_HEAD_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_HDMI_PORT_TYPE */
/*  <p>AUDIO_PORT_INVALID             (0xFF)  */
/*  <p>AUDIO_DAC_CS4335               (0)  */
/*  <p>AUDIO_ADC_CS5333               (1)  */
/*  <p>AUDIO_SPDIF_OUT                (2)  */
/*  <p>AUDIO_RF_MODULATOR             (3)  */
/*  <p>AUDIO_HDMI                     (4)  */
/*  <p>AUDIO_DAC_CS4345               (5)  */
/*  <p>AUDIO_BTSC_OUT                 (6)  */
/*  <p>AUDIO_BTSC_IN                  (7)  */
/* End of possible values for key AUDIO_B_HDMI_PORT_TYPE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_HDMI_PORT_NUM */
/*  <p>The PCM port # for the chip in use.  */
/* End of possible values for key AUDIO_B_HDMI_PORT_NUM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_B_HDMI_HEAD_NUM */
/*  <p>The head/display # with which this port is associated.  */
/* End of possible values for key AUDIO_B_HDMI_HEAD_NUM */
/*******************************************************/

/*   **************  */
/*   * IR Remote  *  */
/*   **************  */
/*******************************************************/
/* Possible values for key(s) NUMBER_OF_IR_REMOTES */
/*  <p>The max number of IR units.  Three of them are front IR, and three of  */
/*  them are back IR which is used for UHF    */
/* End of possible values for key NUMBER_OF_IR_REMOTES */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_0 */
/*  <p>The unit number of the first front IR   */
/* End of possible values for key FRONT_IR_0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_1 */
/*  <p>The unit number of the second front IR   */
/* End of possible values for key FRONT_IR_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_2 */
/*  <p>The unit number of the third front IR   */
/* End of possible values for key FRONT_IR_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_0 */
/*  <p>The unit number of the first back IR   */
/* End of possible values for key BACK_IR_0 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_1 */
/*  <p>The unit number of the second back IR   */
/* End of possible values for key BACK_IR_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_2 */
/*  <p>The unit number of the third back IR   */
/* End of possible values for key BACK_IR_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_0_GPIO */
/*  <p>GPIO used to flash the front IR 0.   */
/* End of possible values for key FRONT_IR_0_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_1_GPIO */
/*  <p>GPIO used to flash the front IR 1.   */
/* End of possible values for key FRONT_IR_1_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FRONT_IR_2_GPIO */
/*  <p>GPIO used to flash the front IR 2.   */
/* End of possible values for key FRONT_IR_2_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_0_GPIO */
/*  <p>GPIO used to flash the front IR 0.   */
/* End of possible values for key BACK_IR_0_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_1_GPIO */
/*  <p>GPIO used to flash the front IR 1.   */
/* End of possible values for key BACK_IR_1_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BACK_IR_2_GPIO */
/*  <p>GPIO used to flash the front IR 2.   */
/* End of possible values for key BACK_IR_2_GPIO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) IR_FLASH_TIME */
/*  <p>Flash time of IR LED in ms.   */
/* End of possible values for key IR_FLASH_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AVC_ASM_MODE_INTERNAL */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key AVC_ASM_MODE_INTERNAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SEC_SCRAM_KEY_INDEX */
/*  <p> Valid values is YES meaning Tuner4 support is used  */
/*   or NO meaning no Tuner4 support.  */
/* End of possible values for key SEC_SCRAM_KEY_INDEX */
/*******************************************************/

/*    */
/*   DRM Options   */
/*    */
/*******************************************************/
/* Possible values for key(s) DRM_DVO_MODE */
/*  <p>Default value is 10 bits  */
#define DRM_DVO_MODE_10_BITS 0
#define DRM_DVO_MODE_20_BITS 1
/* End of possible values for key DRM_DVO_MODE */
/*******************************************************/

/*    */
/*   MCARD OPTIONS  */
/*    */
/*******************************************************/
/* Possible values for key(s) MCARD_SUPPORT */
/*  <p>Valid values are PRESENT and NOT_PRESENT.  */
/* End of possible values for key MCARD_SUPPORT */
/*******************************************************/

/*    */
/*   HSUART OPTIONS  */
/*    */
/*******************************************************/
/* Possible values for key(s) HSUART_SUPPORT */
/*  <p>Valid values are PRESENT and NOT_PRESENT.  */
/* End of possible values for key HSUART_SUPPORT */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) MCARD_OUTPUT_BASEBAND_DEMOD_UNIT */
/*  <p>Valid values is 2.  */
/*   If not connected,correct value is INVALID_UNIT  */
/* End of possible values for key MCARD_OUTPUT_BASEBAND_DEMOD_UNIT */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MCARD_INPUT_BASEBAND_DEMOD_UNIT */
/*  <p>Valid value is 3.   */
/*   If not connected, the correct value is INVALID_UNIT.  */
/* End of possible values for key MCARD_INPUT_BASEBAND_DEMOD_UNIT */
/*******************************************************/

/*   ********************************************************************  */
/*   * NVMGR INFO( EEPROM device /FLASHDEVICE /ETC..) FOR ALL SUBTYPES  *  */
/*   ********************************************************************  */


/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_I2C_ADDR_EEPROM */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_I2C_ADDR_EEPROM */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_I2C_ADDR_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_I2C_ADDR_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_I2C_ADDR_EEPROM */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_I2C_BUS_EEPROM */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_I2C_BUS_EEPROM */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_I2C_BUS_EEPROM */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_I2C_BUS_EEPROM */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_I2C_BUS_EEPROM */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_I2C_BUS_EEPROM */
/*******************************************************/


/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_PAGE_SIZE */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_PAGE_SIZE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_PAGE_SIZE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_PAGE_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_PAGE_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_PAGE_SIZE */
/*******************************************************/



/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_SETUP_TIME */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_SETUP_TIME */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_SETUP_TIME */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_SETUP_TIME */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_SETUP_TIME */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_SETUP_TIME */
/*******************************************************/



/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_EEPROM_SIZE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_SIZE */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_EEPROM_SIZE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_EEPROM_SIZE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_EEPROM_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_SIZE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_EEPROM_SIZE */
/*******************************************************/



/*******************************************************/
/* Possible values for key(s) NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_SYSTEM_SUBTYPE_CONFIG_INFO_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_HDMI_SUBTYPE_REVOCATION_LIST_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_NETWORK_SUBTYPE_MAC_ADDR_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_NETWORK_SUBTYPE_MAC_ADDR_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_NV_DATA_PIO_EEPROM_WRITE_ENABLE */

/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_NV_DATA_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_CM_SUBTYPE_BPI_INFO_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_CM_SUBTYPE_BPI_INFO_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_DSP_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_AUDIO_APP_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_PVC_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_MALONE_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_VIDEO_IPP_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSP_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_MICROCODE_SUBTYPE_DEMUX_TSR_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/
/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_STARTUP_PARAMS_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_1_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_2_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_PIO_EEPROM_WRITE_ENABLE */
/*  <p>The value NOT_PRESENT is also valid for this key  */
/* End of possible values for key NVMGR_APPLICATION_SUBTYPE_USER_SETTINGS_3_PIO_EEPROM_WRITE_ENABLE */
/*******************************************************/

/*   *********************************  */
/*   * MCARD GIO DEFINITIONS *  */
/*   *********************************  */
/*******************************************************/
/* Possible values for key(s) PIO_MCARD_CD_1 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_CD_1 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MCARD_CD_2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_CD_2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MCARD_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_RESET */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MCARD_VS2 */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_VS2 */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MCARD_MDET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_MDET */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MCARD_VCC */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MCARD_VCC */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) COMPOSITE_DRM0_TO_DRM1_WA */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key COMPOSITE_DRM0_TO_DRM1_WA */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) BYPASS_FILTER_RFMOD_MODE_SEL_VDAC_MODE */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key BYPASS_FILTER_RFMOD_MODE_SEL_VDAC_MODE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) AUDIO_THROUGH_SCART_SWITCH */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key AUDIO_THROUGH_SCART_SWITCH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) CH34_DACJ_RFMOD_USED_FOR_COMPOSITE_VIDEO */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key CH34_DACJ_RFMOD_USED_FOR_COMPOSITE_VIDEO */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) SCART_VIDEOENABLE_ON_IICBUS */
/*  <p>Valid values are YES and NO  */
/* End of possible values for key SCART_VIDEOENABLE_ON_IICBUS */
/*******************************************************/


#define BOARD_TYPE_NONE 0
#define BOARD_TYPE_PRESIDIO 1
#define BOARD_TYPE_NOCONA 2
#define BOARD_TYPE_HR22 3
#define BOARD_TYPE_HR24 4
#define BOARD_TYPE_H24 5

/*******************************************************/
/* Possible values for key(s) BOARD_TYPE */
/*  <p>Valid values are BOARD_TYPE_*  */
/* End of possible values for key BOARD_TYPE */
/*******************************************************/

/*   *********************************  */
/*   * MC Configuration DEFINITIONS  *  */
/*   *********************************  */
/*******************************************************/
/* Possible values for key(s) MC_DEVICE_CONFIG */
/*  <p>Bit 0 is M0 device 0, bit 1 is M0 device 1, bit 2 is M1 device 0, and bit  */
/*  3 is M1 device 1. Valid values are b_0001 through b_1111 (1-15). Zero is not  */
/*  a valid value since that would indicate no RAM in the system. Since Nevis  */
/*  does not use M0 device 1, b_0010 is not a valid value for any Nevis-based  */
/*  hardware. Specific processors that have missing devices will mask out the  */
/*  appropriate bit(s). The default value of b_1111 (0xf) therefore indicates all  */
/*  devices populated for any chip.  */
/* End of possible values for key MC_DEVICE_CONFIG */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_SPEED */
/*  <p>The default value of DDR2_667D reflects standard memory for  */
/*  Presidio/Nocona and friends.  */
#define DDR2_667C 0
#define DDR2_667D 1
#define DDR2_800C 2
#define DDR2_800D 3
#define DDR2_800E 4
/* End of possible values for key MC_SPEED */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC0_WIDTH */
/*  <p>Valid values are 0, 16, 32  */
/* End of possible values for key MC0_WIDTH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC1_WIDTH */
/*  <p>Valid values are 0, 16, 32  */
/* End of possible values for key MC1_WIDTH */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC0_SIZE */
#define DDR2_64Mb 0
#define DDR2_128Mb 1
#define DDR2_256Mb 2
#define DDR2_512Mb 3
#define DDR2_1Gb 4
#define DDR2_2Gb 5
#define DDR2_4Gb 6
/* End of possible values for key MC0_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC1_SIZE */
/*  <p>Allowed values are the same as for MC0_SIZE.  */
/* End of possible values for key MC1_SIZE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_TILE_CFG_REG_VAL */
/*  <p>the default mode is tile mode 56 with device swap enabled for Nevis B and later.  */
/* End of possible values for key MC_TILE_CFG_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) FAST_RAM_CEILING */
/*  <p>Valid values are 0 to indicate that fast memory pools may be placed  */
/*  anywhere in RAM or the address of the memory just after the fast RAM when the  */
/*  memory initialization must consider the cutoff when allocating pools. A value  */
/*  of 0x10000000 will place fast pools in 32-bit memory (M1 bus) for Nocona  */
/*  platforms and will keep the fast pools in the bottom half of memory (M0 bus)  */
/*  for Presidio platforms.  */
/*  The default value is 0.  */
/* End of possible values for key FAST_RAM_CEILING */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CONFIG_METHORD_AUTOSENSE */
/*  <p>Valid values are YES, NO  */
/* End of possible values for key MC_CONFIG_METHORD_AUTOSENSE */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG2_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG2_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM2_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM2_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM3_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM3_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM4_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM4_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_MRS_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_MRS_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS2_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS2_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS3_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS3_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DLL_CTL_CLOCK_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DLL_CTL_CLOCK_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DLL_CTL_SKEW_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DLL_CTL_SKEW_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DLL_CTL_OVERRIDE0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DLL_CTL_OVERRIDE0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DLL_CTL_OVERRIDE1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DLL_CTL_OVERRIDE1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_THRESH0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_THRESH0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_THRESH1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_THRESH1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG3_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG3_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM5_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM5_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM6_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM6_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DRIVE0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DRIVE0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DRIVE1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DRIVE1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DRIVE2_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DRIVE2_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DRIVE3_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DRIVE3_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_DRIVE4_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_DRIVE4_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_O_DELAY_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_O_DELAY_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG0_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG0_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_CFG1_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_CFG1_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM0_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM0_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM1_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM1_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM2_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM2_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM3_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM3_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM4_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM4_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_MRS_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_MRS_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS1_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS1_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS2_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS2_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_EMRS3_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_EMRS3_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM5_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM5_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PARAM6_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PARAM6_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_O_DELAY_M1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_O_DELAY_M1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PLL_CTRL0_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PLL_CTRL0_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PLL_CTRL1_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PLL_CTRL1_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PLL_CTRL2_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PLL_CTRL2_REG_VAL */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) MC_PLL_CTRL3_REG_VAL */
/*  <p>Refer to MC data sheet to decide on the right setting for the register.  */
/* End of possible values for key MC_PLL_CTRL3_REG_VAL */
/*******************************************************/


/*   *********************************  */
/*   * PIO to drive CORE VDD level   *  */
/*   *********************************  */
/*******************************************************/
/* Possible values for key(s) PIO_CORE_VDD_LEVEL */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_CORE_VDD_LEVEL */
/*******************************************************/

/*   **********************************************  */
/*   * PIO to reset MII0 and MII1 interface       *  */
/*   **********************************************  */
/*******************************************************/
/* Possible values for key(s) PIO_MII0_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MII0_RESET */
/*******************************************************/

/*******************************************************/
/* Possible values for key(s) PIO_MII1_RESET */
/*  <p>A description of the GPIO using combinations of the GPIO_XXX labels defined at the top of HWCONFIG.CFG.  */
/* End of possible values for key PIO_MII1_RESET */
/*******************************************************/

/*    */

/*  This file was generated from hwconfig.cfg on Mon Feb  9 12:13:43 2009  */

#endif /* __BUILD_HWOPTS__ */

/* ************************************************************ */
/* * End of automatically generated configuration header file * */
/* ************************************************************ */
